# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'CustomDomainAssociationCertificateValidationRecord',
    'ObservabilityConfigurationTraceConfiguration',
    'ServiceEncryptionConfiguration',
    'ServiceHealthCheckConfiguration',
    'ServiceInstanceConfiguration',
    'ServiceNetworkConfiguration',
    'ServiceNetworkConfigurationEgressConfiguration',
    'ServiceNetworkConfigurationIngressConfiguration',
    'ServiceObservabilityConfiguration',
    'ServiceSourceConfiguration',
    'ServiceSourceConfigurationAuthenticationConfiguration',
    'ServiceSourceConfigurationCodeRepository',
    'ServiceSourceConfigurationCodeRepositoryCodeConfiguration',
    'ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues',
    'ServiceSourceConfigurationCodeRepositorySourceCodeVersion',
    'ServiceSourceConfigurationImageRepository',
    'ServiceSourceConfigurationImageRepositoryImageConfiguration',
    'VpcIngressConnectionIngressVpcConfiguration',
]

@pulumi.output_type
class CustomDomainAssociationCertificateValidationRecord(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None,
                 status: Optional[str] = None,
                 type: Optional[str] = None,
                 value: Optional[str] = None):
        """
        :param str name: Certificate CNAME record name.
        :param str status: Current state of the certificate CNAME record validation. It should change to `SUCCESS` after App Runner completes validation with your DNS.
        :param str type: Record type, always `CNAME`.
        :param str value: Certificate CNAME record value.
        """
        CustomDomainAssociationCertificateValidationRecord._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            status=status,
            type=type,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             status: Optional[str] = None,
             type: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if name is not None:
            _setter("name", name)
        if status is not None:
            _setter("status", status)
        if type is not None:
            _setter("type", type)
        if value is not None:
            _setter("value", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Certificate CNAME record name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Current state of the certificate CNAME record validation. It should change to `SUCCESS` after App Runner completes validation with your DNS.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Record type, always `CNAME`.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        """
        Certificate CNAME record value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ObservabilityConfigurationTraceConfiguration(dict):
    def __init__(__self__, *,
                 vendor: Optional[str] = None):
        """
        :param str vendor: Implementation provider chosen for tracing App Runner services. Valid values: `AWSXRAY`.
        """
        ObservabilityConfigurationTraceConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            vendor=vendor,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             vendor: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if vendor is not None:
            _setter("vendor", vendor)

    @property
    @pulumi.getter
    def vendor(self) -> Optional[str]:
        """
        Implementation provider chosen for tracing App Runner services. Valid values: `AWSXRAY`.
        """
        return pulumi.get(self, "vendor")


@pulumi.output_type
class ServiceEncryptionConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "kmsKey":
            suggest = "kms_key"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceEncryptionConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceEncryptionConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceEncryptionConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 kms_key: str):
        """
        :param str kms_key: ARN of the KMS key used for encryption.
        """
        ServiceEncryptionConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            kms_key=kms_key,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             kms_key: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if kms_key is None and 'kmsKey' in kwargs:
            kms_key = kwargs['kmsKey']
        if kms_key is None:
            raise TypeError("Missing 'kms_key' argument")

        _setter("kms_key", kms_key)

    @property
    @pulumi.getter(name="kmsKey")
    def kms_key(self) -> str:
        """
        ARN of the KMS key used for encryption.
        """
        return pulumi.get(self, "kms_key")


@pulumi.output_type
class ServiceHealthCheckConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "healthyThreshold":
            suggest = "healthy_threshold"
        elif key == "unhealthyThreshold":
            suggest = "unhealthy_threshold"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceHealthCheckConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceHealthCheckConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceHealthCheckConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 healthy_threshold: Optional[int] = None,
                 interval: Optional[int] = None,
                 path: Optional[str] = None,
                 protocol: Optional[str] = None,
                 timeout: Optional[int] = None,
                 unhealthy_threshold: Optional[int] = None):
        """
        :param int healthy_threshold: Number of consecutive checks that must succeed before App Runner decides that the service is healthy. Defaults to 1. Minimum value of 1. Maximum value of 20.
        :param int interval: Time interval, in seconds, between health checks. Defaults to 5. Minimum value of 1. Maximum value of 20.
        :param str path: URL to send requests to for health checks. Defaults to `/`. Minimum length of 0. Maximum length of 51200.
        :param str protocol: IP protocol that App Runner uses to perform health checks for your service. Valid values: `TCP`, `HTTP`. Defaults to `TCP`. If you set protocol to `HTTP`, App Runner sends health check requests to the HTTP path specified by `path`.
        :param int timeout: Time, in seconds, to wait for a health check response before deciding it failed. Defaults to 2. Minimum value of  1. Maximum value of 20.
        :param int unhealthy_threshold: Number of consecutive checks that must fail before App Runner decides that the service is unhealthy. Defaults to 5. Minimum value of  1. Maximum value of 20.
        """
        ServiceHealthCheckConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            healthy_threshold=healthy_threshold,
            interval=interval,
            path=path,
            protocol=protocol,
            timeout=timeout,
            unhealthy_threshold=unhealthy_threshold,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             healthy_threshold: Optional[int] = None,
             interval: Optional[int] = None,
             path: Optional[str] = None,
             protocol: Optional[str] = None,
             timeout: Optional[int] = None,
             unhealthy_threshold: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if healthy_threshold is None and 'healthyThreshold' in kwargs:
            healthy_threshold = kwargs['healthyThreshold']
        if unhealthy_threshold is None and 'unhealthyThreshold' in kwargs:
            unhealthy_threshold = kwargs['unhealthyThreshold']

        if healthy_threshold is not None:
            _setter("healthy_threshold", healthy_threshold)
        if interval is not None:
            _setter("interval", interval)
        if path is not None:
            _setter("path", path)
        if protocol is not None:
            _setter("protocol", protocol)
        if timeout is not None:
            _setter("timeout", timeout)
        if unhealthy_threshold is not None:
            _setter("unhealthy_threshold", unhealthy_threshold)

    @property
    @pulumi.getter(name="healthyThreshold")
    def healthy_threshold(self) -> Optional[int]:
        """
        Number of consecutive checks that must succeed before App Runner decides that the service is healthy. Defaults to 1. Minimum value of 1. Maximum value of 20.
        """
        return pulumi.get(self, "healthy_threshold")

    @property
    @pulumi.getter
    def interval(self) -> Optional[int]:
        """
        Time interval, in seconds, between health checks. Defaults to 5. Minimum value of 1. Maximum value of 20.
        """
        return pulumi.get(self, "interval")

    @property
    @pulumi.getter
    def path(self) -> Optional[str]:
        """
        URL to send requests to for health checks. Defaults to `/`. Minimum length of 0. Maximum length of 51200.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def protocol(self) -> Optional[str]:
        """
        IP protocol that App Runner uses to perform health checks for your service. Valid values: `TCP`, `HTTP`. Defaults to `TCP`. If you set protocol to `HTTP`, App Runner sends health check requests to the HTTP path specified by `path`.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def timeout(self) -> Optional[int]:
        """
        Time, in seconds, to wait for a health check response before deciding it failed. Defaults to 2. Minimum value of  1. Maximum value of 20.
        """
        return pulumi.get(self, "timeout")

    @property
    @pulumi.getter(name="unhealthyThreshold")
    def unhealthy_threshold(self) -> Optional[int]:
        """
        Number of consecutive checks that must fail before App Runner decides that the service is unhealthy. Defaults to 5. Minimum value of  1. Maximum value of 20.
        """
        return pulumi.get(self, "unhealthy_threshold")


@pulumi.output_type
class ServiceInstanceConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "instanceRoleArn":
            suggest = "instance_role_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceInstanceConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceInstanceConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceInstanceConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 cpu: Optional[str] = None,
                 instance_role_arn: Optional[str] = None,
                 memory: Optional[str] = None):
        """
        :param str cpu: Number of CPU units reserved for each instance of your App Runner service represented as a String. Defaults to `1024`. Valid values: `256|512|1024|2048|4096|(0.25|0.5|1|2|4) vCPU`.
        :param str instance_role_arn: ARN of an IAM role that provides permissions to your App Runner service. These are permissions that your code needs when it calls any AWS APIs.
        :param str memory: Amount of memory, in MB or GB, reserved for each instance of your App Runner service. Defaults to `2048`. Valid values: `512|1024|2048|3072|4096|6144|8192|10240|12288|(0.5|1|2|3|4|6|8|10|12) GB`.
        """
        ServiceInstanceConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            cpu=cpu,
            instance_role_arn=instance_role_arn,
            memory=memory,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             cpu: Optional[str] = None,
             instance_role_arn: Optional[str] = None,
             memory: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if instance_role_arn is None and 'instanceRoleArn' in kwargs:
            instance_role_arn = kwargs['instanceRoleArn']

        if cpu is not None:
            _setter("cpu", cpu)
        if instance_role_arn is not None:
            _setter("instance_role_arn", instance_role_arn)
        if memory is not None:
            _setter("memory", memory)

    @property
    @pulumi.getter
    def cpu(self) -> Optional[str]:
        """
        Number of CPU units reserved for each instance of your App Runner service represented as a String. Defaults to `1024`. Valid values: `256|512|1024|2048|4096|(0.25|0.5|1|2|4) vCPU`.
        """
        return pulumi.get(self, "cpu")

    @property
    @pulumi.getter(name="instanceRoleArn")
    def instance_role_arn(self) -> Optional[str]:
        """
        ARN of an IAM role that provides permissions to your App Runner service. These are permissions that your code needs when it calls any AWS APIs.
        """
        return pulumi.get(self, "instance_role_arn")

    @property
    @pulumi.getter
    def memory(self) -> Optional[str]:
        """
        Amount of memory, in MB or GB, reserved for each instance of your App Runner service. Defaults to `2048`. Valid values: `512|1024|2048|3072|4096|6144|8192|10240|12288|(0.5|1|2|3|4|6|8|10|12) GB`.
        """
        return pulumi.get(self, "memory")


@pulumi.output_type
class ServiceNetworkConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "egressConfiguration":
            suggest = "egress_configuration"
        elif key == "ingressConfiguration":
            suggest = "ingress_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceNetworkConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceNetworkConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceNetworkConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 egress_configuration: Optional['outputs.ServiceNetworkConfigurationEgressConfiguration'] = None,
                 ingress_configuration: Optional['outputs.ServiceNetworkConfigurationIngressConfiguration'] = None):
        """
        :param 'ServiceNetworkConfigurationEgressConfigurationArgs' egress_configuration: Network configuration settings for outbound message traffic. See Egress Configuration below for more details.
        :param 'ServiceNetworkConfigurationIngressConfigurationArgs' ingress_configuration: Network configuration settings for inbound network traffic. See Ingress Configuration below for more details.
        """
        ServiceNetworkConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            egress_configuration=egress_configuration,
            ingress_configuration=ingress_configuration,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             egress_configuration: Optional['outputs.ServiceNetworkConfigurationEgressConfiguration'] = None,
             ingress_configuration: Optional['outputs.ServiceNetworkConfigurationIngressConfiguration'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if egress_configuration is None and 'egressConfiguration' in kwargs:
            egress_configuration = kwargs['egressConfiguration']
        if ingress_configuration is None and 'ingressConfiguration' in kwargs:
            ingress_configuration = kwargs['ingressConfiguration']

        if egress_configuration is not None:
            _setter("egress_configuration", egress_configuration)
        if ingress_configuration is not None:
            _setter("ingress_configuration", ingress_configuration)

    @property
    @pulumi.getter(name="egressConfiguration")
    def egress_configuration(self) -> Optional['outputs.ServiceNetworkConfigurationEgressConfiguration']:
        """
        Network configuration settings for outbound message traffic. See Egress Configuration below for more details.
        """
        return pulumi.get(self, "egress_configuration")

    @property
    @pulumi.getter(name="ingressConfiguration")
    def ingress_configuration(self) -> Optional['outputs.ServiceNetworkConfigurationIngressConfiguration']:
        """
        Network configuration settings for inbound network traffic. See Ingress Configuration below for more details.
        """
        return pulumi.get(self, "ingress_configuration")


@pulumi.output_type
class ServiceNetworkConfigurationEgressConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "egressType":
            suggest = "egress_type"
        elif key == "vpcConnectorArn":
            suggest = "vpc_connector_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceNetworkConfigurationEgressConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceNetworkConfigurationEgressConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceNetworkConfigurationEgressConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 egress_type: Optional[str] = None,
                 vpc_connector_arn: Optional[str] = None):
        """
        :param str egress_type: The type of egress configuration. Valid values are: `DEFAULT` and `VPC`.
        :param str vpc_connector_arn: The Amazon Resource Name (ARN) of the App Runner VPC connector that you want to associate with your App Runner service. Only valid when `EgressType = VPC`.
        """
        ServiceNetworkConfigurationEgressConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            egress_type=egress_type,
            vpc_connector_arn=vpc_connector_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             egress_type: Optional[str] = None,
             vpc_connector_arn: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if egress_type is None and 'egressType' in kwargs:
            egress_type = kwargs['egressType']
        if vpc_connector_arn is None and 'vpcConnectorArn' in kwargs:
            vpc_connector_arn = kwargs['vpcConnectorArn']

        if egress_type is not None:
            _setter("egress_type", egress_type)
        if vpc_connector_arn is not None:
            _setter("vpc_connector_arn", vpc_connector_arn)

    @property
    @pulumi.getter(name="egressType")
    def egress_type(self) -> Optional[str]:
        """
        The type of egress configuration. Valid values are: `DEFAULT` and `VPC`.
        """
        return pulumi.get(self, "egress_type")

    @property
    @pulumi.getter(name="vpcConnectorArn")
    def vpc_connector_arn(self) -> Optional[str]:
        """
        The Amazon Resource Name (ARN) of the App Runner VPC connector that you want to associate with your App Runner service. Only valid when `EgressType = VPC`.
        """
        return pulumi.get(self, "vpc_connector_arn")


@pulumi.output_type
class ServiceNetworkConfigurationIngressConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "isPubliclyAccessible":
            suggest = "is_publicly_accessible"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceNetworkConfigurationIngressConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceNetworkConfigurationIngressConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceNetworkConfigurationIngressConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 is_publicly_accessible: Optional[bool] = None):
        """
        :param bool is_publicly_accessible: Specifies whether your App Runner service is publicly accessible. To make the service publicly accessible set it to True. To make the service privately accessible, from only within an Amazon VPC set it to False.
        """
        ServiceNetworkConfigurationIngressConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            is_publicly_accessible=is_publicly_accessible,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             is_publicly_accessible: Optional[bool] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if is_publicly_accessible is None and 'isPubliclyAccessible' in kwargs:
            is_publicly_accessible = kwargs['isPubliclyAccessible']

        if is_publicly_accessible is not None:
            _setter("is_publicly_accessible", is_publicly_accessible)

    @property
    @pulumi.getter(name="isPubliclyAccessible")
    def is_publicly_accessible(self) -> Optional[bool]:
        """
        Specifies whether your App Runner service is publicly accessible. To make the service publicly accessible set it to True. To make the service privately accessible, from only within an Amazon VPC set it to False.
        """
        return pulumi.get(self, "is_publicly_accessible")


@pulumi.output_type
class ServiceObservabilityConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "observabilityEnabled":
            suggest = "observability_enabled"
        elif key == "observabilityConfigurationArn":
            suggest = "observability_configuration_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceObservabilityConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceObservabilityConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceObservabilityConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 observability_enabled: bool,
                 observability_configuration_arn: Optional[str] = None):
        """
        :param bool observability_enabled: When `true`, an observability configuration resource is associated with the service.
        :param str observability_configuration_arn: ARN of the observability configuration that is associated with the service. Specified only when `observability_enabled` is `true`.
        """
        ServiceObservabilityConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            observability_enabled=observability_enabled,
            observability_configuration_arn=observability_configuration_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             observability_enabled: Optional[bool] = None,
             observability_configuration_arn: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if observability_enabled is None and 'observabilityEnabled' in kwargs:
            observability_enabled = kwargs['observabilityEnabled']
        if observability_enabled is None:
            raise TypeError("Missing 'observability_enabled' argument")
        if observability_configuration_arn is None and 'observabilityConfigurationArn' in kwargs:
            observability_configuration_arn = kwargs['observabilityConfigurationArn']

        _setter("observability_enabled", observability_enabled)
        if observability_configuration_arn is not None:
            _setter("observability_configuration_arn", observability_configuration_arn)

    @property
    @pulumi.getter(name="observabilityEnabled")
    def observability_enabled(self) -> bool:
        """
        When `true`, an observability configuration resource is associated with the service.
        """
        return pulumi.get(self, "observability_enabled")

    @property
    @pulumi.getter(name="observabilityConfigurationArn")
    def observability_configuration_arn(self) -> Optional[str]:
        """
        ARN of the observability configuration that is associated with the service. Specified only when `observability_enabled` is `true`.
        """
        return pulumi.get(self, "observability_configuration_arn")


@pulumi.output_type
class ServiceSourceConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "authenticationConfiguration":
            suggest = "authentication_configuration"
        elif key == "autoDeploymentsEnabled":
            suggest = "auto_deployments_enabled"
        elif key == "codeRepository":
            suggest = "code_repository"
        elif key == "imageRepository":
            suggest = "image_repository"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 authentication_configuration: Optional['outputs.ServiceSourceConfigurationAuthenticationConfiguration'] = None,
                 auto_deployments_enabled: Optional[bool] = None,
                 code_repository: Optional['outputs.ServiceSourceConfigurationCodeRepository'] = None,
                 image_repository: Optional['outputs.ServiceSourceConfigurationImageRepository'] = None):
        """
        :param 'ServiceSourceConfigurationAuthenticationConfigurationArgs' authentication_configuration: Describes resources needed to authenticate access to some source repositories. See Authentication Configuration below for more details.
        :param bool auto_deployments_enabled: Whether continuous integration from the source repository is enabled for the App Runner service. If set to `true`, each repository change (source code commit or new image version) starts a deployment. Defaults to `true`.
        :param 'ServiceSourceConfigurationCodeRepositoryArgs' code_repository: Description of a source code repository. See Code Repository below for more details.
        :param 'ServiceSourceConfigurationImageRepositoryArgs' image_repository: Description of a source image repository. See Image Repository below for more details.
        """
        ServiceSourceConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            authentication_configuration=authentication_configuration,
            auto_deployments_enabled=auto_deployments_enabled,
            code_repository=code_repository,
            image_repository=image_repository,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             authentication_configuration: Optional['outputs.ServiceSourceConfigurationAuthenticationConfiguration'] = None,
             auto_deployments_enabled: Optional[bool] = None,
             code_repository: Optional['outputs.ServiceSourceConfigurationCodeRepository'] = None,
             image_repository: Optional['outputs.ServiceSourceConfigurationImageRepository'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if authentication_configuration is None and 'authenticationConfiguration' in kwargs:
            authentication_configuration = kwargs['authenticationConfiguration']
        if auto_deployments_enabled is None and 'autoDeploymentsEnabled' in kwargs:
            auto_deployments_enabled = kwargs['autoDeploymentsEnabled']
        if code_repository is None and 'codeRepository' in kwargs:
            code_repository = kwargs['codeRepository']
        if image_repository is None and 'imageRepository' in kwargs:
            image_repository = kwargs['imageRepository']

        if authentication_configuration is not None:
            _setter("authentication_configuration", authentication_configuration)
        if auto_deployments_enabled is not None:
            _setter("auto_deployments_enabled", auto_deployments_enabled)
        if code_repository is not None:
            _setter("code_repository", code_repository)
        if image_repository is not None:
            _setter("image_repository", image_repository)

    @property
    @pulumi.getter(name="authenticationConfiguration")
    def authentication_configuration(self) -> Optional['outputs.ServiceSourceConfigurationAuthenticationConfiguration']:
        """
        Describes resources needed to authenticate access to some source repositories. See Authentication Configuration below for more details.
        """
        return pulumi.get(self, "authentication_configuration")

    @property
    @pulumi.getter(name="autoDeploymentsEnabled")
    def auto_deployments_enabled(self) -> Optional[bool]:
        """
        Whether continuous integration from the source repository is enabled for the App Runner service. If set to `true`, each repository change (source code commit or new image version) starts a deployment. Defaults to `true`.
        """
        return pulumi.get(self, "auto_deployments_enabled")

    @property
    @pulumi.getter(name="codeRepository")
    def code_repository(self) -> Optional['outputs.ServiceSourceConfigurationCodeRepository']:
        """
        Description of a source code repository. See Code Repository below for more details.
        """
        return pulumi.get(self, "code_repository")

    @property
    @pulumi.getter(name="imageRepository")
    def image_repository(self) -> Optional['outputs.ServiceSourceConfigurationImageRepository']:
        """
        Description of a source image repository. See Image Repository below for more details.
        """
        return pulumi.get(self, "image_repository")


@pulumi.output_type
class ServiceSourceConfigurationAuthenticationConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "accessRoleArn":
            suggest = "access_role_arn"
        elif key == "connectionArn":
            suggest = "connection_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfigurationAuthenticationConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfigurationAuthenticationConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfigurationAuthenticationConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 access_role_arn: Optional[str] = None,
                 connection_arn: Optional[str] = None):
        """
        :param str access_role_arn: ARN of the IAM role that grants the App Runner service access to a source repository. Required for ECR image repositories (but not for ECR Public)
        :param str connection_arn: ARN of the App Runner connection that enables the App Runner service to connect to a source repository. Required for GitHub code repositories.
        """
        ServiceSourceConfigurationAuthenticationConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            access_role_arn=access_role_arn,
            connection_arn=connection_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             access_role_arn: Optional[str] = None,
             connection_arn: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if access_role_arn is None and 'accessRoleArn' in kwargs:
            access_role_arn = kwargs['accessRoleArn']
        if connection_arn is None and 'connectionArn' in kwargs:
            connection_arn = kwargs['connectionArn']

        if access_role_arn is not None:
            _setter("access_role_arn", access_role_arn)
        if connection_arn is not None:
            _setter("connection_arn", connection_arn)

    @property
    @pulumi.getter(name="accessRoleArn")
    def access_role_arn(self) -> Optional[str]:
        """
        ARN of the IAM role that grants the App Runner service access to a source repository. Required for ECR image repositories (but not for ECR Public)
        """
        return pulumi.get(self, "access_role_arn")

    @property
    @pulumi.getter(name="connectionArn")
    def connection_arn(self) -> Optional[str]:
        """
        ARN of the App Runner connection that enables the App Runner service to connect to a source repository. Required for GitHub code repositories.
        """
        return pulumi.get(self, "connection_arn")


@pulumi.output_type
class ServiceSourceConfigurationCodeRepository(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "repositoryUrl":
            suggest = "repository_url"
        elif key == "sourceCodeVersion":
            suggest = "source_code_version"
        elif key == "codeConfiguration":
            suggest = "code_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfigurationCodeRepository. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfigurationCodeRepository.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfigurationCodeRepository.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 repository_url: str,
                 source_code_version: 'outputs.ServiceSourceConfigurationCodeRepositorySourceCodeVersion',
                 code_configuration: Optional['outputs.ServiceSourceConfigurationCodeRepositoryCodeConfiguration'] = None):
        """
        :param str repository_url: Location of the repository that contains the source code.
        :param 'ServiceSourceConfigurationCodeRepositorySourceCodeVersionArgs' source_code_version: Version that should be used within the source code repository. See Source Code Version below for more details.
        :param 'ServiceSourceConfigurationCodeRepositoryCodeConfigurationArgs' code_configuration: Configuration for building and running the service from a source code repository. See Code Configuration below for more details.
        """
        ServiceSourceConfigurationCodeRepository._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            repository_url=repository_url,
            source_code_version=source_code_version,
            code_configuration=code_configuration,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             repository_url: Optional[str] = None,
             source_code_version: Optional['outputs.ServiceSourceConfigurationCodeRepositorySourceCodeVersion'] = None,
             code_configuration: Optional['outputs.ServiceSourceConfigurationCodeRepositoryCodeConfiguration'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if repository_url is None and 'repositoryUrl' in kwargs:
            repository_url = kwargs['repositoryUrl']
        if repository_url is None:
            raise TypeError("Missing 'repository_url' argument")
        if source_code_version is None and 'sourceCodeVersion' in kwargs:
            source_code_version = kwargs['sourceCodeVersion']
        if source_code_version is None:
            raise TypeError("Missing 'source_code_version' argument")
        if code_configuration is None and 'codeConfiguration' in kwargs:
            code_configuration = kwargs['codeConfiguration']

        _setter("repository_url", repository_url)
        _setter("source_code_version", source_code_version)
        if code_configuration is not None:
            _setter("code_configuration", code_configuration)

    @property
    @pulumi.getter(name="repositoryUrl")
    def repository_url(self) -> str:
        """
        Location of the repository that contains the source code.
        """
        return pulumi.get(self, "repository_url")

    @property
    @pulumi.getter(name="sourceCodeVersion")
    def source_code_version(self) -> 'outputs.ServiceSourceConfigurationCodeRepositorySourceCodeVersion':
        """
        Version that should be used within the source code repository. See Source Code Version below for more details.
        """
        return pulumi.get(self, "source_code_version")

    @property
    @pulumi.getter(name="codeConfiguration")
    def code_configuration(self) -> Optional['outputs.ServiceSourceConfigurationCodeRepositoryCodeConfiguration']:
        """
        Configuration for building and running the service from a source code repository. See Code Configuration below for more details.
        """
        return pulumi.get(self, "code_configuration")


@pulumi.output_type
class ServiceSourceConfigurationCodeRepositoryCodeConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "configurationSource":
            suggest = "configuration_source"
        elif key == "codeConfigurationValues":
            suggest = "code_configuration_values"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfigurationCodeRepositoryCodeConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfigurationCodeRepositoryCodeConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfigurationCodeRepositoryCodeConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 configuration_source: str,
                 code_configuration_values: Optional['outputs.ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues'] = None):
        """
        :param str configuration_source: Source of the App Runner configuration. Valid values: `REPOSITORY`, `API`. Values are interpreted as follows:
        :param 'ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValuesArgs' code_configuration_values: Basic configuration for building and running the App Runner service. Use this parameter to quickly launch an App Runner service without providing an apprunner.yaml file in the source code repository (or ignoring the file if it exists). See Code Configuration Values below for more details.
        """
        ServiceSourceConfigurationCodeRepositoryCodeConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            configuration_source=configuration_source,
            code_configuration_values=code_configuration_values,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             configuration_source: Optional[str] = None,
             code_configuration_values: Optional['outputs.ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if configuration_source is None and 'configurationSource' in kwargs:
            configuration_source = kwargs['configurationSource']
        if configuration_source is None:
            raise TypeError("Missing 'configuration_source' argument")
        if code_configuration_values is None and 'codeConfigurationValues' in kwargs:
            code_configuration_values = kwargs['codeConfigurationValues']

        _setter("configuration_source", configuration_source)
        if code_configuration_values is not None:
            _setter("code_configuration_values", code_configuration_values)

    @property
    @pulumi.getter(name="configurationSource")
    def configuration_source(self) -> str:
        """
        Source of the App Runner configuration. Valid values: `REPOSITORY`, `API`. Values are interpreted as follows:
        """
        return pulumi.get(self, "configuration_source")

    @property
    @pulumi.getter(name="codeConfigurationValues")
    def code_configuration_values(self) -> Optional['outputs.ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues']:
        """
        Basic configuration for building and running the App Runner service. Use this parameter to quickly launch an App Runner service without providing an apprunner.yaml file in the source code repository (or ignoring the file if it exists). See Code Configuration Values below for more details.
        """
        return pulumi.get(self, "code_configuration_values")


@pulumi.output_type
class ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "buildCommand":
            suggest = "build_command"
        elif key == "runtimeEnvironmentSecrets":
            suggest = "runtime_environment_secrets"
        elif key == "runtimeEnvironmentVariables":
            suggest = "runtime_environment_variables"
        elif key == "startCommand":
            suggest = "start_command"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 runtime: str,
                 build_command: Optional[str] = None,
                 port: Optional[str] = None,
                 runtime_environment_secrets: Optional[Mapping[str, str]] = None,
                 runtime_environment_variables: Optional[Mapping[str, str]] = None,
                 start_command: Optional[str] = None):
        """
        :param str runtime: Runtime environment type for building and running an App Runner service. Represents a programming language runtime. Valid values: `PYTHON_3`, `NODEJS_12`, `NODEJS_14`, `NODEJS_16`, `CORRETTO_8`, `CORRETTO_11`, `GO_1`, `DOTNET_6`, `PHP_81`, `RUBY_31`.
        :param str build_command: Command App Runner runs to build your application.
        :param str port: Port that your application listens to in the container. Defaults to `"8080"`.
        :param Mapping[str, str] runtime_environment_secrets: Secrets and parameters available to your service as environment variables. A map of key/value pairs, where the key is the desired name of the Secret in the environment (i.e. it does not have to match the name of the secret in Secrets Manager or SSM Parameter Store), and the value is the ARN of the secret from AWS Secrets Manager or the ARN of the parameter in AWS SSM Parameter Store.
        :param Mapping[str, str] runtime_environment_variables: Environment variables available to your running App Runner service. A map of key/value pairs. Keys with a prefix of `AWSAPPRUNNER` are reserved for system use and aren't valid.
        :param str start_command: Command App Runner runs to start your application.
        """
        ServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            runtime=runtime,
            build_command=build_command,
            port=port,
            runtime_environment_secrets=runtime_environment_secrets,
            runtime_environment_variables=runtime_environment_variables,
            start_command=start_command,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             runtime: Optional[str] = None,
             build_command: Optional[str] = None,
             port: Optional[str] = None,
             runtime_environment_secrets: Optional[Mapping[str, str]] = None,
             runtime_environment_variables: Optional[Mapping[str, str]] = None,
             start_command: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if runtime is None:
            raise TypeError("Missing 'runtime' argument")
        if build_command is None and 'buildCommand' in kwargs:
            build_command = kwargs['buildCommand']
        if runtime_environment_secrets is None and 'runtimeEnvironmentSecrets' in kwargs:
            runtime_environment_secrets = kwargs['runtimeEnvironmentSecrets']
        if runtime_environment_variables is None and 'runtimeEnvironmentVariables' in kwargs:
            runtime_environment_variables = kwargs['runtimeEnvironmentVariables']
        if start_command is None and 'startCommand' in kwargs:
            start_command = kwargs['startCommand']

        _setter("runtime", runtime)
        if build_command is not None:
            _setter("build_command", build_command)
        if port is not None:
            _setter("port", port)
        if runtime_environment_secrets is not None:
            _setter("runtime_environment_secrets", runtime_environment_secrets)
        if runtime_environment_variables is not None:
            _setter("runtime_environment_variables", runtime_environment_variables)
        if start_command is not None:
            _setter("start_command", start_command)

    @property
    @pulumi.getter
    def runtime(self) -> str:
        """
        Runtime environment type for building and running an App Runner service. Represents a programming language runtime. Valid values: `PYTHON_3`, `NODEJS_12`, `NODEJS_14`, `NODEJS_16`, `CORRETTO_8`, `CORRETTO_11`, `GO_1`, `DOTNET_6`, `PHP_81`, `RUBY_31`.
        """
        return pulumi.get(self, "runtime")

    @property
    @pulumi.getter(name="buildCommand")
    def build_command(self) -> Optional[str]:
        """
        Command App Runner runs to build your application.
        """
        return pulumi.get(self, "build_command")

    @property
    @pulumi.getter
    def port(self) -> Optional[str]:
        """
        Port that your application listens to in the container. Defaults to `"8080"`.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="runtimeEnvironmentSecrets")
    def runtime_environment_secrets(self) -> Optional[Mapping[str, str]]:
        """
        Secrets and parameters available to your service as environment variables. A map of key/value pairs, where the key is the desired name of the Secret in the environment (i.e. it does not have to match the name of the secret in Secrets Manager or SSM Parameter Store), and the value is the ARN of the secret from AWS Secrets Manager or the ARN of the parameter in AWS SSM Parameter Store.
        """
        return pulumi.get(self, "runtime_environment_secrets")

    @property
    @pulumi.getter(name="runtimeEnvironmentVariables")
    def runtime_environment_variables(self) -> Optional[Mapping[str, str]]:
        """
        Environment variables available to your running App Runner service. A map of key/value pairs. Keys with a prefix of `AWSAPPRUNNER` are reserved for system use and aren't valid.
        """
        return pulumi.get(self, "runtime_environment_variables")

    @property
    @pulumi.getter(name="startCommand")
    def start_command(self) -> Optional[str]:
        """
        Command App Runner runs to start your application.
        """
        return pulumi.get(self, "start_command")


@pulumi.output_type
class ServiceSourceConfigurationCodeRepositorySourceCodeVersion(dict):
    def __init__(__self__, *,
                 type: str,
                 value: str):
        """
        :param str type: Type of version identifier. For a git-based repository, branches represent versions. Valid values: `BRANCH`.
        :param str value: Source code version. For a git-based repository, a branch name maps to a specific version. App Runner uses the most recent commit to the branch.
        """
        ServiceSourceConfigurationCodeRepositorySourceCodeVersion._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            type=type,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             type: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if type is None:
            raise TypeError("Missing 'type' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("type", type)
        _setter("value", value)

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Type of version identifier. For a git-based repository, branches represent versions. Valid values: `BRANCH`.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Source code version. For a git-based repository, a branch name maps to a specific version. App Runner uses the most recent commit to the branch.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ServiceSourceConfigurationImageRepository(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "imageIdentifier":
            suggest = "image_identifier"
        elif key == "imageRepositoryType":
            suggest = "image_repository_type"
        elif key == "imageConfiguration":
            suggest = "image_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfigurationImageRepository. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfigurationImageRepository.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfigurationImageRepository.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 image_identifier: str,
                 image_repository_type: str,
                 image_configuration: Optional['outputs.ServiceSourceConfigurationImageRepositoryImageConfiguration'] = None):
        """
        :param str image_identifier: Identifier of an image. For an image in Amazon Elastic Container Registry (Amazon ECR), this is an image name. For the
               image name format, see Pulling an image in the Amazon ECR User Guide.
        :param str image_repository_type: Type of the image repository. This reflects the repository provider and whether the repository is private or public. Valid values: `ECR` , `ECR_PUBLIC`.
        :param 'ServiceSourceConfigurationImageRepositoryImageConfigurationArgs' image_configuration: Configuration for running the identified image. See Image Configuration below for more details.
        """
        ServiceSourceConfigurationImageRepository._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            image_identifier=image_identifier,
            image_repository_type=image_repository_type,
            image_configuration=image_configuration,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             image_identifier: Optional[str] = None,
             image_repository_type: Optional[str] = None,
             image_configuration: Optional['outputs.ServiceSourceConfigurationImageRepositoryImageConfiguration'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if image_identifier is None and 'imageIdentifier' in kwargs:
            image_identifier = kwargs['imageIdentifier']
        if image_identifier is None:
            raise TypeError("Missing 'image_identifier' argument")
        if image_repository_type is None and 'imageRepositoryType' in kwargs:
            image_repository_type = kwargs['imageRepositoryType']
        if image_repository_type is None:
            raise TypeError("Missing 'image_repository_type' argument")
        if image_configuration is None and 'imageConfiguration' in kwargs:
            image_configuration = kwargs['imageConfiguration']

        _setter("image_identifier", image_identifier)
        _setter("image_repository_type", image_repository_type)
        if image_configuration is not None:
            _setter("image_configuration", image_configuration)

    @property
    @pulumi.getter(name="imageIdentifier")
    def image_identifier(self) -> str:
        """
        Identifier of an image. For an image in Amazon Elastic Container Registry (Amazon ECR), this is an image name. For the
        image name format, see Pulling an image in the Amazon ECR User Guide.
        """
        return pulumi.get(self, "image_identifier")

    @property
    @pulumi.getter(name="imageRepositoryType")
    def image_repository_type(self) -> str:
        """
        Type of the image repository. This reflects the repository provider and whether the repository is private or public. Valid values: `ECR` , `ECR_PUBLIC`.
        """
        return pulumi.get(self, "image_repository_type")

    @property
    @pulumi.getter(name="imageConfiguration")
    def image_configuration(self) -> Optional['outputs.ServiceSourceConfigurationImageRepositoryImageConfiguration']:
        """
        Configuration for running the identified image. See Image Configuration below for more details.
        """
        return pulumi.get(self, "image_configuration")


@pulumi.output_type
class ServiceSourceConfigurationImageRepositoryImageConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "runtimeEnvironmentSecrets":
            suggest = "runtime_environment_secrets"
        elif key == "runtimeEnvironmentVariables":
            suggest = "runtime_environment_variables"
        elif key == "startCommand":
            suggest = "start_command"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceSourceConfigurationImageRepositoryImageConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceSourceConfigurationImageRepositoryImageConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceSourceConfigurationImageRepositoryImageConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 port: Optional[str] = None,
                 runtime_environment_secrets: Optional[Mapping[str, str]] = None,
                 runtime_environment_variables: Optional[Mapping[str, str]] = None,
                 start_command: Optional[str] = None):
        """
        :param str port: Port that your application listens to in the container. Defaults to `"8080"`.
        :param Mapping[str, str] runtime_environment_secrets: Secrets and parameters available to your service as environment variables. A map of key/value pairs, where the key is the desired name of the Secret in the environment (i.e. it does not have to match the name of the secret in Secrets Manager or SSM Parameter Store), and the value is the ARN of the secret from AWS Secrets Manager or the ARN of the parameter in AWS SSM Parameter Store.
        :param Mapping[str, str] runtime_environment_variables: Environment variables available to your running App Runner service. A map of key/value pairs. Keys with a prefix of `AWSAPPRUNNER` are reserved for system use and aren't valid.
        :param str start_command: Command App Runner runs to start the application in the source image. If specified, this command overrides the Docker image’s default start command.
        """
        ServiceSourceConfigurationImageRepositoryImageConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            port=port,
            runtime_environment_secrets=runtime_environment_secrets,
            runtime_environment_variables=runtime_environment_variables,
            start_command=start_command,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             port: Optional[str] = None,
             runtime_environment_secrets: Optional[Mapping[str, str]] = None,
             runtime_environment_variables: Optional[Mapping[str, str]] = None,
             start_command: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if runtime_environment_secrets is None and 'runtimeEnvironmentSecrets' in kwargs:
            runtime_environment_secrets = kwargs['runtimeEnvironmentSecrets']
        if runtime_environment_variables is None and 'runtimeEnvironmentVariables' in kwargs:
            runtime_environment_variables = kwargs['runtimeEnvironmentVariables']
        if start_command is None and 'startCommand' in kwargs:
            start_command = kwargs['startCommand']

        if port is not None:
            _setter("port", port)
        if runtime_environment_secrets is not None:
            _setter("runtime_environment_secrets", runtime_environment_secrets)
        if runtime_environment_variables is not None:
            _setter("runtime_environment_variables", runtime_environment_variables)
        if start_command is not None:
            _setter("start_command", start_command)

    @property
    @pulumi.getter
    def port(self) -> Optional[str]:
        """
        Port that your application listens to in the container. Defaults to `"8080"`.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="runtimeEnvironmentSecrets")
    def runtime_environment_secrets(self) -> Optional[Mapping[str, str]]:
        """
        Secrets and parameters available to your service as environment variables. A map of key/value pairs, where the key is the desired name of the Secret in the environment (i.e. it does not have to match the name of the secret in Secrets Manager or SSM Parameter Store), and the value is the ARN of the secret from AWS Secrets Manager or the ARN of the parameter in AWS SSM Parameter Store.
        """
        return pulumi.get(self, "runtime_environment_secrets")

    @property
    @pulumi.getter(name="runtimeEnvironmentVariables")
    def runtime_environment_variables(self) -> Optional[Mapping[str, str]]:
        """
        Environment variables available to your running App Runner service. A map of key/value pairs. Keys with a prefix of `AWSAPPRUNNER` are reserved for system use and aren't valid.
        """
        return pulumi.get(self, "runtime_environment_variables")

    @property
    @pulumi.getter(name="startCommand")
    def start_command(self) -> Optional[str]:
        """
        Command App Runner runs to start the application in the source image. If specified, this command overrides the Docker image’s default start command.
        """
        return pulumi.get(self, "start_command")


@pulumi.output_type
class VpcIngressConnectionIngressVpcConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "vpcEndpointId":
            suggest = "vpc_endpoint_id"
        elif key == "vpcId":
            suggest = "vpc_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VpcIngressConnectionIngressVpcConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VpcIngressConnectionIngressVpcConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VpcIngressConnectionIngressVpcConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 vpc_endpoint_id: Optional[str] = None,
                 vpc_id: Optional[str] = None):
        """
        :param str vpc_endpoint_id: The ID of the VPC endpoint that your App Runner service connects to.
        :param str vpc_id: The ID of the VPC that is used for the VPC endpoint.
        """
        VpcIngressConnectionIngressVpcConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            vpc_endpoint_id=vpc_endpoint_id,
            vpc_id=vpc_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             vpc_endpoint_id: Optional[str] = None,
             vpc_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if vpc_endpoint_id is None and 'vpcEndpointId' in kwargs:
            vpc_endpoint_id = kwargs['vpcEndpointId']
        if vpc_id is None and 'vpcId' in kwargs:
            vpc_id = kwargs['vpcId']

        if vpc_endpoint_id is not None:
            _setter("vpc_endpoint_id", vpc_endpoint_id)
        if vpc_id is not None:
            _setter("vpc_id", vpc_id)

    @property
    @pulumi.getter(name="vpcEndpointId")
    def vpc_endpoint_id(self) -> Optional[str]:
        """
        The ID of the VPC endpoint that your App Runner service connects to.
        """
        return pulumi.get(self, "vpc_endpoint_id")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[str]:
        """
        The ID of the VPC that is used for the VPC endpoint.
        """
        return pulumi.get(self, "vpc_id")


