# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'AssessmentAssessmentReportsDestination',
    'AssessmentRole',
    'AssessmentRolesAll',
    'AssessmentScope',
    'AssessmentScopeAwsAccount',
    'AssessmentScopeAwsService',
    'ControlControlMappingSource',
    'ControlControlMappingSourceSourceKeyword',
    'FrameworkControlSet',
    'FrameworkControlSetControl',
    'GetControlControlMappingSourceResult',
    'GetControlControlMappingSourceSourceKeywordResult',
    'GetFrameworkControlSetResult',
    'GetFrameworkControlSetControlResult',
]

@pulumi.output_type
class AssessmentAssessmentReportsDestination(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "destinationType":
            suggest = "destination_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AssessmentAssessmentReportsDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AssessmentAssessmentReportsDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AssessmentAssessmentReportsDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 destination: str,
                 destination_type: str):
        """
        :param str destination: Destination of the assessment report. This value be in the form `s3://{bucket_name}`.
        :param str destination_type: Destination type. Currently, `S3` is the only valid value.
        """
        AssessmentAssessmentReportsDestination._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            destination=destination,
            destination_type=destination_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             destination: Optional[str] = None,
             destination_type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if destination is None:
            raise TypeError("Missing 'destination' argument")
        if destination_type is None and 'destinationType' in kwargs:
            destination_type = kwargs['destinationType']
        if destination_type is None:
            raise TypeError("Missing 'destination_type' argument")

        _setter("destination", destination)
        _setter("destination_type", destination_type)

    @property
    @pulumi.getter
    def destination(self) -> str:
        """
        Destination of the assessment report. This value be in the form `s3://{bucket_name}`.
        """
        return pulumi.get(self, "destination")

    @property
    @pulumi.getter(name="destinationType")
    def destination_type(self) -> str:
        """
        Destination type. Currently, `S3` is the only valid value.
        """
        return pulumi.get(self, "destination_type")


@pulumi.output_type
class AssessmentRole(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "roleArn":
            suggest = "role_arn"
        elif key == "roleType":
            suggest = "role_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AssessmentRole. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AssessmentRole.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AssessmentRole.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 role_arn: str,
                 role_type: str):
        """
        :param str role_arn: Amazon Resource Name (ARN) of the IAM role.
        :param str role_type: Type of customer persona. For assessment creation, type must always be `PROCESS_OWNER`.
        """
        AssessmentRole._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            role_arn=role_arn,
            role_type=role_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             role_arn: Optional[str] = None,
             role_type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if role_arn is None and 'roleArn' in kwargs:
            role_arn = kwargs['roleArn']
        if role_arn is None:
            raise TypeError("Missing 'role_arn' argument")
        if role_type is None and 'roleType' in kwargs:
            role_type = kwargs['roleType']
        if role_type is None:
            raise TypeError("Missing 'role_type' argument")

        _setter("role_arn", role_arn)
        _setter("role_type", role_type)

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        """
        Amazon Resource Name (ARN) of the IAM role.
        """
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="roleType")
    def role_type(self) -> str:
        """
        Type of customer persona. For assessment creation, type must always be `PROCESS_OWNER`.
        """
        return pulumi.get(self, "role_type")


@pulumi.output_type
class AssessmentRolesAll(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "roleArn":
            suggest = "role_arn"
        elif key == "roleType":
            suggest = "role_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AssessmentRolesAll. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AssessmentRolesAll.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AssessmentRolesAll.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 role_arn: str,
                 role_type: str):
        """
        :param str role_arn: Amazon Resource Name (ARN) of the IAM role.
        :param str role_type: Type of customer persona. For assessment creation, type must always be `PROCESS_OWNER`.
        """
        AssessmentRolesAll._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            role_arn=role_arn,
            role_type=role_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             role_arn: Optional[str] = None,
             role_type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if role_arn is None and 'roleArn' in kwargs:
            role_arn = kwargs['roleArn']
        if role_arn is None:
            raise TypeError("Missing 'role_arn' argument")
        if role_type is None and 'roleType' in kwargs:
            role_type = kwargs['roleType']
        if role_type is None:
            raise TypeError("Missing 'role_type' argument")

        _setter("role_arn", role_arn)
        _setter("role_type", role_type)

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        """
        Amazon Resource Name (ARN) of the IAM role.
        """
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="roleType")
    def role_type(self) -> str:
        """
        Type of customer persona. For assessment creation, type must always be `PROCESS_OWNER`.
        """
        return pulumi.get(self, "role_type")


@pulumi.output_type
class AssessmentScope(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "awsAccounts":
            suggest = "aws_accounts"
        elif key == "awsServices":
            suggest = "aws_services"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AssessmentScope. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AssessmentScope.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AssessmentScope.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 aws_accounts: Optional[Sequence['outputs.AssessmentScopeAwsAccount']] = None,
                 aws_services: Optional[Sequence['outputs.AssessmentScopeAwsService']] = None):
        """
        :param Sequence['AssessmentScopeAwsAccountArgs'] aws_accounts: Amazon Web Services accounts that are in scope for the assessment. See `aws_accounts` below.
        :param Sequence['AssessmentScopeAwsServiceArgs'] aws_services: Amazon Web Services services that are included in the scope of the assessment. See `aws_services` below.
        """
        AssessmentScope._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            aws_accounts=aws_accounts,
            aws_services=aws_services,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             aws_accounts: Optional[Sequence['outputs.AssessmentScopeAwsAccount']] = None,
             aws_services: Optional[Sequence['outputs.AssessmentScopeAwsService']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if aws_accounts is None and 'awsAccounts' in kwargs:
            aws_accounts = kwargs['awsAccounts']
        if aws_services is None and 'awsServices' in kwargs:
            aws_services = kwargs['awsServices']

        if aws_accounts is not None:
            _setter("aws_accounts", aws_accounts)
        if aws_services is not None:
            _setter("aws_services", aws_services)

    @property
    @pulumi.getter(name="awsAccounts")
    def aws_accounts(self) -> Optional[Sequence['outputs.AssessmentScopeAwsAccount']]:
        """
        Amazon Web Services accounts that are in scope for the assessment. See `aws_accounts` below.
        """
        return pulumi.get(self, "aws_accounts")

    @property
    @pulumi.getter(name="awsServices")
    def aws_services(self) -> Optional[Sequence['outputs.AssessmentScopeAwsService']]:
        """
        Amazon Web Services services that are included in the scope of the assessment. See `aws_services` below.
        """
        return pulumi.get(self, "aws_services")


@pulumi.output_type
class AssessmentScopeAwsAccount(dict):
    def __init__(__self__, *,
                 id: str):
        """
        :param str id: Identifier for the Amazon Web Services account.
        """
        AssessmentScopeAwsAccount._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")

        _setter("id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Identifier for the Amazon Web Services account.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class AssessmentScopeAwsService(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "serviceName":
            suggest = "service_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AssessmentScopeAwsService. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AssessmentScopeAwsService.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AssessmentScopeAwsService.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 service_name: str):
        """
        :param str service_name: Name of the Amazon Web Service.
        """
        AssessmentScopeAwsService._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            service_name=service_name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             service_name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if service_name is None and 'serviceName' in kwargs:
            service_name = kwargs['serviceName']
        if service_name is None:
            raise TypeError("Missing 'service_name' argument")

        _setter("service_name", service_name)

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> str:
        """
        Name of the Amazon Web Service.
        """
        return pulumi.get(self, "service_name")


@pulumi.output_type
class ControlControlMappingSource(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "sourceName":
            suggest = "source_name"
        elif key == "sourceSetUpOption":
            suggest = "source_set_up_option"
        elif key == "sourceType":
            suggest = "source_type"
        elif key == "sourceDescription":
            suggest = "source_description"
        elif key == "sourceFrequency":
            suggest = "source_frequency"
        elif key == "sourceId":
            suggest = "source_id"
        elif key == "sourceKeyword":
            suggest = "source_keyword"
        elif key == "troubleshootingText":
            suggest = "troubleshooting_text"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ControlControlMappingSource. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ControlControlMappingSource.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ControlControlMappingSource.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 source_name: str,
                 source_set_up_option: str,
                 source_type: str,
                 source_description: Optional[str] = None,
                 source_frequency: Optional[str] = None,
                 source_id: Optional[str] = None,
                 source_keyword: Optional['outputs.ControlControlMappingSourceSourceKeyword'] = None,
                 troubleshooting_text: Optional[str] = None):
        """
        :param str source_name: Name of the source.
        :param str source_set_up_option: The setup option for the data source. This option reflects if the evidence collection is automated or manual. Valid values are `System_Controls_Mapping` (automated) and `Procedural_Controls_Mapping` (manual).
        :param str source_type: Type of data source for evidence collection. If `source_set_up_option` is manual, the only valid value is `MANUAL`. If `source_set_up_option` is automated, valid values are `AWS_Cloudtrail`, `AWS_Config`, `AWS_Security_Hub`, or `AWS_API_Call`.
               
               The following arguments are optional:
        :param str source_description: Description of the source.
        :param str source_frequency: Frequency of evidence collection. Valid values are `DAILY`, `WEEKLY`, or `MONTHLY`.
        :param 'ControlControlMappingSourceSourceKeywordArgs' source_keyword: The keyword to search for in CloudTrail logs, Config rules, Security Hub checks, and Amazon Web Services API names. See `source_keyword` below.
        :param str troubleshooting_text: Instructions for troubleshooting the control.
        """
        ControlControlMappingSource._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            source_name=source_name,
            source_set_up_option=source_set_up_option,
            source_type=source_type,
            source_description=source_description,
            source_frequency=source_frequency,
            source_id=source_id,
            source_keyword=source_keyword,
            troubleshooting_text=troubleshooting_text,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             source_name: Optional[str] = None,
             source_set_up_option: Optional[str] = None,
             source_type: Optional[str] = None,
             source_description: Optional[str] = None,
             source_frequency: Optional[str] = None,
             source_id: Optional[str] = None,
             source_keyword: Optional['outputs.ControlControlMappingSourceSourceKeyword'] = None,
             troubleshooting_text: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if source_name is None and 'sourceName' in kwargs:
            source_name = kwargs['sourceName']
        if source_name is None:
            raise TypeError("Missing 'source_name' argument")
        if source_set_up_option is None and 'sourceSetUpOption' in kwargs:
            source_set_up_option = kwargs['sourceSetUpOption']
        if source_set_up_option is None:
            raise TypeError("Missing 'source_set_up_option' argument")
        if source_type is None and 'sourceType' in kwargs:
            source_type = kwargs['sourceType']
        if source_type is None:
            raise TypeError("Missing 'source_type' argument")
        if source_description is None and 'sourceDescription' in kwargs:
            source_description = kwargs['sourceDescription']
        if source_frequency is None and 'sourceFrequency' in kwargs:
            source_frequency = kwargs['sourceFrequency']
        if source_id is None and 'sourceId' in kwargs:
            source_id = kwargs['sourceId']
        if source_keyword is None and 'sourceKeyword' in kwargs:
            source_keyword = kwargs['sourceKeyword']
        if troubleshooting_text is None and 'troubleshootingText' in kwargs:
            troubleshooting_text = kwargs['troubleshootingText']

        _setter("source_name", source_name)
        _setter("source_set_up_option", source_set_up_option)
        _setter("source_type", source_type)
        if source_description is not None:
            _setter("source_description", source_description)
        if source_frequency is not None:
            _setter("source_frequency", source_frequency)
        if source_id is not None:
            _setter("source_id", source_id)
        if source_keyword is not None:
            _setter("source_keyword", source_keyword)
        if troubleshooting_text is not None:
            _setter("troubleshooting_text", troubleshooting_text)

    @property
    @pulumi.getter(name="sourceName")
    def source_name(self) -> str:
        """
        Name of the source.
        """
        return pulumi.get(self, "source_name")

    @property
    @pulumi.getter(name="sourceSetUpOption")
    def source_set_up_option(self) -> str:
        """
        The setup option for the data source. This option reflects if the evidence collection is automated or manual. Valid values are `System_Controls_Mapping` (automated) and `Procedural_Controls_Mapping` (manual).
        """
        return pulumi.get(self, "source_set_up_option")

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> str:
        """
        Type of data source for evidence collection. If `source_set_up_option` is manual, the only valid value is `MANUAL`. If `source_set_up_option` is automated, valid values are `AWS_Cloudtrail`, `AWS_Config`, `AWS_Security_Hub`, or `AWS_API_Call`.

        The following arguments are optional:
        """
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter(name="sourceDescription")
    def source_description(self) -> Optional[str]:
        """
        Description of the source.
        """
        return pulumi.get(self, "source_description")

    @property
    @pulumi.getter(name="sourceFrequency")
    def source_frequency(self) -> Optional[str]:
        """
        Frequency of evidence collection. Valid values are `DAILY`, `WEEKLY`, or `MONTHLY`.
        """
        return pulumi.get(self, "source_frequency")

    @property
    @pulumi.getter(name="sourceId")
    def source_id(self) -> Optional[str]:
        return pulumi.get(self, "source_id")

    @property
    @pulumi.getter(name="sourceKeyword")
    def source_keyword(self) -> Optional['outputs.ControlControlMappingSourceSourceKeyword']:
        """
        The keyword to search for in CloudTrail logs, Config rules, Security Hub checks, and Amazon Web Services API names. See `source_keyword` below.
        """
        return pulumi.get(self, "source_keyword")

    @property
    @pulumi.getter(name="troubleshootingText")
    def troubleshooting_text(self) -> Optional[str]:
        """
        Instructions for troubleshooting the control.
        """
        return pulumi.get(self, "troubleshooting_text")


@pulumi.output_type
class ControlControlMappingSourceSourceKeyword(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "keywordInputType":
            suggest = "keyword_input_type"
        elif key == "keywordValue":
            suggest = "keyword_value"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ControlControlMappingSourceSourceKeyword. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ControlControlMappingSourceSourceKeyword.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ControlControlMappingSourceSourceKeyword.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 keyword_input_type: str,
                 keyword_value: str):
        """
        :param str keyword_input_type: Input method for the keyword. Valid values are `SELECT_FROM_LIST`.
        :param str keyword_value: The value of the keyword that's used when mapping a control data source. For example, this can be a CloudTrail event name, a rule name for Config, a Security Hub control, or the name of an Amazon Web Services API call. See the [Audit Manager supported control data sources documentation](https://docs.aws.amazon.com/audit-manager/latest/userguide/control-data-sources.html) for more information.
        """
        ControlControlMappingSourceSourceKeyword._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            keyword_input_type=keyword_input_type,
            keyword_value=keyword_value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             keyword_input_type: Optional[str] = None,
             keyword_value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if keyword_input_type is None and 'keywordInputType' in kwargs:
            keyword_input_type = kwargs['keywordInputType']
        if keyword_input_type is None:
            raise TypeError("Missing 'keyword_input_type' argument")
        if keyword_value is None and 'keywordValue' in kwargs:
            keyword_value = kwargs['keywordValue']
        if keyword_value is None:
            raise TypeError("Missing 'keyword_value' argument")

        _setter("keyword_input_type", keyword_input_type)
        _setter("keyword_value", keyword_value)

    @property
    @pulumi.getter(name="keywordInputType")
    def keyword_input_type(self) -> str:
        """
        Input method for the keyword. Valid values are `SELECT_FROM_LIST`.
        """
        return pulumi.get(self, "keyword_input_type")

    @property
    @pulumi.getter(name="keywordValue")
    def keyword_value(self) -> str:
        """
        The value of the keyword that's used when mapping a control data source. For example, this can be a CloudTrail event name, a rule name for Config, a Security Hub control, or the name of an Amazon Web Services API call. See the [Audit Manager supported control data sources documentation](https://docs.aws.amazon.com/audit-manager/latest/userguide/control-data-sources.html) for more information.
        """
        return pulumi.get(self, "keyword_value")


@pulumi.output_type
class FrameworkControlSet(dict):
    def __init__(__self__, *,
                 name: str,
                 controls: Optional[Sequence['outputs.FrameworkControlSetControl']] = None,
                 id: Optional[str] = None):
        """
        :param str name: Name of the control set.
        :param Sequence['FrameworkControlSetControlArgs'] controls: List of controls within the control set. See `controls` below.
        :param str id: Unique identifier of the control.
        """
        FrameworkControlSet._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            controls=controls,
            id=id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             controls: Optional[Sequence['outputs.FrameworkControlSetControl']] = None,
             id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")

        _setter("name", name)
        if controls is not None:
            _setter("controls", controls)
        if id is not None:
            _setter("id", id)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the control set.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def controls(self) -> Optional[Sequence['outputs.FrameworkControlSetControl']]:
        """
        List of controls within the control set. See `controls` below.
        """
        return pulumi.get(self, "controls")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        Unique identifier of the control.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class FrameworkControlSetControl(dict):
    def __init__(__self__, *,
                 id: str):
        """
        :param str id: Unique identifier of the control.
        """
        FrameworkControlSetControl._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")

        _setter("id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        Unique identifier of the control.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class GetControlControlMappingSourceResult(dict):
    def __init__(__self__, *,
                 source_description: str,
                 source_frequency: str,
                 source_id: str,
                 source_name: str,
                 source_set_up_option: str,
                 source_type: str,
                 troubleshooting_text: str,
                 source_keyword: Optional['outputs.GetControlControlMappingSourceSourceKeywordResult'] = None):
        GetControlControlMappingSourceResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            source_description=source_description,
            source_frequency=source_frequency,
            source_id=source_id,
            source_name=source_name,
            source_set_up_option=source_set_up_option,
            source_type=source_type,
            troubleshooting_text=troubleshooting_text,
            source_keyword=source_keyword,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             source_description: Optional[str] = None,
             source_frequency: Optional[str] = None,
             source_id: Optional[str] = None,
             source_name: Optional[str] = None,
             source_set_up_option: Optional[str] = None,
             source_type: Optional[str] = None,
             troubleshooting_text: Optional[str] = None,
             source_keyword: Optional['outputs.GetControlControlMappingSourceSourceKeywordResult'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if source_description is None and 'sourceDescription' in kwargs:
            source_description = kwargs['sourceDescription']
        if source_description is None:
            raise TypeError("Missing 'source_description' argument")
        if source_frequency is None and 'sourceFrequency' in kwargs:
            source_frequency = kwargs['sourceFrequency']
        if source_frequency is None:
            raise TypeError("Missing 'source_frequency' argument")
        if source_id is None and 'sourceId' in kwargs:
            source_id = kwargs['sourceId']
        if source_id is None:
            raise TypeError("Missing 'source_id' argument")
        if source_name is None and 'sourceName' in kwargs:
            source_name = kwargs['sourceName']
        if source_name is None:
            raise TypeError("Missing 'source_name' argument")
        if source_set_up_option is None and 'sourceSetUpOption' in kwargs:
            source_set_up_option = kwargs['sourceSetUpOption']
        if source_set_up_option is None:
            raise TypeError("Missing 'source_set_up_option' argument")
        if source_type is None and 'sourceType' in kwargs:
            source_type = kwargs['sourceType']
        if source_type is None:
            raise TypeError("Missing 'source_type' argument")
        if troubleshooting_text is None and 'troubleshootingText' in kwargs:
            troubleshooting_text = kwargs['troubleshootingText']
        if troubleshooting_text is None:
            raise TypeError("Missing 'troubleshooting_text' argument")
        if source_keyword is None and 'sourceKeyword' in kwargs:
            source_keyword = kwargs['sourceKeyword']

        _setter("source_description", source_description)
        _setter("source_frequency", source_frequency)
        _setter("source_id", source_id)
        _setter("source_name", source_name)
        _setter("source_set_up_option", source_set_up_option)
        _setter("source_type", source_type)
        _setter("troubleshooting_text", troubleshooting_text)
        if source_keyword is not None:
            _setter("source_keyword", source_keyword)

    @property
    @pulumi.getter(name="sourceDescription")
    def source_description(self) -> str:
        return pulumi.get(self, "source_description")

    @property
    @pulumi.getter(name="sourceFrequency")
    def source_frequency(self) -> str:
        return pulumi.get(self, "source_frequency")

    @property
    @pulumi.getter(name="sourceId")
    def source_id(self) -> str:
        return pulumi.get(self, "source_id")

    @property
    @pulumi.getter(name="sourceName")
    def source_name(self) -> str:
        return pulumi.get(self, "source_name")

    @property
    @pulumi.getter(name="sourceSetUpOption")
    def source_set_up_option(self) -> str:
        return pulumi.get(self, "source_set_up_option")

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> str:
        return pulumi.get(self, "source_type")

    @property
    @pulumi.getter(name="troubleshootingText")
    def troubleshooting_text(self) -> str:
        return pulumi.get(self, "troubleshooting_text")

    @property
    @pulumi.getter(name="sourceKeyword")
    def source_keyword(self) -> Optional['outputs.GetControlControlMappingSourceSourceKeywordResult']:
        return pulumi.get(self, "source_keyword")


@pulumi.output_type
class GetControlControlMappingSourceSourceKeywordResult(dict):
    def __init__(__self__, *,
                 keyword_input_type: str,
                 keyword_value: str):
        GetControlControlMappingSourceSourceKeywordResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            keyword_input_type=keyword_input_type,
            keyword_value=keyword_value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             keyword_input_type: Optional[str] = None,
             keyword_value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if keyword_input_type is None and 'keywordInputType' in kwargs:
            keyword_input_type = kwargs['keywordInputType']
        if keyword_input_type is None:
            raise TypeError("Missing 'keyword_input_type' argument")
        if keyword_value is None and 'keywordValue' in kwargs:
            keyword_value = kwargs['keywordValue']
        if keyword_value is None:
            raise TypeError("Missing 'keyword_value' argument")

        _setter("keyword_input_type", keyword_input_type)
        _setter("keyword_value", keyword_value)

    @property
    @pulumi.getter(name="keywordInputType")
    def keyword_input_type(self) -> str:
        return pulumi.get(self, "keyword_input_type")

    @property
    @pulumi.getter(name="keywordValue")
    def keyword_value(self) -> str:
        return pulumi.get(self, "keyword_value")


@pulumi.output_type
class GetFrameworkControlSetResult(dict):
    def __init__(__self__, *,
                 id: str,
                 name: str,
                 controls: Optional[Sequence['outputs.GetFrameworkControlSetControlResult']] = None):
        """
        :param str name: Name of the framework.
        """
        GetFrameworkControlSetResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
            name=name,
            controls=controls,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             name: Optional[str] = None,
             controls: Optional[Sequence['outputs.GetFrameworkControlSetControlResult']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")
        if name is None:
            raise TypeError("Missing 'name' argument")

        _setter("id", id)
        _setter("name", name)
        if controls is not None:
            _setter("controls", controls)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the framework.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def controls(self) -> Optional[Sequence['outputs.GetFrameworkControlSetControlResult']]:
        return pulumi.get(self, "controls")


@pulumi.output_type
class GetFrameworkControlSetControlResult(dict):
    def __init__(__self__, *,
                 id: str):
        GetFrameworkControlSetControlResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if id is None:
            raise TypeError("Missing 'id' argument")

        _setter("id", id)

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")


