# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'DomainEndpointOptions',
    'DomainIndexField',
    'DomainScalingParameters',
]

@pulumi.output_type
class DomainEndpointOptions(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "enforceHttps":
            suggest = "enforce_https"
        elif key == "tlsSecurityPolicy":
            suggest = "tls_security_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DomainEndpointOptions. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DomainEndpointOptions.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DomainEndpointOptions.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enforce_https: Optional[bool] = None,
                 tls_security_policy: Optional[str] = None):
        """
        :param bool enforce_https: Enables or disables the requirement that all requests to the domain arrive over HTTPS.
        :param str tls_security_policy: The minimum required TLS version. See the [AWS documentation](https://docs.aws.amazon.com/cloudsearch/latest/developerguide/API_DomainEndpointOptions.html) for valid values.
        """
        DomainEndpointOptions._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            enforce_https=enforce_https,
            tls_security_policy=tls_security_policy,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             enforce_https: Optional[bool] = None,
             tls_security_policy: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if enforce_https is None and 'enforceHttps' in kwargs:
            enforce_https = kwargs['enforceHttps']
        if tls_security_policy is None and 'tlsSecurityPolicy' in kwargs:
            tls_security_policy = kwargs['tlsSecurityPolicy']

        if enforce_https is not None:
            _setter("enforce_https", enforce_https)
        if tls_security_policy is not None:
            _setter("tls_security_policy", tls_security_policy)

    @property
    @pulumi.getter(name="enforceHttps")
    def enforce_https(self) -> Optional[bool]:
        """
        Enables or disables the requirement that all requests to the domain arrive over HTTPS.
        """
        return pulumi.get(self, "enforce_https")

    @property
    @pulumi.getter(name="tlsSecurityPolicy")
    def tls_security_policy(self) -> Optional[str]:
        """
        The minimum required TLS version. See the [AWS documentation](https://docs.aws.amazon.com/cloudsearch/latest/developerguide/API_DomainEndpointOptions.html) for valid values.
        """
        return pulumi.get(self, "tls_security_policy")


@pulumi.output_type
class DomainIndexField(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "analysisScheme":
            suggest = "analysis_scheme"
        elif key == "defaultValue":
            suggest = "default_value"
        elif key == "return":
            suggest = "return_"
        elif key == "sourceFields":
            suggest = "source_fields"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DomainIndexField. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DomainIndexField.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DomainIndexField.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 type: str,
                 analysis_scheme: Optional[str] = None,
                 default_value: Optional[str] = None,
                 facet: Optional[bool] = None,
                 highlight: Optional[bool] = None,
                 return_: Optional[bool] = None,
                 search: Optional[bool] = None,
                 sort: Optional[bool] = None,
                 source_fields: Optional[str] = None):
        """
        :param str name: A unique name for the field. Field names must begin with a letter and be at least 3 and no more than 64 characters long. The allowed characters are: `a`-`z` (lower-case letters), `0`-`9`, and `_` (underscore). The name `score` is reserved and cannot be used as a field name.
        :param str type: The field type. Valid values: `date`, `date-array`, `double`, `double-array`, `int`, `int-array`, `literal`, `literal-array`, `text`, `text-array`.
        :param str analysis_scheme: The analysis scheme you want to use for a `text` field. The analysis scheme specifies the language-specific text processing options that are used during indexing.
        :param str default_value: The default value for the field. This value is used when no value is specified for the field in the document data.
        :param bool facet: You can get facet information by enabling this.
        :param bool highlight: You can highlight information.
        :param bool return_: You can enable returning the value of all searchable fields.
        :param bool search: You can set whether this index should be searchable or not.
        :param bool sort: You can enable the property to be sortable.
        :param str source_fields: A comma-separated list of source fields to map to the field. Specifying a source field copies data from one field to another, enabling you to use the same source data in different ways by configuring different options for the fields.
        """
        DomainIndexField._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            type=type,
            analysis_scheme=analysis_scheme,
            default_value=default_value,
            facet=facet,
            highlight=highlight,
            return_=return_,
            search=search,
            sort=sort,
            source_fields=source_fields,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             type: Optional[str] = None,
             analysis_scheme: Optional[str] = None,
             default_value: Optional[str] = None,
             facet: Optional[bool] = None,
             highlight: Optional[bool] = None,
             return_: Optional[bool] = None,
             search: Optional[bool] = None,
             sort: Optional[bool] = None,
             source_fields: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if type is None:
            raise TypeError("Missing 'type' argument")
        if analysis_scheme is None and 'analysisScheme' in kwargs:
            analysis_scheme = kwargs['analysisScheme']
        if default_value is None and 'defaultValue' in kwargs:
            default_value = kwargs['defaultValue']
        if return_ is None and 'return' in kwargs:
            return_ = kwargs['return']
        if source_fields is None and 'sourceFields' in kwargs:
            source_fields = kwargs['sourceFields']

        _setter("name", name)
        _setter("type", type)
        if analysis_scheme is not None:
            _setter("analysis_scheme", analysis_scheme)
        if default_value is not None:
            _setter("default_value", default_value)
        if facet is not None:
            _setter("facet", facet)
        if highlight is not None:
            _setter("highlight", highlight)
        if return_ is not None:
            _setter("return_", return_)
        if search is not None:
            _setter("search", search)
        if sort is not None:
            _setter("sort", sort)
        if source_fields is not None:
            _setter("source_fields", source_fields)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        A unique name for the field. Field names must begin with a letter and be at least 3 and no more than 64 characters long. The allowed characters are: `a`-`z` (lower-case letters), `0`-`9`, and `_` (underscore). The name `score` is reserved and cannot be used as a field name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The field type. Valid values: `date`, `date-array`, `double`, `double-array`, `int`, `int-array`, `literal`, `literal-array`, `text`, `text-array`.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="analysisScheme")
    def analysis_scheme(self) -> Optional[str]:
        """
        The analysis scheme you want to use for a `text` field. The analysis scheme specifies the language-specific text processing options that are used during indexing.
        """
        return pulumi.get(self, "analysis_scheme")

    @property
    @pulumi.getter(name="defaultValue")
    def default_value(self) -> Optional[str]:
        """
        The default value for the field. This value is used when no value is specified for the field in the document data.
        """
        return pulumi.get(self, "default_value")

    @property
    @pulumi.getter
    def facet(self) -> Optional[bool]:
        """
        You can get facet information by enabling this.
        """
        return pulumi.get(self, "facet")

    @property
    @pulumi.getter
    def highlight(self) -> Optional[bool]:
        """
        You can highlight information.
        """
        return pulumi.get(self, "highlight")

    @property
    @pulumi.getter(name="return")
    def return_(self) -> Optional[bool]:
        """
        You can enable returning the value of all searchable fields.
        """
        return pulumi.get(self, "return_")

    @property
    @pulumi.getter
    def search(self) -> Optional[bool]:
        """
        You can set whether this index should be searchable or not.
        """
        return pulumi.get(self, "search")

    @property
    @pulumi.getter
    def sort(self) -> Optional[bool]:
        """
        You can enable the property to be sortable.
        """
        return pulumi.get(self, "sort")

    @property
    @pulumi.getter(name="sourceFields")
    def source_fields(self) -> Optional[str]:
        """
        A comma-separated list of source fields to map to the field. Specifying a source field copies data from one field to another, enabling you to use the same source data in different ways by configuring different options for the fields.
        """
        return pulumi.get(self, "source_fields")


@pulumi.output_type
class DomainScalingParameters(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "desiredInstanceType":
            suggest = "desired_instance_type"
        elif key == "desiredPartitionCount":
            suggest = "desired_partition_count"
        elif key == "desiredReplicationCount":
            suggest = "desired_replication_count"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DomainScalingParameters. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DomainScalingParameters.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DomainScalingParameters.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 desired_instance_type: Optional[str] = None,
                 desired_partition_count: Optional[int] = None,
                 desired_replication_count: Optional[int] = None):
        """
        :param str desired_instance_type: The instance type that you want to preconfigure for your domain. See the [AWS documentation](https://docs.aws.amazon.com/cloudsearch/latest/developerguide/API_ScalingParameters.html) for valid values.
        :param int desired_partition_count: The number of partitions you want to preconfigure for your domain. Only valid when you select `search.2xlarge` as the instance type.
        :param int desired_replication_count: The number of replicas you want to preconfigure for each index partition.
        """
        DomainScalingParameters._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            desired_instance_type=desired_instance_type,
            desired_partition_count=desired_partition_count,
            desired_replication_count=desired_replication_count,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             desired_instance_type: Optional[str] = None,
             desired_partition_count: Optional[int] = None,
             desired_replication_count: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if desired_instance_type is None and 'desiredInstanceType' in kwargs:
            desired_instance_type = kwargs['desiredInstanceType']
        if desired_partition_count is None and 'desiredPartitionCount' in kwargs:
            desired_partition_count = kwargs['desiredPartitionCount']
        if desired_replication_count is None and 'desiredReplicationCount' in kwargs:
            desired_replication_count = kwargs['desiredReplicationCount']

        if desired_instance_type is not None:
            _setter("desired_instance_type", desired_instance_type)
        if desired_partition_count is not None:
            _setter("desired_partition_count", desired_partition_count)
        if desired_replication_count is not None:
            _setter("desired_replication_count", desired_replication_count)

    @property
    @pulumi.getter(name="desiredInstanceType")
    def desired_instance_type(self) -> Optional[str]:
        """
        The instance type that you want to preconfigure for your domain. See the [AWS documentation](https://docs.aws.amazon.com/cloudsearch/latest/developerguide/API_ScalingParameters.html) for valid values.
        """
        return pulumi.get(self, "desired_instance_type")

    @property
    @pulumi.getter(name="desiredPartitionCount")
    def desired_partition_count(self) -> Optional[int]:
        """
        The number of partitions you want to preconfigure for your domain. Only valid when you select `search.2xlarge` as the instance type.
        """
        return pulumi.get(self, "desired_partition_count")

    @property
    @pulumi.getter(name="desiredReplicationCount")
    def desired_replication_count(self) -> Optional[int]:
        """
        The number of replicas you want to preconfigure for each index partition.
        """
        return pulumi.get(self, "desired_replication_count")


