# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'RepositoryExternalConnections',
    'RepositoryUpstream',
]

@pulumi.output_type
class RepositoryExternalConnections(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "externalConnectionName":
            suggest = "external_connection_name"
        elif key == "packageFormat":
            suggest = "package_format"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RepositoryExternalConnections. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RepositoryExternalConnections.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RepositoryExternalConnections.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 external_connection_name: str,
                 package_format: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str external_connection_name: The name of the external connection associated with a repository.
        """
        RepositoryExternalConnections._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            external_connection_name=external_connection_name,
            package_format=package_format,
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             external_connection_name: Optional[str] = None,
             package_format: Optional[str] = None,
             status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if external_connection_name is None and 'externalConnectionName' in kwargs:
            external_connection_name = kwargs['externalConnectionName']
        if external_connection_name is None:
            raise TypeError("Missing 'external_connection_name' argument")
        if package_format is None and 'packageFormat' in kwargs:
            package_format = kwargs['packageFormat']

        _setter("external_connection_name", external_connection_name)
        if package_format is not None:
            _setter("package_format", package_format)
        if status is not None:
            _setter("status", status)

    @property
    @pulumi.getter(name="externalConnectionName")
    def external_connection_name(self) -> str:
        """
        The name of the external connection associated with a repository.
        """
        return pulumi.get(self, "external_connection_name")

    @property
    @pulumi.getter(name="packageFormat")
    def package_format(self) -> Optional[str]:
        return pulumi.get(self, "package_format")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        return pulumi.get(self, "status")


@pulumi.output_type
class RepositoryUpstream(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "repositoryName":
            suggest = "repository_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RepositoryUpstream. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RepositoryUpstream.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RepositoryUpstream.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 repository_name: str):
        """
        :param str repository_name: The name of an upstream repository.
        """
        RepositoryUpstream._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            repository_name=repository_name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             repository_name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if repository_name is None and 'repositoryName' in kwargs:
            repository_name = kwargs['repositoryName']
        if repository_name is None:
            raise TypeError("Missing 'repository_name' argument")

        _setter("repository_name", repository_name)

    @property
    @pulumi.getter(name="repositoryName")
    def repository_name(self) -> str:
        """
        The name of an upstream repository.
        """
        return pulumi.get(self, "repository_name")


