# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetRouterConfigurationRouterResult',
]

@pulumi.output_type
class GetRouterConfigurationRouterResult(dict):
    def __init__(__self__, *,
                 platform: str,
                 router_type_identifier: str,
                 software: str,
                 vendor: str,
                 xslt_template_name: str,
                 xslt_template_name_for_mac_sec: str):
        """
        :param str platform: Router platform
        :param str router_type_identifier: ID of the Router Type. For example: `CiscoSystemsInc-2900SeriesRouters-IOS124`
               
               There is currently no AWS API to retrieve the full list of `router_type_identifier` values. Here is a list of known `RouterType` objects that can be used:
               
               ```python
               import pulumi
               ```
        :param str software: Router operating system
        :param str vendor: Router vendor
        :param str xslt_template_name: Router XSLT Template Name
        """
        GetRouterConfigurationRouterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            platform=platform,
            router_type_identifier=router_type_identifier,
            software=software,
            vendor=vendor,
            xslt_template_name=xslt_template_name,
            xslt_template_name_for_mac_sec=xslt_template_name_for_mac_sec,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             platform: Optional[str] = None,
             router_type_identifier: Optional[str] = None,
             software: Optional[str] = None,
             vendor: Optional[str] = None,
             xslt_template_name: Optional[str] = None,
             xslt_template_name_for_mac_sec: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if platform is None:
            raise TypeError("Missing 'platform' argument")
        if router_type_identifier is None and 'routerTypeIdentifier' in kwargs:
            router_type_identifier = kwargs['routerTypeIdentifier']
        if router_type_identifier is None:
            raise TypeError("Missing 'router_type_identifier' argument")
        if software is None:
            raise TypeError("Missing 'software' argument")
        if vendor is None:
            raise TypeError("Missing 'vendor' argument")
        if xslt_template_name is None and 'xsltTemplateName' in kwargs:
            xslt_template_name = kwargs['xsltTemplateName']
        if xslt_template_name is None:
            raise TypeError("Missing 'xslt_template_name' argument")
        if xslt_template_name_for_mac_sec is None and 'xsltTemplateNameForMacSec' in kwargs:
            xslt_template_name_for_mac_sec = kwargs['xsltTemplateNameForMacSec']
        if xslt_template_name_for_mac_sec is None:
            raise TypeError("Missing 'xslt_template_name_for_mac_sec' argument")

        _setter("platform", platform)
        _setter("router_type_identifier", router_type_identifier)
        _setter("software", software)
        _setter("vendor", vendor)
        _setter("xslt_template_name", xslt_template_name)
        _setter("xslt_template_name_for_mac_sec", xslt_template_name_for_mac_sec)

    @property
    @pulumi.getter
    def platform(self) -> str:
        """
        Router platform
        """
        return pulumi.get(self, "platform")

    @property
    @pulumi.getter(name="routerTypeIdentifier")
    def router_type_identifier(self) -> str:
        """
        ID of the Router Type. For example: `CiscoSystemsInc-2900SeriesRouters-IOS124`

        There is currently no AWS API to retrieve the full list of `router_type_identifier` values. Here is a list of known `RouterType` objects that can be used:

        ```python
        import pulumi
        ```
        """
        return pulumi.get(self, "router_type_identifier")

    @property
    @pulumi.getter
    def software(self) -> str:
        """
        Router operating system
        """
        return pulumi.get(self, "software")

    @property
    @pulumi.getter
    def vendor(self) -> str:
        """
        Router vendor
        """
        return pulumi.get(self, "vendor")

    @property
    @pulumi.getter(name="xsltTemplateName")
    def xslt_template_name(self) -> str:
        """
        Router XSLT Template Name
        """
        return pulumi.get(self, "xslt_template_name")

    @property
    @pulumi.getter(name="xsltTemplateNameForMacSec")
    def xslt_template_name_for_mac_sec(self) -> str:
        return pulumi.get(self, "xslt_template_name_for_mac_sec")


