# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['PolicyTableAssociationArgs', 'PolicyTableAssociation']

@pulumi.input_type
class PolicyTableAssociationArgs:
    def __init__(__self__, *,
                 transit_gateway_attachment_id: pulumi.Input[str],
                 transit_gateway_policy_table_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a PolicyTableAssociation resource.
        :param pulumi.Input[str] transit_gateway_attachment_id: Identifier of EC2 Transit Gateway Attachment.
        :param pulumi.Input[str] transit_gateway_policy_table_id: Identifier of EC2 Transit Gateway Policy Table.
        """
        PolicyTableAssociationArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            transit_gateway_attachment_id=transit_gateway_attachment_id,
            transit_gateway_policy_table_id=transit_gateway_policy_table_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             transit_gateway_attachment_id: Optional[pulumi.Input[str]] = None,
             transit_gateway_policy_table_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if transit_gateway_attachment_id is None and 'transitGatewayAttachmentId' in kwargs:
            transit_gateway_attachment_id = kwargs['transitGatewayAttachmentId']
        if transit_gateway_attachment_id is None:
            raise TypeError("Missing 'transit_gateway_attachment_id' argument")
        if transit_gateway_policy_table_id is None and 'transitGatewayPolicyTableId' in kwargs:
            transit_gateway_policy_table_id = kwargs['transitGatewayPolicyTableId']
        if transit_gateway_policy_table_id is None:
            raise TypeError("Missing 'transit_gateway_policy_table_id' argument")

        _setter("transit_gateway_attachment_id", transit_gateway_attachment_id)
        _setter("transit_gateway_policy_table_id", transit_gateway_policy_table_id)

    @property
    @pulumi.getter(name="transitGatewayAttachmentId")
    def transit_gateway_attachment_id(self) -> pulumi.Input[str]:
        """
        Identifier of EC2 Transit Gateway Attachment.
        """
        return pulumi.get(self, "transit_gateway_attachment_id")

    @transit_gateway_attachment_id.setter
    def transit_gateway_attachment_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "transit_gateway_attachment_id", value)

    @property
    @pulumi.getter(name="transitGatewayPolicyTableId")
    def transit_gateway_policy_table_id(self) -> pulumi.Input[str]:
        """
        Identifier of EC2 Transit Gateway Policy Table.
        """
        return pulumi.get(self, "transit_gateway_policy_table_id")

    @transit_gateway_policy_table_id.setter
    def transit_gateway_policy_table_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "transit_gateway_policy_table_id", value)


@pulumi.input_type
class _PolicyTableAssociationState:
    def __init__(__self__, *,
                 resource_id: Optional[pulumi.Input[str]] = None,
                 resource_type: Optional[pulumi.Input[str]] = None,
                 transit_gateway_attachment_id: Optional[pulumi.Input[str]] = None,
                 transit_gateway_policy_table_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering PolicyTableAssociation resources.
        :param pulumi.Input[str] resource_id: Identifier of the resource
        :param pulumi.Input[str] resource_type: Type of the resource
        :param pulumi.Input[str] transit_gateway_attachment_id: Identifier of EC2 Transit Gateway Attachment.
        :param pulumi.Input[str] transit_gateway_policy_table_id: Identifier of EC2 Transit Gateway Policy Table.
        """
        _PolicyTableAssociationState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            resource_id=resource_id,
            resource_type=resource_type,
            transit_gateway_attachment_id=transit_gateway_attachment_id,
            transit_gateway_policy_table_id=transit_gateway_policy_table_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             resource_id: Optional[pulumi.Input[str]] = None,
             resource_type: Optional[pulumi.Input[str]] = None,
             transit_gateway_attachment_id: Optional[pulumi.Input[str]] = None,
             transit_gateway_policy_table_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if resource_id is None and 'resourceId' in kwargs:
            resource_id = kwargs['resourceId']
        if resource_type is None and 'resourceType' in kwargs:
            resource_type = kwargs['resourceType']
        if transit_gateway_attachment_id is None and 'transitGatewayAttachmentId' in kwargs:
            transit_gateway_attachment_id = kwargs['transitGatewayAttachmentId']
        if transit_gateway_policy_table_id is None and 'transitGatewayPolicyTableId' in kwargs:
            transit_gateway_policy_table_id = kwargs['transitGatewayPolicyTableId']

        if resource_id is not None:
            _setter("resource_id", resource_id)
        if resource_type is not None:
            _setter("resource_type", resource_type)
        if transit_gateway_attachment_id is not None:
            _setter("transit_gateway_attachment_id", transit_gateway_attachment_id)
        if transit_gateway_policy_table_id is not None:
            _setter("transit_gateway_policy_table_id", transit_gateway_policy_table_id)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the resource
        """
        return pulumi.get(self, "resource_id")

    @resource_id.setter
    def resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_id", value)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of the resource
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_type", value)

    @property
    @pulumi.getter(name="transitGatewayAttachmentId")
    def transit_gateway_attachment_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of EC2 Transit Gateway Attachment.
        """
        return pulumi.get(self, "transit_gateway_attachment_id")

    @transit_gateway_attachment_id.setter
    def transit_gateway_attachment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transit_gateway_attachment_id", value)

    @property
    @pulumi.getter(name="transitGatewayPolicyTableId")
    def transit_gateway_policy_table_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of EC2 Transit Gateway Policy Table.
        """
        return pulumi.get(self, "transit_gateway_policy_table_id")

    @transit_gateway_policy_table_id.setter
    def transit_gateway_policy_table_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transit_gateway_policy_table_id", value)


class PolicyTableAssociation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 transit_gateway_attachment_id: Optional[pulumi.Input[str]] = None,
                 transit_gateway_policy_table_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages an EC2 Transit Gateway Policy Table association.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_aws as aws

        example = aws.ec2transitgateway.PolicyTableAssociation("example",
            transit_gateway_attachment_id=aws_networkmanager_transit_gateway_peering["example"]["transit_gateway_peering_attachment_id"],
            transit_gateway_policy_table_id=aws_ec2_transit_gateway_policy_table["example"]["id"])
        ```

        ## Import

        Using `pulumi import`, import `aws_ec2_transit_gateway_policy_table_association` using the EC2 Transit Gateway Policy Table identifier, an underscore, and the EC2 Transit Gateway Attachment identifier. For example:

        ```sh
         $ pulumi import aws:ec2transitgateway/policyTableAssociation:PolicyTableAssociation example tgw-rtb-12345678_tgw-attach-87654321
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] transit_gateway_attachment_id: Identifier of EC2 Transit Gateway Attachment.
        :param pulumi.Input[str] transit_gateway_policy_table_id: Identifier of EC2 Transit Gateway Policy Table.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PolicyTableAssociationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an EC2 Transit Gateway Policy Table association.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_aws as aws

        example = aws.ec2transitgateway.PolicyTableAssociation("example",
            transit_gateway_attachment_id=aws_networkmanager_transit_gateway_peering["example"]["transit_gateway_peering_attachment_id"],
            transit_gateway_policy_table_id=aws_ec2_transit_gateway_policy_table["example"]["id"])
        ```

        ## Import

        Using `pulumi import`, import `aws_ec2_transit_gateway_policy_table_association` using the EC2 Transit Gateway Policy Table identifier, an underscore, and the EC2 Transit Gateway Attachment identifier. For example:

        ```sh
         $ pulumi import aws:ec2transitgateway/policyTableAssociation:PolicyTableAssociation example tgw-rtb-12345678_tgw-attach-87654321
        ```

        :param str resource_name: The name of the resource.
        :param PolicyTableAssociationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PolicyTableAssociationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            PolicyTableAssociationArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 transit_gateway_attachment_id: Optional[pulumi.Input[str]] = None,
                 transit_gateway_policy_table_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PolicyTableAssociationArgs.__new__(PolicyTableAssociationArgs)

            if transit_gateway_attachment_id is None and not opts.urn:
                raise TypeError("Missing required property 'transit_gateway_attachment_id'")
            __props__.__dict__["transit_gateway_attachment_id"] = transit_gateway_attachment_id
            if transit_gateway_policy_table_id is None and not opts.urn:
                raise TypeError("Missing required property 'transit_gateway_policy_table_id'")
            __props__.__dict__["transit_gateway_policy_table_id"] = transit_gateway_policy_table_id
            __props__.__dict__["resource_id"] = None
            __props__.__dict__["resource_type"] = None
        super(PolicyTableAssociation, __self__).__init__(
            'aws:ec2transitgateway/policyTableAssociation:PolicyTableAssociation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            resource_id: Optional[pulumi.Input[str]] = None,
            resource_type: Optional[pulumi.Input[str]] = None,
            transit_gateway_attachment_id: Optional[pulumi.Input[str]] = None,
            transit_gateway_policy_table_id: Optional[pulumi.Input[str]] = None) -> 'PolicyTableAssociation':
        """
        Get an existing PolicyTableAssociation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] resource_id: Identifier of the resource
        :param pulumi.Input[str] resource_type: Type of the resource
        :param pulumi.Input[str] transit_gateway_attachment_id: Identifier of EC2 Transit Gateway Attachment.
        :param pulumi.Input[str] transit_gateway_policy_table_id: Identifier of EC2 Transit Gateway Policy Table.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PolicyTableAssociationState.__new__(_PolicyTableAssociationState)

        __props__.__dict__["resource_id"] = resource_id
        __props__.__dict__["resource_type"] = resource_type
        __props__.__dict__["transit_gateway_attachment_id"] = transit_gateway_attachment_id
        __props__.__dict__["transit_gateway_policy_table_id"] = transit_gateway_policy_table_id
        return PolicyTableAssociation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> pulumi.Output[str]:
        """
        Identifier of the resource
        """
        return pulumi.get(self, "resource_id")

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> pulumi.Output[str]:
        """
        Type of the resource
        """
        return pulumi.get(self, "resource_type")

    @property
    @pulumi.getter(name="transitGatewayAttachmentId")
    def transit_gateway_attachment_id(self) -> pulumi.Output[str]:
        """
        Identifier of EC2 Transit Gateway Attachment.
        """
        return pulumi.get(self, "transit_gateway_attachment_id")

    @property
    @pulumi.getter(name="transitGatewayPolicyTableId")
    def transit_gateway_policy_table_id(self) -> pulumi.Output[str]:
        """
        Identifier of EC2 Transit Gateway Policy Table.
        """
        return pulumi.get(self, "transit_gateway_policy_table_id")

