# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'AccessPointPosixUserArgs',
    'AccessPointRootDirectoryArgs',
    'AccessPointRootDirectoryCreationInfoArgs',
    'BackupPolicyBackupPolicyArgs',
    'FileSystemLifecyclePolicyArgs',
    'FileSystemSizeInByteArgs',
    'ReplicationConfigurationDestinationArgs',
]

@pulumi.input_type
class AccessPointPosixUserArgs:
    def __init__(__self__, *,
                 gid: pulumi.Input[int],
                 uid: pulumi.Input[int],
                 secondary_gids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        :param pulumi.Input[int] gid: POSIX group ID used for all file system operations using this access point.
        :param pulumi.Input[int] uid: POSIX user ID used for all file system operations using this access point.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] secondary_gids: Secondary POSIX group IDs used for all file system operations using this access point.
        """
        AccessPointPosixUserArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            gid=gid,
            uid=uid,
            secondary_gids=secondary_gids,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             gid: Optional[pulumi.Input[int]] = None,
             uid: Optional[pulumi.Input[int]] = None,
             secondary_gids: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if gid is None:
            raise TypeError("Missing 'gid' argument")
        if uid is None:
            raise TypeError("Missing 'uid' argument")
        if secondary_gids is None and 'secondaryGids' in kwargs:
            secondary_gids = kwargs['secondaryGids']

        _setter("gid", gid)
        _setter("uid", uid)
        if secondary_gids is not None:
            _setter("secondary_gids", secondary_gids)

    @property
    @pulumi.getter
    def gid(self) -> pulumi.Input[int]:
        """
        POSIX group ID used for all file system operations using this access point.
        """
        return pulumi.get(self, "gid")

    @gid.setter
    def gid(self, value: pulumi.Input[int]):
        pulumi.set(self, "gid", value)

    @property
    @pulumi.getter
    def uid(self) -> pulumi.Input[int]:
        """
        POSIX user ID used for all file system operations using this access point.
        """
        return pulumi.get(self, "uid")

    @uid.setter
    def uid(self, value: pulumi.Input[int]):
        pulumi.set(self, "uid", value)

    @property
    @pulumi.getter(name="secondaryGids")
    def secondary_gids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Secondary POSIX group IDs used for all file system operations using this access point.
        """
        return pulumi.get(self, "secondary_gids")

    @secondary_gids.setter
    def secondary_gids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "secondary_gids", value)


@pulumi.input_type
class AccessPointRootDirectoryArgs:
    def __init__(__self__, *,
                 creation_info: Optional[pulumi.Input['AccessPointRootDirectoryCreationInfoArgs']] = None,
                 path: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input['AccessPointRootDirectoryCreationInfoArgs'] creation_info: POSIX IDs and permissions to apply to the access point's Root Directory. See Creation Info below.
        :param pulumi.Input[str] path: Path on the EFS file system to expose as the root directory to NFS clients using the access point to access the EFS file system. A path can have up to four subdirectories. If the specified path does not exist, you are required to provide `creation_info`.
        """
        AccessPointRootDirectoryArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            creation_info=creation_info,
            path=path,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             creation_info: Optional[pulumi.Input['AccessPointRootDirectoryCreationInfoArgs']] = None,
             path: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if creation_info is None and 'creationInfo' in kwargs:
            creation_info = kwargs['creationInfo']

        if creation_info is not None:
            _setter("creation_info", creation_info)
        if path is not None:
            _setter("path", path)

    @property
    @pulumi.getter(name="creationInfo")
    def creation_info(self) -> Optional[pulumi.Input['AccessPointRootDirectoryCreationInfoArgs']]:
        """
        POSIX IDs and permissions to apply to the access point's Root Directory. See Creation Info below.
        """
        return pulumi.get(self, "creation_info")

    @creation_info.setter
    def creation_info(self, value: Optional[pulumi.Input['AccessPointRootDirectoryCreationInfoArgs']]):
        pulumi.set(self, "creation_info", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[str]]:
        """
        Path on the EFS file system to expose as the root directory to NFS clients using the access point to access the EFS file system. A path can have up to four subdirectories. If the specified path does not exist, you are required to provide `creation_info`.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "path", value)


@pulumi.input_type
class AccessPointRootDirectoryCreationInfoArgs:
    def __init__(__self__, *,
                 owner_gid: pulumi.Input[int],
                 owner_uid: pulumi.Input[int],
                 permissions: pulumi.Input[str]):
        """
        :param pulumi.Input[int] owner_gid: POSIX group ID to apply to the `root_directory`.
        :param pulumi.Input[int] owner_uid: POSIX user ID to apply to the `root_directory`.
        :param pulumi.Input[str] permissions: POSIX permissions to apply to the RootDirectory, in the format of an octal number representing the file's mode bits.
        """
        AccessPointRootDirectoryCreationInfoArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            owner_gid=owner_gid,
            owner_uid=owner_uid,
            permissions=permissions,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             owner_gid: Optional[pulumi.Input[int]] = None,
             owner_uid: Optional[pulumi.Input[int]] = None,
             permissions: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if owner_gid is None and 'ownerGid' in kwargs:
            owner_gid = kwargs['ownerGid']
        if owner_gid is None:
            raise TypeError("Missing 'owner_gid' argument")
        if owner_uid is None and 'ownerUid' in kwargs:
            owner_uid = kwargs['ownerUid']
        if owner_uid is None:
            raise TypeError("Missing 'owner_uid' argument")
        if permissions is None:
            raise TypeError("Missing 'permissions' argument")

        _setter("owner_gid", owner_gid)
        _setter("owner_uid", owner_uid)
        _setter("permissions", permissions)

    @property
    @pulumi.getter(name="ownerGid")
    def owner_gid(self) -> pulumi.Input[int]:
        """
        POSIX group ID to apply to the `root_directory`.
        """
        return pulumi.get(self, "owner_gid")

    @owner_gid.setter
    def owner_gid(self, value: pulumi.Input[int]):
        pulumi.set(self, "owner_gid", value)

    @property
    @pulumi.getter(name="ownerUid")
    def owner_uid(self) -> pulumi.Input[int]:
        """
        POSIX user ID to apply to the `root_directory`.
        """
        return pulumi.get(self, "owner_uid")

    @owner_uid.setter
    def owner_uid(self, value: pulumi.Input[int]):
        pulumi.set(self, "owner_uid", value)

    @property
    @pulumi.getter
    def permissions(self) -> pulumi.Input[str]:
        """
        POSIX permissions to apply to the RootDirectory, in the format of an octal number representing the file's mode bits.
        """
        return pulumi.get(self, "permissions")

    @permissions.setter
    def permissions(self, value: pulumi.Input[str]):
        pulumi.set(self, "permissions", value)


@pulumi.input_type
class BackupPolicyBackupPolicyArgs:
    def __init__(__self__, *,
                 status: pulumi.Input[str]):
        """
        :param pulumi.Input[str] status: A status of the backup policy. Valid values: `ENABLED`, `DISABLED`.
        """
        BackupPolicyBackupPolicyArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             status: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if status is None:
            raise TypeError("Missing 'status' argument")

        _setter("status", status)

    @property
    @pulumi.getter
    def status(self) -> pulumi.Input[str]:
        """
        A status of the backup policy. Valid values: `ENABLED`, `DISABLED`.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: pulumi.Input[str]):
        pulumi.set(self, "status", value)


@pulumi.input_type
class FileSystemLifecyclePolicyArgs:
    def __init__(__self__, *,
                 transition_to_ia: Optional[pulumi.Input[str]] = None,
                 transition_to_primary_storage_class: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] transition_to_ia: Indicates how long it takes to transition files to the IA storage class. Valid values: `AFTER_1_DAY`, `AFTER_7_DAYS`, `AFTER_14_DAYS`, `AFTER_30_DAYS`, `AFTER_60_DAYS`, or `AFTER_90_DAYS`.
        :param pulumi.Input[str] transition_to_primary_storage_class: Describes the policy used to transition a file from infequent access storage to primary storage. Valid values: `AFTER_1_ACCESS`.
        """
        FileSystemLifecyclePolicyArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            transition_to_ia=transition_to_ia,
            transition_to_primary_storage_class=transition_to_primary_storage_class,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             transition_to_ia: Optional[pulumi.Input[str]] = None,
             transition_to_primary_storage_class: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if transition_to_ia is None and 'transitionToIa' in kwargs:
            transition_to_ia = kwargs['transitionToIa']
        if transition_to_primary_storage_class is None and 'transitionToPrimaryStorageClass' in kwargs:
            transition_to_primary_storage_class = kwargs['transitionToPrimaryStorageClass']

        if transition_to_ia is not None:
            _setter("transition_to_ia", transition_to_ia)
        if transition_to_primary_storage_class is not None:
            _setter("transition_to_primary_storage_class", transition_to_primary_storage_class)

    @property
    @pulumi.getter(name="transitionToIa")
    def transition_to_ia(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates how long it takes to transition files to the IA storage class. Valid values: `AFTER_1_DAY`, `AFTER_7_DAYS`, `AFTER_14_DAYS`, `AFTER_30_DAYS`, `AFTER_60_DAYS`, or `AFTER_90_DAYS`.
        """
        return pulumi.get(self, "transition_to_ia")

    @transition_to_ia.setter
    def transition_to_ia(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transition_to_ia", value)

    @property
    @pulumi.getter(name="transitionToPrimaryStorageClass")
    def transition_to_primary_storage_class(self) -> Optional[pulumi.Input[str]]:
        """
        Describes the policy used to transition a file from infequent access storage to primary storage. Valid values: `AFTER_1_ACCESS`.
        """
        return pulumi.get(self, "transition_to_primary_storage_class")

    @transition_to_primary_storage_class.setter
    def transition_to_primary_storage_class(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transition_to_primary_storage_class", value)


@pulumi.input_type
class FileSystemSizeInByteArgs:
    def __init__(__self__, *,
                 value: Optional[pulumi.Input[int]] = None,
                 value_in_ia: Optional[pulumi.Input[int]] = None,
                 value_in_standard: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] value: The latest known metered size (in bytes) of data stored in the file system.
        :param pulumi.Input[int] value_in_ia: The latest known metered size (in bytes) of data stored in the Infrequent Access storage class.
        :param pulumi.Input[int] value_in_standard: The latest known metered size (in bytes) of data stored in the Standard storage class.
        """
        FileSystemSizeInByteArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            value=value,
            value_in_ia=value_in_ia,
            value_in_standard=value_in_standard,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             value: Optional[pulumi.Input[int]] = None,
             value_in_ia: Optional[pulumi.Input[int]] = None,
             value_in_standard: Optional[pulumi.Input[int]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if value_in_ia is None and 'valueInIa' in kwargs:
            value_in_ia = kwargs['valueInIa']
        if value_in_standard is None and 'valueInStandard' in kwargs:
            value_in_standard = kwargs['valueInStandard']

        if value is not None:
            _setter("value", value)
        if value_in_ia is not None:
            _setter("value_in_ia", value_in_ia)
        if value_in_standard is not None:
            _setter("value_in_standard", value_in_standard)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[int]]:
        """
        The latest known metered size (in bytes) of data stored in the file system.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "value", value)

    @property
    @pulumi.getter(name="valueInIa")
    def value_in_ia(self) -> Optional[pulumi.Input[int]]:
        """
        The latest known metered size (in bytes) of data stored in the Infrequent Access storage class.
        """
        return pulumi.get(self, "value_in_ia")

    @value_in_ia.setter
    def value_in_ia(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "value_in_ia", value)

    @property
    @pulumi.getter(name="valueInStandard")
    def value_in_standard(self) -> Optional[pulumi.Input[int]]:
        """
        The latest known metered size (in bytes) of data stored in the Standard storage class.
        """
        return pulumi.get(self, "value_in_standard")

    @value_in_standard.setter
    def value_in_standard(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "value_in_standard", value)


@pulumi.input_type
class ReplicationConfigurationDestinationArgs:
    def __init__(__self__, *,
                 availability_zone_name: Optional[pulumi.Input[str]] = None,
                 file_system_id: Optional[pulumi.Input[str]] = None,
                 kms_key_id: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] availability_zone_name: The availability zone in which the replica should be created. If specified, the replica will be created with One Zone storage. If omitted, regional storage will be used.
        :param pulumi.Input[str] kms_key_id: The Key ID, ARN, alias, or alias ARN of the KMS key that should be used to encrypt the replica file system. If omitted, the default KMS key for EFS `/aws/elasticfilesystem` will be used.
        :param pulumi.Input[str] region: The region in which the replica should be created.
        """
        ReplicationConfigurationDestinationArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_zone_name=availability_zone_name,
            file_system_id=file_system_id,
            kms_key_id=kms_key_id,
            region=region,
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_zone_name: Optional[pulumi.Input[str]] = None,
             file_system_id: Optional[pulumi.Input[str]] = None,
             kms_key_id: Optional[pulumi.Input[str]] = None,
             region: Optional[pulumi.Input[str]] = None,
             status: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_zone_name is None and 'availabilityZoneName' in kwargs:
            availability_zone_name = kwargs['availabilityZoneName']
        if file_system_id is None and 'fileSystemId' in kwargs:
            file_system_id = kwargs['fileSystemId']
        if kms_key_id is None and 'kmsKeyId' in kwargs:
            kms_key_id = kwargs['kmsKeyId']

        if availability_zone_name is not None:
            _setter("availability_zone_name", availability_zone_name)
        if file_system_id is not None:
            _setter("file_system_id", file_system_id)
        if kms_key_id is not None:
            _setter("kms_key_id", kms_key_id)
        if region is not None:
            _setter("region", region)
        if status is not None:
            _setter("status", status)

    @property
    @pulumi.getter(name="availabilityZoneName")
    def availability_zone_name(self) -> Optional[pulumi.Input[str]]:
        """
        The availability zone in which the replica should be created. If specified, the replica will be created with One Zone storage. If omitted, regional storage will be used.
        """
        return pulumi.get(self, "availability_zone_name")

    @availability_zone_name.setter
    def availability_zone_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone_name", value)

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "file_system_id")

    @file_system_id.setter
    def file_system_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_system_id", value)

    @property
    @pulumi.getter(name="kmsKeyId")
    def kms_key_id(self) -> Optional[pulumi.Input[str]]:
        """
        The Key ID, ARN, alias, or alias ARN of the KMS key that should be used to encrypt the replica file system. If omitted, the default KMS key for EFS `/aws/elasticfilesystem` will be used.
        """
        return pulumi.get(self, "kms_key_id")

    @kms_key_id.setter
    def kms_key_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "kms_key_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which the replica should be created.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


