# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'PipelineContentConfigArgs',
    'PipelineContentConfigPermissionArgs',
    'PipelineNotificationsArgs',
    'PipelineThumbnailConfigArgs',
    'PipelineThumbnailConfigPermissionArgs',
    'PresetAudioArgs',
    'PresetAudioCodecOptionsArgs',
    'PresetThumbnailsArgs',
    'PresetVideoArgs',
    'PresetVideoWatermarkArgs',
]

@pulumi.input_type
class PipelineContentConfigArgs:
    def __init__(__self__, *,
                 bucket: Optional[pulumi.Input[str]] = None,
                 storage_class: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.
        :param pulumi.Input[str] storage_class: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the files and playlists that it stores in your Amazon S3 bucket.
        """
        PipelineContentConfigArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            storage_class=storage_class,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[pulumi.Input[str]] = None,
             storage_class: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if storage_class is None and 'storageClass' in kwargs:
            storage_class = kwargs['storageClass']

        if bucket is not None:
            _setter("bucket", bucket)
        if storage_class is not None:
            _setter("storage_class", storage_class)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter(name="storageClass")
    def storage_class(self) -> Optional[pulumi.Input[str]]:
        """
        The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the files and playlists that it stores in your Amazon S3 bucket.
        """
        return pulumi.get(self, "storage_class")

    @storage_class.setter
    def storage_class(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "storage_class", value)


@pulumi.input_type
class PipelineContentConfigPermissionArgs:
    def __init__(__self__, *,
                 accesses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 grantee: Optional[pulumi.Input[str]] = None,
                 grantee_type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input[str]]] accesses: The permission that you want to give to the AWS user that you specified in `content_config_permissions.grantee`. Valid values are `Read`, `ReadAcp`, `WriteAcp` or `FullControl`.
        :param pulumi.Input[str] grantee: The AWS user or group that you want to have access to transcoded files and playlists.
        :param pulumi.Input[str] grantee_type: Specify the type of value that appears in the `content_config_permissions.grantee` object. Valid values are `Canonical`, `Email` or `Group`.
        """
        PipelineContentConfigPermissionArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            accesses=accesses,
            grantee=grantee,
            grantee_type=grantee_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             accesses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             grantee: Optional[pulumi.Input[str]] = None,
             grantee_type: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if grantee_type is None and 'granteeType' in kwargs:
            grantee_type = kwargs['granteeType']

        if accesses is not None:
            _setter("accesses", accesses)
        if grantee is not None:
            _setter("grantee", grantee)
        if grantee_type is not None:
            _setter("grantee_type", grantee_type)

    @property
    @pulumi.getter
    def accesses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The permission that you want to give to the AWS user that you specified in `content_config_permissions.grantee`. Valid values are `Read`, `ReadAcp`, `WriteAcp` or `FullControl`.
        """
        return pulumi.get(self, "accesses")

    @accesses.setter
    def accesses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "accesses", value)

    @property
    @pulumi.getter
    def grantee(self) -> Optional[pulumi.Input[str]]:
        """
        The AWS user or group that you want to have access to transcoded files and playlists.
        """
        return pulumi.get(self, "grantee")

    @grantee.setter
    def grantee(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "grantee", value)

    @property
    @pulumi.getter(name="granteeType")
    def grantee_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specify the type of value that appears in the `content_config_permissions.grantee` object. Valid values are `Canonical`, `Email` or `Group`.
        """
        return pulumi.get(self, "grantee_type")

    @grantee_type.setter
    def grantee_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "grantee_type", value)


@pulumi.input_type
class PipelineNotificationsArgs:
    def __init__(__self__, *,
                 completed: Optional[pulumi.Input[str]] = None,
                 error: Optional[pulumi.Input[str]] = None,
                 progressing: Optional[pulumi.Input[str]] = None,
                 warning: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline.
        :param pulumi.Input[str] error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline.
        :param pulumi.Input[str] progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline.
        :param pulumi.Input[str] warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline.
               
               The `thumbnail_config` object specifies information about the Amazon S3 bucket in
               which you want Elastic Transcoder to save thumbnail files: which bucket to use,
               which users you want to have access to the files, the type of access you want
               users to have, and the storage class that you want to assign to the files. If
               you specify values for `content_config`, you must also specify values for
               `thumbnail_config` even if you don't want to create thumbnails. (You control
               whether to create thumbnails when you create a job. For more information, see
               ThumbnailPattern in the topic Create Job.) If you specify values for
               `content_config` and `thumbnail_config`, omit the OutputBucket object.
        """
        PipelineNotificationsArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            completed=completed,
            error=error,
            progressing=progressing,
            warning=warning,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             completed: Optional[pulumi.Input[str]] = None,
             error: Optional[pulumi.Input[str]] = None,
             progressing: Optional[pulumi.Input[str]] = None,
             warning: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if completed is not None:
            _setter("completed", completed)
        if error is not None:
            _setter("error", error)
        if progressing is not None:
            _setter("progressing", progressing)
        if warning is not None:
            _setter("warning", warning)

    @property
    @pulumi.getter
    def completed(self) -> Optional[pulumi.Input[str]]:
        """
        The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline.
        """
        return pulumi.get(self, "completed")

    @completed.setter
    def completed(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "completed", value)

    @property
    @pulumi.getter
    def error(self) -> Optional[pulumi.Input[str]]:
        """
        The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline.
        """
        return pulumi.get(self, "error")

    @error.setter
    def error(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "error", value)

    @property
    @pulumi.getter
    def progressing(self) -> Optional[pulumi.Input[str]]:
        """
        The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline.
        """
        return pulumi.get(self, "progressing")

    @progressing.setter
    def progressing(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "progressing", value)

    @property
    @pulumi.getter
    def warning(self) -> Optional[pulumi.Input[str]]:
        """
        The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline.

        The `thumbnail_config` object specifies information about the Amazon S3 bucket in
        which you want Elastic Transcoder to save thumbnail files: which bucket to use,
        which users you want to have access to the files, the type of access you want
        users to have, and the storage class that you want to assign to the files. If
        you specify values for `content_config`, you must also specify values for
        `thumbnail_config` even if you don't want to create thumbnails. (You control
        whether to create thumbnails when you create a job. For more information, see
        ThumbnailPattern in the topic Create Job.) If you specify values for
        `content_config` and `thumbnail_config`, omit the OutputBucket object.
        """
        return pulumi.get(self, "warning")

    @warning.setter
    def warning(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "warning", value)


@pulumi.input_type
class PipelineThumbnailConfigArgs:
    def __init__(__self__, *,
                 bucket: Optional[pulumi.Input[str]] = None,
                 storage_class: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.
        :param pulumi.Input[str] storage_class: The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.
        """
        PipelineThumbnailConfigArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            storage_class=storage_class,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[pulumi.Input[str]] = None,
             storage_class: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if storage_class is None and 'storageClass' in kwargs:
            storage_class = kwargs['storageClass']

        if bucket is not None:
            _setter("bucket", bucket)
        if storage_class is not None:
            _setter("storage_class", storage_class)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter(name="storageClass")
    def storage_class(self) -> Optional[pulumi.Input[str]]:
        """
        The Amazon S3 storage class, Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.
        """
        return pulumi.get(self, "storage_class")

    @storage_class.setter
    def storage_class(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "storage_class", value)


@pulumi.input_type
class PipelineThumbnailConfigPermissionArgs:
    def __init__(__self__, *,
                 accesses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 grantee: Optional[pulumi.Input[str]] = None,
                 grantee_type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input[str]]] accesses: The permission that you want to give to the AWS user that you specified in `thumbnail_config_permissions.grantee`. Valid values are `Read`, `ReadAcp`, `WriteAcp` or `FullControl`.
        :param pulumi.Input[str] grantee: The AWS user or group that you want to have access to thumbnail files.
        :param pulumi.Input[str] grantee_type: Specify the type of value that appears in the `thumbnail_config_permissions.grantee` object. Valid values are `Canonical`, `Email` or `Group`.
        """
        PipelineThumbnailConfigPermissionArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            accesses=accesses,
            grantee=grantee,
            grantee_type=grantee_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             accesses: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             grantee: Optional[pulumi.Input[str]] = None,
             grantee_type: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if grantee_type is None and 'granteeType' in kwargs:
            grantee_type = kwargs['granteeType']

        if accesses is not None:
            _setter("accesses", accesses)
        if grantee is not None:
            _setter("grantee", grantee)
        if grantee_type is not None:
            _setter("grantee_type", grantee_type)

    @property
    @pulumi.getter
    def accesses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The permission that you want to give to the AWS user that you specified in `thumbnail_config_permissions.grantee`. Valid values are `Read`, `ReadAcp`, `WriteAcp` or `FullControl`.
        """
        return pulumi.get(self, "accesses")

    @accesses.setter
    def accesses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "accesses", value)

    @property
    @pulumi.getter
    def grantee(self) -> Optional[pulumi.Input[str]]:
        """
        The AWS user or group that you want to have access to thumbnail files.
        """
        return pulumi.get(self, "grantee")

    @grantee.setter
    def grantee(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "grantee", value)

    @property
    @pulumi.getter(name="granteeType")
    def grantee_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specify the type of value that appears in the `thumbnail_config_permissions.grantee` object. Valid values are `Canonical`, `Email` or `Group`.
        """
        return pulumi.get(self, "grantee_type")

    @grantee_type.setter
    def grantee_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "grantee_type", value)


@pulumi.input_type
class PresetAudioArgs:
    def __init__(__self__, *,
                 audio_packing_mode: Optional[pulumi.Input[str]] = None,
                 bit_rate: Optional[pulumi.Input[str]] = None,
                 channels: Optional[pulumi.Input[str]] = None,
                 codec: Optional[pulumi.Input[str]] = None,
                 sample_rate: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] audio_packing_mode: The method of organizing audio channels and tracks. Use Audio:Channels to specify the number of channels in your output, and Audio:AudioPackingMode to specify the number of tracks and their relation to the channels. If you do not specify an Audio:AudioPackingMode, Elastic Transcoder uses SingleTrack.
        :param pulumi.Input[str] bit_rate: The bit rate of the audio stream in the output file, in kilobits/second. Enter an integer between 64 and 320, inclusive.
        :param pulumi.Input[str] channels: The number of audio channels in the output file
        :param pulumi.Input[str] codec: The audio codec for the output file. Valid values are `AAC`, `flac`, `mp2`, `mp3`, `pcm`, and `vorbis`.
        :param pulumi.Input[str] sample_rate: The sample rate of the audio stream in the output file, in hertz. Valid values are: `auto`, `22050`, `32000`, `44100`, `48000`, `96000`
        """
        PresetAudioArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            audio_packing_mode=audio_packing_mode,
            bit_rate=bit_rate,
            channels=channels,
            codec=codec,
            sample_rate=sample_rate,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             audio_packing_mode: Optional[pulumi.Input[str]] = None,
             bit_rate: Optional[pulumi.Input[str]] = None,
             channels: Optional[pulumi.Input[str]] = None,
             codec: Optional[pulumi.Input[str]] = None,
             sample_rate: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if audio_packing_mode is None and 'audioPackingMode' in kwargs:
            audio_packing_mode = kwargs['audioPackingMode']
        if bit_rate is None and 'bitRate' in kwargs:
            bit_rate = kwargs['bitRate']
        if sample_rate is None and 'sampleRate' in kwargs:
            sample_rate = kwargs['sampleRate']

        if audio_packing_mode is not None:
            _setter("audio_packing_mode", audio_packing_mode)
        if bit_rate is not None:
            _setter("bit_rate", bit_rate)
        if channels is not None:
            _setter("channels", channels)
        if codec is not None:
            _setter("codec", codec)
        if sample_rate is not None:
            _setter("sample_rate", sample_rate)

    @property
    @pulumi.getter(name="audioPackingMode")
    def audio_packing_mode(self) -> Optional[pulumi.Input[str]]:
        """
        The method of organizing audio channels and tracks. Use Audio:Channels to specify the number of channels in your output, and Audio:AudioPackingMode to specify the number of tracks and their relation to the channels. If you do not specify an Audio:AudioPackingMode, Elastic Transcoder uses SingleTrack.
        """
        return pulumi.get(self, "audio_packing_mode")

    @audio_packing_mode.setter
    def audio_packing_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "audio_packing_mode", value)

    @property
    @pulumi.getter(name="bitRate")
    def bit_rate(self) -> Optional[pulumi.Input[str]]:
        """
        The bit rate of the audio stream in the output file, in kilobits/second. Enter an integer between 64 and 320, inclusive.
        """
        return pulumi.get(self, "bit_rate")

    @bit_rate.setter
    def bit_rate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bit_rate", value)

    @property
    @pulumi.getter
    def channels(self) -> Optional[pulumi.Input[str]]:
        """
        The number of audio channels in the output file
        """
        return pulumi.get(self, "channels")

    @channels.setter
    def channels(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "channels", value)

    @property
    @pulumi.getter
    def codec(self) -> Optional[pulumi.Input[str]]:
        """
        The audio codec for the output file. Valid values are `AAC`, `flac`, `mp2`, `mp3`, `pcm`, and `vorbis`.
        """
        return pulumi.get(self, "codec")

    @codec.setter
    def codec(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "codec", value)

    @property
    @pulumi.getter(name="sampleRate")
    def sample_rate(self) -> Optional[pulumi.Input[str]]:
        """
        The sample rate of the audio stream in the output file, in hertz. Valid values are: `auto`, `22050`, `32000`, `44100`, `48000`, `96000`
        """
        return pulumi.get(self, "sample_rate")

    @sample_rate.setter
    def sample_rate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sample_rate", value)


@pulumi.input_type
class PresetAudioCodecOptionsArgs:
    def __init__(__self__, *,
                 bit_depth: Optional[pulumi.Input[str]] = None,
                 bit_order: Optional[pulumi.Input[str]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 signed: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] bit_depth: The bit depth of a sample is how many bits of information are included in the audio samples. Valid values are `16` and `24`. (FLAC/PCM Only)
        :param pulumi.Input[str] bit_order: The order the bits of a PCM sample are stored in. The supported value is LittleEndian. (PCM Only)
        :param pulumi.Input[str] profile: If you specified AAC for Audio:Codec, choose the AAC profile for the output file.
        :param pulumi.Input[str] signed: Whether audio samples are represented with negative and positive numbers (signed) or only positive numbers (unsigned). The supported value is Signed. (PCM Only)
        """
        PresetAudioCodecOptionsArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bit_depth=bit_depth,
            bit_order=bit_order,
            profile=profile,
            signed=signed,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bit_depth: Optional[pulumi.Input[str]] = None,
             bit_order: Optional[pulumi.Input[str]] = None,
             profile: Optional[pulumi.Input[str]] = None,
             signed: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if bit_depth is None and 'bitDepth' in kwargs:
            bit_depth = kwargs['bitDepth']
        if bit_order is None and 'bitOrder' in kwargs:
            bit_order = kwargs['bitOrder']

        if bit_depth is not None:
            _setter("bit_depth", bit_depth)
        if bit_order is not None:
            _setter("bit_order", bit_order)
        if profile is not None:
            _setter("profile", profile)
        if signed is not None:
            _setter("signed", signed)

    @property
    @pulumi.getter(name="bitDepth")
    def bit_depth(self) -> Optional[pulumi.Input[str]]:
        """
        The bit depth of a sample is how many bits of information are included in the audio samples. Valid values are `16` and `24`. (FLAC/PCM Only)
        """
        return pulumi.get(self, "bit_depth")

    @bit_depth.setter
    def bit_depth(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bit_depth", value)

    @property
    @pulumi.getter(name="bitOrder")
    def bit_order(self) -> Optional[pulumi.Input[str]]:
        """
        The order the bits of a PCM sample are stored in. The supported value is LittleEndian. (PCM Only)
        """
        return pulumi.get(self, "bit_order")

    @bit_order.setter
    def bit_order(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bit_order", value)

    @property
    @pulumi.getter
    def profile(self) -> Optional[pulumi.Input[str]]:
        """
        If you specified AAC for Audio:Codec, choose the AAC profile for the output file.
        """
        return pulumi.get(self, "profile")

    @profile.setter
    def profile(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile", value)

    @property
    @pulumi.getter
    def signed(self) -> Optional[pulumi.Input[str]]:
        """
        Whether audio samples are represented with negative and positive numbers (signed) or only positive numbers (unsigned). The supported value is Signed. (PCM Only)
        """
        return pulumi.get(self, "signed")

    @signed.setter
    def signed(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "signed", value)


@pulumi.input_type
class PresetThumbnailsArgs:
    def __init__(__self__, *,
                 aspect_ratio: Optional[pulumi.Input[str]] = None,
                 format: Optional[pulumi.Input[str]] = None,
                 interval: Optional[pulumi.Input[str]] = None,
                 max_height: Optional[pulumi.Input[str]] = None,
                 max_width: Optional[pulumi.Input[str]] = None,
                 padding_policy: Optional[pulumi.Input[str]] = None,
                 resolution: Optional[pulumi.Input[str]] = None,
                 sizing_policy: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] aspect_ratio: The aspect ratio of thumbnails. The following values are valid: auto, 1:1, 4:3, 3:2, 16:9
        :param pulumi.Input[str] format: The format of thumbnails, if any. Valid formats are jpg and png.
        :param pulumi.Input[str] interval: The approximate number of seconds between thumbnails. The value must be an integer. The actual interval can vary by several seconds from one thumbnail to the next.
        :param pulumi.Input[str] max_height: The maximum height of thumbnails, in pixels. If you specify auto, Elastic Transcoder uses 1080 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 32 and 3072, inclusive.
        :param pulumi.Input[str] max_width: The maximum width of thumbnails, in pixels. If you specify auto, Elastic Transcoder uses 1920 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 32 and 4096, inclusive.
        :param pulumi.Input[str] padding_policy: When you set PaddingPolicy to Pad, Elastic Transcoder might add black bars to the top and bottom and/or left and right sides of thumbnails to make the total size of the thumbnails match the values that you specified for thumbnail MaxWidth and MaxHeight settings.
        :param pulumi.Input[str] resolution: The width and height of thumbnail files in pixels, in the format WidthxHeight, where both values are even integers. The values cannot exceed the width and height that you specified in the Video:Resolution object. (To better control resolution and aspect ratio of thumbnails, we recommend that you use the thumbnail values `max_width`, `max_height`, `sizing_policy`, and `padding_policy` instead of `resolution` and `aspect_ratio`. The two groups of settings are mutually exclusive. Do not use them together)
        :param pulumi.Input[str] sizing_policy: A value that controls scaling of thumbnails. Valid values are: `Fit`, `Fill`, `Stretch`, `Keep`, `ShrinkToFit`, and `ShrinkToFill`.
        """
        PresetThumbnailsArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            aspect_ratio=aspect_ratio,
            format=format,
            interval=interval,
            max_height=max_height,
            max_width=max_width,
            padding_policy=padding_policy,
            resolution=resolution,
            sizing_policy=sizing_policy,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             aspect_ratio: Optional[pulumi.Input[str]] = None,
             format: Optional[pulumi.Input[str]] = None,
             interval: Optional[pulumi.Input[str]] = None,
             max_height: Optional[pulumi.Input[str]] = None,
             max_width: Optional[pulumi.Input[str]] = None,
             padding_policy: Optional[pulumi.Input[str]] = None,
             resolution: Optional[pulumi.Input[str]] = None,
             sizing_policy: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if aspect_ratio is None and 'aspectRatio' in kwargs:
            aspect_ratio = kwargs['aspectRatio']
        if max_height is None and 'maxHeight' in kwargs:
            max_height = kwargs['maxHeight']
        if max_width is None and 'maxWidth' in kwargs:
            max_width = kwargs['maxWidth']
        if padding_policy is None and 'paddingPolicy' in kwargs:
            padding_policy = kwargs['paddingPolicy']
        if sizing_policy is None and 'sizingPolicy' in kwargs:
            sizing_policy = kwargs['sizingPolicy']

        if aspect_ratio is not None:
            _setter("aspect_ratio", aspect_ratio)
        if format is not None:
            _setter("format", format)
        if interval is not None:
            _setter("interval", interval)
        if max_height is not None:
            _setter("max_height", max_height)
        if max_width is not None:
            _setter("max_width", max_width)
        if padding_policy is not None:
            _setter("padding_policy", padding_policy)
        if resolution is not None:
            _setter("resolution", resolution)
        if sizing_policy is not None:
            _setter("sizing_policy", sizing_policy)

    @property
    @pulumi.getter(name="aspectRatio")
    def aspect_ratio(self) -> Optional[pulumi.Input[str]]:
        """
        The aspect ratio of thumbnails. The following values are valid: auto, 1:1, 4:3, 3:2, 16:9
        """
        return pulumi.get(self, "aspect_ratio")

    @aspect_ratio.setter
    def aspect_ratio(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "aspect_ratio", value)

    @property
    @pulumi.getter
    def format(self) -> Optional[pulumi.Input[str]]:
        """
        The format of thumbnails, if any. Valid formats are jpg and png.
        """
        return pulumi.get(self, "format")

    @format.setter
    def format(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "format", value)

    @property
    @pulumi.getter
    def interval(self) -> Optional[pulumi.Input[str]]:
        """
        The approximate number of seconds between thumbnails. The value must be an integer. The actual interval can vary by several seconds from one thumbnail to the next.
        """
        return pulumi.get(self, "interval")

    @interval.setter
    def interval(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "interval", value)

    @property
    @pulumi.getter(name="maxHeight")
    def max_height(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum height of thumbnails, in pixels. If you specify auto, Elastic Transcoder uses 1080 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 32 and 3072, inclusive.
        """
        return pulumi.get(self, "max_height")

    @max_height.setter
    def max_height(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_height", value)

    @property
    @pulumi.getter(name="maxWidth")
    def max_width(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum width of thumbnails, in pixels. If you specify auto, Elastic Transcoder uses 1920 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 32 and 4096, inclusive.
        """
        return pulumi.get(self, "max_width")

    @max_width.setter
    def max_width(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_width", value)

    @property
    @pulumi.getter(name="paddingPolicy")
    def padding_policy(self) -> Optional[pulumi.Input[str]]:
        """
        When you set PaddingPolicy to Pad, Elastic Transcoder might add black bars to the top and bottom and/or left and right sides of thumbnails to make the total size of the thumbnails match the values that you specified for thumbnail MaxWidth and MaxHeight settings.
        """
        return pulumi.get(self, "padding_policy")

    @padding_policy.setter
    def padding_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "padding_policy", value)

    @property
    @pulumi.getter
    def resolution(self) -> Optional[pulumi.Input[str]]:
        """
        The width and height of thumbnail files in pixels, in the format WidthxHeight, where both values are even integers. The values cannot exceed the width and height that you specified in the Video:Resolution object. (To better control resolution and aspect ratio of thumbnails, we recommend that you use the thumbnail values `max_width`, `max_height`, `sizing_policy`, and `padding_policy` instead of `resolution` and `aspect_ratio`. The two groups of settings are mutually exclusive. Do not use them together)
        """
        return pulumi.get(self, "resolution")

    @resolution.setter
    def resolution(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resolution", value)

    @property
    @pulumi.getter(name="sizingPolicy")
    def sizing_policy(self) -> Optional[pulumi.Input[str]]:
        """
        A value that controls scaling of thumbnails. Valid values are: `Fit`, `Fill`, `Stretch`, `Keep`, `ShrinkToFit`, and `ShrinkToFill`.
        """
        return pulumi.get(self, "sizing_policy")

    @sizing_policy.setter
    def sizing_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sizing_policy", value)


@pulumi.input_type
class PresetVideoArgs:
    def __init__(__self__, *,
                 aspect_ratio: Optional[pulumi.Input[str]] = None,
                 bit_rate: Optional[pulumi.Input[str]] = None,
                 codec: Optional[pulumi.Input[str]] = None,
                 display_aspect_ratio: Optional[pulumi.Input[str]] = None,
                 fixed_gop: Optional[pulumi.Input[str]] = None,
                 frame_rate: Optional[pulumi.Input[str]] = None,
                 keyframes_max_dist: Optional[pulumi.Input[str]] = None,
                 max_frame_rate: Optional[pulumi.Input[str]] = None,
                 max_height: Optional[pulumi.Input[str]] = None,
                 max_width: Optional[pulumi.Input[str]] = None,
                 padding_policy: Optional[pulumi.Input[str]] = None,
                 resolution: Optional[pulumi.Input[str]] = None,
                 sizing_policy: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] aspect_ratio: The display aspect ratio of the video in the output file. Valid values are: `auto`, `1:1`, `4:3`, `3:2`, `16:9`. (Note; to better control resolution and aspect ratio of output videos, we recommend that you use the values `max_width`, `max_height`, `sizing_policy`, `padding_policy`, and `display_aspect_ratio` instead of `resolution` and `aspect_ratio`.)
        :param pulumi.Input[str] bit_rate: The bit rate of the video stream in the output file, in kilobits/second. You can configure variable bit rate or constant bit rate encoding.
        :param pulumi.Input[str] codec: The video codec for the output file. Valid values are `gif`, `H.264`, `mpeg2`, `vp8`, and `vp9`.
        :param pulumi.Input[str] display_aspect_ratio: The value that Elastic Transcoder adds to the metadata in the output file. If you set DisplayAspectRatio to auto, Elastic Transcoder chooses an aspect ratio that ensures square pixels. If you specify another option, Elastic Transcoder sets that value in the output file.
        :param pulumi.Input[str] fixed_gop: Whether to use a fixed value for Video:FixedGOP. Not applicable for containers of type gif. Valid values are true and false. Also known as, Fixed Number of Frames Between Keyframes.
        :param pulumi.Input[str] frame_rate: The frames per second for the video stream in the output file. The following values are valid: `auto`, `10`, `15`, `23.97`, `24`, `25`, `29.97`, `30`, `50`, `60`.
        :param pulumi.Input[str] keyframes_max_dist: The maximum number of frames between key frames. Not applicable for containers of type gif.
        :param pulumi.Input[str] max_frame_rate: If you specify auto for FrameRate, Elastic Transcoder uses the frame rate of the input video for the frame rate of the output video, up to the maximum frame rate. If you do not specify a MaxFrameRate, Elastic Transcoder will use a default of 30.
        :param pulumi.Input[str] max_height: The maximum height of the output video in pixels. If you specify auto, Elastic Transcoder uses 1080 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 96 and 3072, inclusive.
        :param pulumi.Input[str] max_width: The maximum width of the output video in pixels. If you specify auto, Elastic Transcoder uses 1920 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 128 and 4096, inclusive.
        :param pulumi.Input[str] padding_policy: When you set PaddingPolicy to Pad, Elastic Transcoder might add black bars to the top and bottom and/or left and right sides of the output video to make the total size of the output video match the values that you specified for `max_width` and `max_height`.
        :param pulumi.Input[str] resolution: The width and height of the video in the output file, in pixels. Valid values are `auto` and `widthxheight`. (see note for `aspect_ratio`)
        :param pulumi.Input[str] sizing_policy: A value that controls scaling of the output video. Valid values are: `Fit`, `Fill`, `Stretch`, `Keep`, `ShrinkToFit`, `ShrinkToFill`.
        """
        PresetVideoArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            aspect_ratio=aspect_ratio,
            bit_rate=bit_rate,
            codec=codec,
            display_aspect_ratio=display_aspect_ratio,
            fixed_gop=fixed_gop,
            frame_rate=frame_rate,
            keyframes_max_dist=keyframes_max_dist,
            max_frame_rate=max_frame_rate,
            max_height=max_height,
            max_width=max_width,
            padding_policy=padding_policy,
            resolution=resolution,
            sizing_policy=sizing_policy,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             aspect_ratio: Optional[pulumi.Input[str]] = None,
             bit_rate: Optional[pulumi.Input[str]] = None,
             codec: Optional[pulumi.Input[str]] = None,
             display_aspect_ratio: Optional[pulumi.Input[str]] = None,
             fixed_gop: Optional[pulumi.Input[str]] = None,
             frame_rate: Optional[pulumi.Input[str]] = None,
             keyframes_max_dist: Optional[pulumi.Input[str]] = None,
             max_frame_rate: Optional[pulumi.Input[str]] = None,
             max_height: Optional[pulumi.Input[str]] = None,
             max_width: Optional[pulumi.Input[str]] = None,
             padding_policy: Optional[pulumi.Input[str]] = None,
             resolution: Optional[pulumi.Input[str]] = None,
             sizing_policy: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if aspect_ratio is None and 'aspectRatio' in kwargs:
            aspect_ratio = kwargs['aspectRatio']
        if bit_rate is None and 'bitRate' in kwargs:
            bit_rate = kwargs['bitRate']
        if display_aspect_ratio is None and 'displayAspectRatio' in kwargs:
            display_aspect_ratio = kwargs['displayAspectRatio']
        if fixed_gop is None and 'fixedGop' in kwargs:
            fixed_gop = kwargs['fixedGop']
        if frame_rate is None and 'frameRate' in kwargs:
            frame_rate = kwargs['frameRate']
        if keyframes_max_dist is None and 'keyframesMaxDist' in kwargs:
            keyframes_max_dist = kwargs['keyframesMaxDist']
        if max_frame_rate is None and 'maxFrameRate' in kwargs:
            max_frame_rate = kwargs['maxFrameRate']
        if max_height is None and 'maxHeight' in kwargs:
            max_height = kwargs['maxHeight']
        if max_width is None and 'maxWidth' in kwargs:
            max_width = kwargs['maxWidth']
        if padding_policy is None and 'paddingPolicy' in kwargs:
            padding_policy = kwargs['paddingPolicy']
        if sizing_policy is None and 'sizingPolicy' in kwargs:
            sizing_policy = kwargs['sizingPolicy']

        if aspect_ratio is not None:
            _setter("aspect_ratio", aspect_ratio)
        if bit_rate is not None:
            _setter("bit_rate", bit_rate)
        if codec is not None:
            _setter("codec", codec)
        if display_aspect_ratio is not None:
            _setter("display_aspect_ratio", display_aspect_ratio)
        if fixed_gop is not None:
            _setter("fixed_gop", fixed_gop)
        if frame_rate is not None:
            _setter("frame_rate", frame_rate)
        if keyframes_max_dist is not None:
            _setter("keyframes_max_dist", keyframes_max_dist)
        if max_frame_rate is not None:
            _setter("max_frame_rate", max_frame_rate)
        if max_height is not None:
            _setter("max_height", max_height)
        if max_width is not None:
            _setter("max_width", max_width)
        if padding_policy is not None:
            _setter("padding_policy", padding_policy)
        if resolution is not None:
            _setter("resolution", resolution)
        if sizing_policy is not None:
            _setter("sizing_policy", sizing_policy)

    @property
    @pulumi.getter(name="aspectRatio")
    def aspect_ratio(self) -> Optional[pulumi.Input[str]]:
        """
        The display aspect ratio of the video in the output file. Valid values are: `auto`, `1:1`, `4:3`, `3:2`, `16:9`. (Note; to better control resolution and aspect ratio of output videos, we recommend that you use the values `max_width`, `max_height`, `sizing_policy`, `padding_policy`, and `display_aspect_ratio` instead of `resolution` and `aspect_ratio`.)
        """
        return pulumi.get(self, "aspect_ratio")

    @aspect_ratio.setter
    def aspect_ratio(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "aspect_ratio", value)

    @property
    @pulumi.getter(name="bitRate")
    def bit_rate(self) -> Optional[pulumi.Input[str]]:
        """
        The bit rate of the video stream in the output file, in kilobits/second. You can configure variable bit rate or constant bit rate encoding.
        """
        return pulumi.get(self, "bit_rate")

    @bit_rate.setter
    def bit_rate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bit_rate", value)

    @property
    @pulumi.getter
    def codec(self) -> Optional[pulumi.Input[str]]:
        """
        The video codec for the output file. Valid values are `gif`, `H.264`, `mpeg2`, `vp8`, and `vp9`.
        """
        return pulumi.get(self, "codec")

    @codec.setter
    def codec(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "codec", value)

    @property
    @pulumi.getter(name="displayAspectRatio")
    def display_aspect_ratio(self) -> Optional[pulumi.Input[str]]:
        """
        The value that Elastic Transcoder adds to the metadata in the output file. If you set DisplayAspectRatio to auto, Elastic Transcoder chooses an aspect ratio that ensures square pixels. If you specify another option, Elastic Transcoder sets that value in the output file.
        """
        return pulumi.get(self, "display_aspect_ratio")

    @display_aspect_ratio.setter
    def display_aspect_ratio(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_aspect_ratio", value)

    @property
    @pulumi.getter(name="fixedGop")
    def fixed_gop(self) -> Optional[pulumi.Input[str]]:
        """
        Whether to use a fixed value for Video:FixedGOP. Not applicable for containers of type gif. Valid values are true and false. Also known as, Fixed Number of Frames Between Keyframes.
        """
        return pulumi.get(self, "fixed_gop")

    @fixed_gop.setter
    def fixed_gop(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fixed_gop", value)

    @property
    @pulumi.getter(name="frameRate")
    def frame_rate(self) -> Optional[pulumi.Input[str]]:
        """
        The frames per second for the video stream in the output file. The following values are valid: `auto`, `10`, `15`, `23.97`, `24`, `25`, `29.97`, `30`, `50`, `60`.
        """
        return pulumi.get(self, "frame_rate")

    @frame_rate.setter
    def frame_rate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "frame_rate", value)

    @property
    @pulumi.getter(name="keyframesMaxDist")
    def keyframes_max_dist(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum number of frames between key frames. Not applicable for containers of type gif.
        """
        return pulumi.get(self, "keyframes_max_dist")

    @keyframes_max_dist.setter
    def keyframes_max_dist(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "keyframes_max_dist", value)

    @property
    @pulumi.getter(name="maxFrameRate")
    def max_frame_rate(self) -> Optional[pulumi.Input[str]]:
        """
        If you specify auto for FrameRate, Elastic Transcoder uses the frame rate of the input video for the frame rate of the output video, up to the maximum frame rate. If you do not specify a MaxFrameRate, Elastic Transcoder will use a default of 30.
        """
        return pulumi.get(self, "max_frame_rate")

    @max_frame_rate.setter
    def max_frame_rate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_frame_rate", value)

    @property
    @pulumi.getter(name="maxHeight")
    def max_height(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum height of the output video in pixels. If you specify auto, Elastic Transcoder uses 1080 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 96 and 3072, inclusive.
        """
        return pulumi.get(self, "max_height")

    @max_height.setter
    def max_height(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_height", value)

    @property
    @pulumi.getter(name="maxWidth")
    def max_width(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum width of the output video in pixels. If you specify auto, Elastic Transcoder uses 1920 (Full HD) as the default value. If you specify a numeric value, enter an even integer between 128 and 4096, inclusive.
        """
        return pulumi.get(self, "max_width")

    @max_width.setter
    def max_width(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_width", value)

    @property
    @pulumi.getter(name="paddingPolicy")
    def padding_policy(self) -> Optional[pulumi.Input[str]]:
        """
        When you set PaddingPolicy to Pad, Elastic Transcoder might add black bars to the top and bottom and/or left and right sides of the output video to make the total size of the output video match the values that you specified for `max_width` and `max_height`.
        """
        return pulumi.get(self, "padding_policy")

    @padding_policy.setter
    def padding_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "padding_policy", value)

    @property
    @pulumi.getter
    def resolution(self) -> Optional[pulumi.Input[str]]:
        """
        The width and height of the video in the output file, in pixels. Valid values are `auto` and `widthxheight`. (see note for `aspect_ratio`)
        """
        return pulumi.get(self, "resolution")

    @resolution.setter
    def resolution(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resolution", value)

    @property
    @pulumi.getter(name="sizingPolicy")
    def sizing_policy(self) -> Optional[pulumi.Input[str]]:
        """
        A value that controls scaling of the output video. Valid values are: `Fit`, `Fill`, `Stretch`, `Keep`, `ShrinkToFit`, `ShrinkToFill`.
        """
        return pulumi.get(self, "sizing_policy")

    @sizing_policy.setter
    def sizing_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sizing_policy", value)


@pulumi.input_type
class PresetVideoWatermarkArgs:
    def __init__(__self__, *,
                 horizontal_align: Optional[pulumi.Input[str]] = None,
                 horizontal_offset: Optional[pulumi.Input[str]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 max_height: Optional[pulumi.Input[str]] = None,
                 max_width: Optional[pulumi.Input[str]] = None,
                 opacity: Optional[pulumi.Input[str]] = None,
                 sizing_policy: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[str]] = None,
                 vertical_align: Optional[pulumi.Input[str]] = None,
                 vertical_offset: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] horizontal_align: The horizontal position of the watermark unless you specify a nonzero value for `horzontal_offset`.
        :param pulumi.Input[str] horizontal_offset: The amount by which you want the horizontal position of the watermark to be offset from the position specified by `horizontal_align`.
        :param pulumi.Input[str] id: A unique identifier for the settings for one watermark. The value of Id can be up to 40 characters long. You can specify settings for up to four watermarks.
        :param pulumi.Input[str] max_height: The maximum height of the watermark.
        :param pulumi.Input[str] max_width: The maximum width of the watermark.
        :param pulumi.Input[str] opacity: A percentage that indicates how much you want a watermark to obscure the video in the location where it appears.
        :param pulumi.Input[str] sizing_policy: A value that controls scaling of the watermark. Valid values are: `Fit`, `Stretch`, `ShrinkToFit`
        :param pulumi.Input[str] target: A value that determines how Elastic Transcoder interprets values that you specified for `video_watermarks.horizontal_offset`, `video_watermarks.vertical_offset`, `video_watermarks.max_width`, and `video_watermarks.max_height`. Valid values are `Content` and `Frame`.
        :param pulumi.Input[str] vertical_align: The vertical position of the watermark unless you specify a nonzero value for `vertical_align`. Valid values are `Top`, `Bottom`, `Center`.
        :param pulumi.Input[str] vertical_offset: The amount by which you want the vertical position of the watermark to be offset from the position specified by `vertical_align`
        """
        PresetVideoWatermarkArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            horizontal_align=horizontal_align,
            horizontal_offset=horizontal_offset,
            id=id,
            max_height=max_height,
            max_width=max_width,
            opacity=opacity,
            sizing_policy=sizing_policy,
            target=target,
            vertical_align=vertical_align,
            vertical_offset=vertical_offset,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             horizontal_align: Optional[pulumi.Input[str]] = None,
             horizontal_offset: Optional[pulumi.Input[str]] = None,
             id: Optional[pulumi.Input[str]] = None,
             max_height: Optional[pulumi.Input[str]] = None,
             max_width: Optional[pulumi.Input[str]] = None,
             opacity: Optional[pulumi.Input[str]] = None,
             sizing_policy: Optional[pulumi.Input[str]] = None,
             target: Optional[pulumi.Input[str]] = None,
             vertical_align: Optional[pulumi.Input[str]] = None,
             vertical_offset: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if horizontal_align is None and 'horizontalAlign' in kwargs:
            horizontal_align = kwargs['horizontalAlign']
        if horizontal_offset is None and 'horizontalOffset' in kwargs:
            horizontal_offset = kwargs['horizontalOffset']
        if max_height is None and 'maxHeight' in kwargs:
            max_height = kwargs['maxHeight']
        if max_width is None and 'maxWidth' in kwargs:
            max_width = kwargs['maxWidth']
        if sizing_policy is None and 'sizingPolicy' in kwargs:
            sizing_policy = kwargs['sizingPolicy']
        if vertical_align is None and 'verticalAlign' in kwargs:
            vertical_align = kwargs['verticalAlign']
        if vertical_offset is None and 'verticalOffset' in kwargs:
            vertical_offset = kwargs['verticalOffset']

        if horizontal_align is not None:
            _setter("horizontal_align", horizontal_align)
        if horizontal_offset is not None:
            _setter("horizontal_offset", horizontal_offset)
        if id is not None:
            _setter("id", id)
        if max_height is not None:
            _setter("max_height", max_height)
        if max_width is not None:
            _setter("max_width", max_width)
        if opacity is not None:
            _setter("opacity", opacity)
        if sizing_policy is not None:
            _setter("sizing_policy", sizing_policy)
        if target is not None:
            _setter("target", target)
        if vertical_align is not None:
            _setter("vertical_align", vertical_align)
        if vertical_offset is not None:
            _setter("vertical_offset", vertical_offset)

    @property
    @pulumi.getter(name="horizontalAlign")
    def horizontal_align(self) -> Optional[pulumi.Input[str]]:
        """
        The horizontal position of the watermark unless you specify a nonzero value for `horzontal_offset`.
        """
        return pulumi.get(self, "horizontal_align")

    @horizontal_align.setter
    def horizontal_align(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "horizontal_align", value)

    @property
    @pulumi.getter(name="horizontalOffset")
    def horizontal_offset(self) -> Optional[pulumi.Input[str]]:
        """
        The amount by which you want the horizontal position of the watermark to be offset from the position specified by `horizontal_align`.
        """
        return pulumi.get(self, "horizontal_offset")

    @horizontal_offset.setter
    def horizontal_offset(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "horizontal_offset", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for the settings for one watermark. The value of Id can be up to 40 characters long. You can specify settings for up to four watermarks.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="maxHeight")
    def max_height(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum height of the watermark.
        """
        return pulumi.get(self, "max_height")

    @max_height.setter
    def max_height(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_height", value)

    @property
    @pulumi.getter(name="maxWidth")
    def max_width(self) -> Optional[pulumi.Input[str]]:
        """
        The maximum width of the watermark.
        """
        return pulumi.get(self, "max_width")

    @max_width.setter
    def max_width(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max_width", value)

    @property
    @pulumi.getter
    def opacity(self) -> Optional[pulumi.Input[str]]:
        """
        A percentage that indicates how much you want a watermark to obscure the video in the location where it appears.
        """
        return pulumi.get(self, "opacity")

    @opacity.setter
    def opacity(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "opacity", value)

    @property
    @pulumi.getter(name="sizingPolicy")
    def sizing_policy(self) -> Optional[pulumi.Input[str]]:
        """
        A value that controls scaling of the watermark. Valid values are: `Fit`, `Stretch`, `ShrinkToFit`
        """
        return pulumi.get(self, "sizing_policy")

    @sizing_policy.setter
    def sizing_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sizing_policy", value)

    @property
    @pulumi.getter
    def target(self) -> Optional[pulumi.Input[str]]:
        """
        A value that determines how Elastic Transcoder interprets values that you specified for `video_watermarks.horizontal_offset`, `video_watermarks.vertical_offset`, `video_watermarks.max_width`, and `video_watermarks.max_height`. Valid values are `Content` and `Frame`.
        """
        return pulumi.get(self, "target")

    @target.setter
    def target(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target", value)

    @property
    @pulumi.getter(name="verticalAlign")
    def vertical_align(self) -> Optional[pulumi.Input[str]]:
        """
        The vertical position of the watermark unless you specify a nonzero value for `vertical_align`. Valid values are `Top`, `Bottom`, `Center`.
        """
        return pulumi.get(self, "vertical_align")

    @vertical_align.setter
    def vertical_align(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vertical_align", value)

    @property
    @pulumi.getter(name="verticalOffset")
    def vertical_offset(self) -> Optional[pulumi.Input[str]]:
        """
        The amount by which you want the vertical position of the watermark to be offset from the position specified by `vertical_align`
        """
        return pulumi.get(self, "vertical_offset")

    @vertical_offset.setter
    def vertical_offset(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vertical_offset", value)


