# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'LoadBalancerAccessLogs',
    'LoadBalancerHealthCheck',
    'LoadBalancerListener',
    'LoadBalancerPolicyPolicyAttribute',
    'SslNegotiationPolicyAttribute',
    'GetLoadBalancerAccessLogsResult',
    'GetLoadBalancerHealthCheckResult',
    'GetLoadBalancerListenerResult',
]

@pulumi.output_type
class LoadBalancerAccessLogs(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bucketPrefix":
            suggest = "bucket_prefix"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LoadBalancerAccessLogs. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LoadBalancerAccessLogs.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LoadBalancerAccessLogs.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bucket: str,
                 bucket_prefix: Optional[str] = None,
                 enabled: Optional[bool] = None,
                 interval: Optional[int] = None):
        """
        :param str bucket: The S3 bucket name to store the logs in.
        :param str bucket_prefix: The S3 bucket prefix. Logs are stored in the root if not configured.
        :param bool enabled: Boolean to enable / disable `access_logs`. Default is `true`
        :param int interval: The publishing interval in minutes. Valid values: `5` and `60`. Default: `60`
        """
        LoadBalancerAccessLogs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            bucket_prefix=bucket_prefix,
            enabled=enabled,
            interval=interval,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[str] = None,
             bucket_prefix: Optional[str] = None,
             enabled: Optional[bool] = None,
             interval: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if bucket is None:
            raise TypeError("Missing 'bucket' argument")
        if bucket_prefix is None and 'bucketPrefix' in kwargs:
            bucket_prefix = kwargs['bucketPrefix']

        _setter("bucket", bucket)
        if bucket_prefix is not None:
            _setter("bucket_prefix", bucket_prefix)
        if enabled is not None:
            _setter("enabled", enabled)
        if interval is not None:
            _setter("interval", interval)

    @property
    @pulumi.getter
    def bucket(self) -> str:
        """
        The S3 bucket name to store the logs in.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="bucketPrefix")
    def bucket_prefix(self) -> Optional[str]:
        """
        The S3 bucket prefix. Logs are stored in the root if not configured.
        """
        return pulumi.get(self, "bucket_prefix")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        """
        Boolean to enable / disable `access_logs`. Default is `true`
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def interval(self) -> Optional[int]:
        """
        The publishing interval in minutes. Valid values: `5` and `60`. Default: `60`
        """
        return pulumi.get(self, "interval")


@pulumi.output_type
class LoadBalancerHealthCheck(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "healthyThreshold":
            suggest = "healthy_threshold"
        elif key == "unhealthyThreshold":
            suggest = "unhealthy_threshold"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LoadBalancerHealthCheck. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LoadBalancerHealthCheck.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LoadBalancerHealthCheck.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 healthy_threshold: int,
                 interval: int,
                 target: str,
                 timeout: int,
                 unhealthy_threshold: int):
        """
        :param int healthy_threshold: The number of checks before the instance is declared healthy.
        :param int interval: The interval between checks.
        :param str target: The target of the check. Valid pattern is "${PROTOCOL}:${PORT}${PATH}", where PROTOCOL
               values are:
        :param int timeout: The length of time before the check times out.
        :param int unhealthy_threshold: The number of checks before the instance is declared unhealthy.
        """
        LoadBalancerHealthCheck._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            healthy_threshold=healthy_threshold,
            interval=interval,
            target=target,
            timeout=timeout,
            unhealthy_threshold=unhealthy_threshold,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             healthy_threshold: Optional[int] = None,
             interval: Optional[int] = None,
             target: Optional[str] = None,
             timeout: Optional[int] = None,
             unhealthy_threshold: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if healthy_threshold is None and 'healthyThreshold' in kwargs:
            healthy_threshold = kwargs['healthyThreshold']
        if healthy_threshold is None:
            raise TypeError("Missing 'healthy_threshold' argument")
        if interval is None:
            raise TypeError("Missing 'interval' argument")
        if target is None:
            raise TypeError("Missing 'target' argument")
        if timeout is None:
            raise TypeError("Missing 'timeout' argument")
        if unhealthy_threshold is None and 'unhealthyThreshold' in kwargs:
            unhealthy_threshold = kwargs['unhealthyThreshold']
        if unhealthy_threshold is None:
            raise TypeError("Missing 'unhealthy_threshold' argument")

        _setter("healthy_threshold", healthy_threshold)
        _setter("interval", interval)
        _setter("target", target)
        _setter("timeout", timeout)
        _setter("unhealthy_threshold", unhealthy_threshold)

    @property
    @pulumi.getter(name="healthyThreshold")
    def healthy_threshold(self) -> int:
        """
        The number of checks before the instance is declared healthy.
        """
        return pulumi.get(self, "healthy_threshold")

    @property
    @pulumi.getter
    def interval(self) -> int:
        """
        The interval between checks.
        """
        return pulumi.get(self, "interval")

    @property
    @pulumi.getter
    def target(self) -> str:
        """
        The target of the check. Valid pattern is "${PROTOCOL}:${PORT}${PATH}", where PROTOCOL
        values are:
        """
        return pulumi.get(self, "target")

    @property
    @pulumi.getter
    def timeout(self) -> int:
        """
        The length of time before the check times out.
        """
        return pulumi.get(self, "timeout")

    @property
    @pulumi.getter(name="unhealthyThreshold")
    def unhealthy_threshold(self) -> int:
        """
        The number of checks before the instance is declared unhealthy.
        """
        return pulumi.get(self, "unhealthy_threshold")


@pulumi.output_type
class LoadBalancerListener(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "instancePort":
            suggest = "instance_port"
        elif key == "instanceProtocol":
            suggest = "instance_protocol"
        elif key == "lbPort":
            suggest = "lb_port"
        elif key == "lbProtocol":
            suggest = "lb_protocol"
        elif key == "sslCertificateId":
            suggest = "ssl_certificate_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LoadBalancerListener. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LoadBalancerListener.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LoadBalancerListener.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 instance_port: int,
                 instance_protocol: str,
                 lb_port: int,
                 lb_protocol: str,
                 ssl_certificate_id: Optional[str] = None):
        """
        :param int instance_port: The port on the instance to route to
        :param str instance_protocol: The protocol to use to the instance. Valid
               values are `HTTP`, `HTTPS`, `TCP`, or `SSL`
        :param int lb_port: The port to listen on for the load balancer
        :param str lb_protocol: The protocol to listen on. Valid values are `HTTP`,
               `HTTPS`, `TCP`, or `SSL`
        :param str ssl_certificate_id: The ARN of an SSL certificate you have
               uploaded to AWS IAM. **Note ECDSA-specific restrictions below.  Only valid when `lb_protocol` is either HTTPS or SSL**
        """
        LoadBalancerListener._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            instance_port=instance_port,
            instance_protocol=instance_protocol,
            lb_port=lb_port,
            lb_protocol=lb_protocol,
            ssl_certificate_id=ssl_certificate_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             instance_port: Optional[int] = None,
             instance_protocol: Optional[str] = None,
             lb_port: Optional[int] = None,
             lb_protocol: Optional[str] = None,
             ssl_certificate_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if instance_port is None and 'instancePort' in kwargs:
            instance_port = kwargs['instancePort']
        if instance_port is None:
            raise TypeError("Missing 'instance_port' argument")
        if instance_protocol is None and 'instanceProtocol' in kwargs:
            instance_protocol = kwargs['instanceProtocol']
        if instance_protocol is None:
            raise TypeError("Missing 'instance_protocol' argument")
        if lb_port is None and 'lbPort' in kwargs:
            lb_port = kwargs['lbPort']
        if lb_port is None:
            raise TypeError("Missing 'lb_port' argument")
        if lb_protocol is None and 'lbProtocol' in kwargs:
            lb_protocol = kwargs['lbProtocol']
        if lb_protocol is None:
            raise TypeError("Missing 'lb_protocol' argument")
        if ssl_certificate_id is None and 'sslCertificateId' in kwargs:
            ssl_certificate_id = kwargs['sslCertificateId']

        _setter("instance_port", instance_port)
        _setter("instance_protocol", instance_protocol)
        _setter("lb_port", lb_port)
        _setter("lb_protocol", lb_protocol)
        if ssl_certificate_id is not None:
            _setter("ssl_certificate_id", ssl_certificate_id)

    @property
    @pulumi.getter(name="instancePort")
    def instance_port(self) -> int:
        """
        The port on the instance to route to
        """
        return pulumi.get(self, "instance_port")

    @property
    @pulumi.getter(name="instanceProtocol")
    def instance_protocol(self) -> str:
        """
        The protocol to use to the instance. Valid
        values are `HTTP`, `HTTPS`, `TCP`, or `SSL`
        """
        return pulumi.get(self, "instance_protocol")

    @property
    @pulumi.getter(name="lbPort")
    def lb_port(self) -> int:
        """
        The port to listen on for the load balancer
        """
        return pulumi.get(self, "lb_port")

    @property
    @pulumi.getter(name="lbProtocol")
    def lb_protocol(self) -> str:
        """
        The protocol to listen on. Valid values are `HTTP`,
        `HTTPS`, `TCP`, or `SSL`
        """
        return pulumi.get(self, "lb_protocol")

    @property
    @pulumi.getter(name="sslCertificateId")
    def ssl_certificate_id(self) -> Optional[str]:
        """
        The ARN of an SSL certificate you have
        uploaded to AWS IAM. **Note ECDSA-specific restrictions below.  Only valid when `lb_protocol` is either HTTPS or SSL**
        """
        return pulumi.get(self, "ssl_certificate_id")


@pulumi.output_type
class LoadBalancerPolicyPolicyAttribute(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None,
                 value: Optional[str] = None):
        LoadBalancerPolicyPolicyAttribute._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if name is not None:
            _setter("name", name)
        if value is not None:
            _setter("value", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        return pulumi.get(self, "value")


@pulumi.output_type
class SslNegotiationPolicyAttribute(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        :param str name: The name of the attribute
        :param str value: The value of the attribute
        """
        SslNegotiationPolicyAttribute._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("name", name)
        _setter("value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the attribute
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value of the attribute
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetLoadBalancerAccessLogsResult(dict):
    def __init__(__self__, *,
                 bucket: str,
                 bucket_prefix: str,
                 enabled: bool,
                 interval: int):
        GetLoadBalancerAccessLogsResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            bucket_prefix=bucket_prefix,
            enabled=enabled,
            interval=interval,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[str] = None,
             bucket_prefix: Optional[str] = None,
             enabled: Optional[bool] = None,
             interval: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if bucket is None:
            raise TypeError("Missing 'bucket' argument")
        if bucket_prefix is None and 'bucketPrefix' in kwargs:
            bucket_prefix = kwargs['bucketPrefix']
        if bucket_prefix is None:
            raise TypeError("Missing 'bucket_prefix' argument")
        if enabled is None:
            raise TypeError("Missing 'enabled' argument")
        if interval is None:
            raise TypeError("Missing 'interval' argument")

        _setter("bucket", bucket)
        _setter("bucket_prefix", bucket_prefix)
        _setter("enabled", enabled)
        _setter("interval", interval)

    @property
    @pulumi.getter
    def bucket(self) -> str:
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter(name="bucketPrefix")
    def bucket_prefix(self) -> str:
        return pulumi.get(self, "bucket_prefix")

    @property
    @pulumi.getter
    def enabled(self) -> bool:
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def interval(self) -> int:
        return pulumi.get(self, "interval")


@pulumi.output_type
class GetLoadBalancerHealthCheckResult(dict):
    def __init__(__self__, *,
                 healthy_threshold: int,
                 interval: int,
                 target: str,
                 timeout: int,
                 unhealthy_threshold: int):
        GetLoadBalancerHealthCheckResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            healthy_threshold=healthy_threshold,
            interval=interval,
            target=target,
            timeout=timeout,
            unhealthy_threshold=unhealthy_threshold,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             healthy_threshold: Optional[int] = None,
             interval: Optional[int] = None,
             target: Optional[str] = None,
             timeout: Optional[int] = None,
             unhealthy_threshold: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if healthy_threshold is None and 'healthyThreshold' in kwargs:
            healthy_threshold = kwargs['healthyThreshold']
        if healthy_threshold is None:
            raise TypeError("Missing 'healthy_threshold' argument")
        if interval is None:
            raise TypeError("Missing 'interval' argument")
        if target is None:
            raise TypeError("Missing 'target' argument")
        if timeout is None:
            raise TypeError("Missing 'timeout' argument")
        if unhealthy_threshold is None and 'unhealthyThreshold' in kwargs:
            unhealthy_threshold = kwargs['unhealthyThreshold']
        if unhealthy_threshold is None:
            raise TypeError("Missing 'unhealthy_threshold' argument")

        _setter("healthy_threshold", healthy_threshold)
        _setter("interval", interval)
        _setter("target", target)
        _setter("timeout", timeout)
        _setter("unhealthy_threshold", unhealthy_threshold)

    @property
    @pulumi.getter(name="healthyThreshold")
    def healthy_threshold(self) -> int:
        return pulumi.get(self, "healthy_threshold")

    @property
    @pulumi.getter
    def interval(self) -> int:
        return pulumi.get(self, "interval")

    @property
    @pulumi.getter
    def target(self) -> str:
        return pulumi.get(self, "target")

    @property
    @pulumi.getter
    def timeout(self) -> int:
        return pulumi.get(self, "timeout")

    @property
    @pulumi.getter(name="unhealthyThreshold")
    def unhealthy_threshold(self) -> int:
        return pulumi.get(self, "unhealthy_threshold")


@pulumi.output_type
class GetLoadBalancerListenerResult(dict):
    def __init__(__self__, *,
                 instance_port: int,
                 instance_protocol: str,
                 lb_port: int,
                 lb_protocol: str,
                 ssl_certificate_id: str):
        GetLoadBalancerListenerResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            instance_port=instance_port,
            instance_protocol=instance_protocol,
            lb_port=lb_port,
            lb_protocol=lb_protocol,
            ssl_certificate_id=ssl_certificate_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             instance_port: Optional[int] = None,
             instance_protocol: Optional[str] = None,
             lb_port: Optional[int] = None,
             lb_protocol: Optional[str] = None,
             ssl_certificate_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if instance_port is None and 'instancePort' in kwargs:
            instance_port = kwargs['instancePort']
        if instance_port is None:
            raise TypeError("Missing 'instance_port' argument")
        if instance_protocol is None and 'instanceProtocol' in kwargs:
            instance_protocol = kwargs['instanceProtocol']
        if instance_protocol is None:
            raise TypeError("Missing 'instance_protocol' argument")
        if lb_port is None and 'lbPort' in kwargs:
            lb_port = kwargs['lbPort']
        if lb_port is None:
            raise TypeError("Missing 'lb_port' argument")
        if lb_protocol is None and 'lbProtocol' in kwargs:
            lb_protocol = kwargs['lbProtocol']
        if lb_protocol is None:
            raise TypeError("Missing 'lb_protocol' argument")
        if ssl_certificate_id is None and 'sslCertificateId' in kwargs:
            ssl_certificate_id = kwargs['sslCertificateId']
        if ssl_certificate_id is None:
            raise TypeError("Missing 'ssl_certificate_id' argument")

        _setter("instance_port", instance_port)
        _setter("instance_protocol", instance_protocol)
        _setter("lb_port", lb_port)
        _setter("lb_protocol", lb_protocol)
        _setter("ssl_certificate_id", ssl_certificate_id)

    @property
    @pulumi.getter(name="instancePort")
    def instance_port(self) -> int:
        return pulumi.get(self, "instance_port")

    @property
    @pulumi.getter(name="instanceProtocol")
    def instance_protocol(self) -> str:
        return pulumi.get(self, "instance_protocol")

    @property
    @pulumi.getter(name="lbPort")
    def lb_port(self) -> int:
        return pulumi.get(self, "lb_port")

    @property
    @pulumi.getter(name="lbProtocol")
    def lb_protocol(self) -> str:
        return pulumi.get(self, "lb_protocol")

    @property
    @pulumi.getter(name="sslCertificateId")
    def ssl_certificate_id(self) -> str:
        return pulumi.get(self, "ssl_certificate_id")


