# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ExperimentTemplateAction',
    'ExperimentTemplateActionParameter',
    'ExperimentTemplateActionTarget',
    'ExperimentTemplateLogConfiguration',
    'ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration',
    'ExperimentTemplateLogConfigurationS3Configuration',
    'ExperimentTemplateStopCondition',
    'ExperimentTemplateTarget',
    'ExperimentTemplateTargetFilter',
    'ExperimentTemplateTargetResourceTag',
]

@pulumi.output_type
class ExperimentTemplateAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "actionId":
            suggest = "action_id"
        elif key == "startAfters":
            suggest = "start_afters"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExperimentTemplateAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExperimentTemplateAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExperimentTemplateAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action_id: str,
                 name: str,
                 description: Optional[str] = None,
                 parameters: Optional[Sequence['outputs.ExperimentTemplateActionParameter']] = None,
                 start_afters: Optional[Sequence[str]] = None,
                 target: Optional['outputs.ExperimentTemplateActionTarget'] = None):
        """
        :param str action_id: ID of the action. To find out what actions are supported see [AWS FIS actions reference](https://docs.aws.amazon.com/fis/latest/userguide/fis-actions-reference.html).
        :param str name: Friendly name of the action.
        :param str description: Description of the action.
        :param Sequence['ExperimentTemplateActionParameterArgs'] parameters: Parameter(s) for the action, if applicable. See below.
        :param Sequence[str] start_afters: Set of action names that must complete before this action can be executed.
        :param 'ExperimentTemplateActionTargetArgs' target: Action's target, if applicable. See below.
        """
        ExperimentTemplateAction._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            action_id=action_id,
            name=name,
            description=description,
            parameters=parameters,
            start_afters=start_afters,
            target=target,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             action_id: Optional[str] = None,
             name: Optional[str] = None,
             description: Optional[str] = None,
             parameters: Optional[Sequence['outputs.ExperimentTemplateActionParameter']] = None,
             start_afters: Optional[Sequence[str]] = None,
             target: Optional['outputs.ExperimentTemplateActionTarget'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if action_id is None and 'actionId' in kwargs:
            action_id = kwargs['actionId']
        if action_id is None:
            raise TypeError("Missing 'action_id' argument")
        if name is None:
            raise TypeError("Missing 'name' argument")
        if start_afters is None and 'startAfters' in kwargs:
            start_afters = kwargs['startAfters']

        _setter("action_id", action_id)
        _setter("name", name)
        if description is not None:
            _setter("description", description)
        if parameters is not None:
            _setter("parameters", parameters)
        if start_afters is not None:
            _setter("start_afters", start_afters)
        if target is not None:
            _setter("target", target)

    @property
    @pulumi.getter(name="actionId")
    def action_id(self) -> str:
        """
        ID of the action. To find out what actions are supported see [AWS FIS actions reference](https://docs.aws.amazon.com/fis/latest/userguide/fis-actions-reference.html).
        """
        return pulumi.get(self, "action_id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Friendly name of the action.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the action.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def parameters(self) -> Optional[Sequence['outputs.ExperimentTemplateActionParameter']]:
        """
        Parameter(s) for the action, if applicable. See below.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="startAfters")
    def start_afters(self) -> Optional[Sequence[str]]:
        """
        Set of action names that must complete before this action can be executed.
        """
        return pulumi.get(self, "start_afters")

    @property
    @pulumi.getter
    def target(self) -> Optional['outputs.ExperimentTemplateActionTarget']:
        """
        Action's target, if applicable. See below.
        """
        return pulumi.get(self, "target")


@pulumi.output_type
class ExperimentTemplateActionParameter(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Parameter name.
        :param str value: Parameter value.
               
               For a list of parameters supported by each action, see [AWS FIS actions reference](https://docs.aws.amazon.com/fis/latest/userguide/fis-actions-reference.html).
        """
        ExperimentTemplateActionParameter._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if key is None:
            raise TypeError("Missing 'key' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Parameter name.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Parameter value.

        For a list of parameters supported by each action, see [AWS FIS actions reference](https://docs.aws.amazon.com/fis/latest/userguide/fis-actions-reference.html).
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ExperimentTemplateActionTarget(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Target type. Valid values are `Cluster` (EKS Cluster), `Clusters` (ECS Clusters), `DBInstances` (RDS DB Instances), `Instances` (EC2 Instances), `Nodegroups` (EKS Node groups), `Roles` (IAM Roles), `SpotInstances` (EC2 Spot Instances), `Subnets` (VPC Subnets), `Volumes` (EBS Volumes) , `Pods` (EKS Pods), `Tasks` (ECS Tasks). See the [documentation](https://docs.aws.amazon.com/fis/latest/userguide/actions.html#action-targets) for more details.
        :param str value: Target name, referencing a corresponding target.
        """
        ExperimentTemplateActionTarget._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if key is None:
            raise TypeError("Missing 'key' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Target type. Valid values are `Cluster` (EKS Cluster), `Clusters` (ECS Clusters), `DBInstances` (RDS DB Instances), `Instances` (EC2 Instances), `Nodegroups` (EKS Node groups), `Roles` (IAM Roles), `SpotInstances` (EC2 Spot Instances), `Subnets` (VPC Subnets), `Volumes` (EBS Volumes) , `Pods` (EKS Pods), `Tasks` (ECS Tasks). See the [documentation](https://docs.aws.amazon.com/fis/latest/userguide/actions.html#action-targets) for more details.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Target name, referencing a corresponding target.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ExperimentTemplateLogConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logSchemaVersion":
            suggest = "log_schema_version"
        elif key == "cloudwatchLogsConfiguration":
            suggest = "cloudwatch_logs_configuration"
        elif key == "s3Configuration":
            suggest = "s3_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExperimentTemplateLogConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExperimentTemplateLogConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExperimentTemplateLogConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log_schema_version: int,
                 cloudwatch_logs_configuration: Optional['outputs.ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration'] = None,
                 s3_configuration: Optional['outputs.ExperimentTemplateLogConfigurationS3Configuration'] = None):
        """
        :param int log_schema_version: The schema version. See [documentation](https://docs.aws.amazon.com/fis/latest/userguide/monitoring-logging.html#experiment-log-schema) for the list of schema versions.
        :param 'ExperimentTemplateLogConfigurationCloudwatchLogsConfigurationArgs' cloudwatch_logs_configuration: The configuration for experiment logging to Amazon CloudWatch Logs. See below.
        :param 'ExperimentTemplateLogConfigurationS3ConfigurationArgs' s3_configuration: The configuration for experiment logging to Amazon S3. See below.
        """
        ExperimentTemplateLogConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            log_schema_version=log_schema_version,
            cloudwatch_logs_configuration=cloudwatch_logs_configuration,
            s3_configuration=s3_configuration,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             log_schema_version: Optional[int] = None,
             cloudwatch_logs_configuration: Optional['outputs.ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration'] = None,
             s3_configuration: Optional['outputs.ExperimentTemplateLogConfigurationS3Configuration'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if log_schema_version is None and 'logSchemaVersion' in kwargs:
            log_schema_version = kwargs['logSchemaVersion']
        if log_schema_version is None:
            raise TypeError("Missing 'log_schema_version' argument")
        if cloudwatch_logs_configuration is None and 'cloudwatchLogsConfiguration' in kwargs:
            cloudwatch_logs_configuration = kwargs['cloudwatchLogsConfiguration']
        if s3_configuration is None and 's3Configuration' in kwargs:
            s3_configuration = kwargs['s3Configuration']

        _setter("log_schema_version", log_schema_version)
        if cloudwatch_logs_configuration is not None:
            _setter("cloudwatch_logs_configuration", cloudwatch_logs_configuration)
        if s3_configuration is not None:
            _setter("s3_configuration", s3_configuration)

    @property
    @pulumi.getter(name="logSchemaVersion")
    def log_schema_version(self) -> int:
        """
        The schema version. See [documentation](https://docs.aws.amazon.com/fis/latest/userguide/monitoring-logging.html#experiment-log-schema) for the list of schema versions.
        """
        return pulumi.get(self, "log_schema_version")

    @property
    @pulumi.getter(name="cloudwatchLogsConfiguration")
    def cloudwatch_logs_configuration(self) -> Optional['outputs.ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration']:
        """
        The configuration for experiment logging to Amazon CloudWatch Logs. See below.
        """
        return pulumi.get(self, "cloudwatch_logs_configuration")

    @property
    @pulumi.getter(name="s3Configuration")
    def s3_configuration(self) -> Optional['outputs.ExperimentTemplateLogConfigurationS3Configuration']:
        """
        The configuration for experiment logging to Amazon S3. See below.
        """
        return pulumi.get(self, "s3_configuration")


@pulumi.output_type
class ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logGroupArn":
            suggest = "log_group_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log_group_arn: str):
        """
        :param str log_group_arn: The Amazon Resource Name (ARN) of the destination Amazon CloudWatch Logs log group.
        """
        ExperimentTemplateLogConfigurationCloudwatchLogsConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            log_group_arn=log_group_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             log_group_arn: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if log_group_arn is None and 'logGroupArn' in kwargs:
            log_group_arn = kwargs['logGroupArn']
        if log_group_arn is None:
            raise TypeError("Missing 'log_group_arn' argument")

        _setter("log_group_arn", log_group_arn)

    @property
    @pulumi.getter(name="logGroupArn")
    def log_group_arn(self) -> str:
        """
        The Amazon Resource Name (ARN) of the destination Amazon CloudWatch Logs log group.
        """
        return pulumi.get(self, "log_group_arn")


@pulumi.output_type
class ExperimentTemplateLogConfigurationS3Configuration(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bucketName":
            suggest = "bucket_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExperimentTemplateLogConfigurationS3Configuration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExperimentTemplateLogConfigurationS3Configuration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExperimentTemplateLogConfigurationS3Configuration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bucket_name: str,
                 prefix: Optional[str] = None):
        """
        :param str bucket_name: The name of the destination bucket.
        :param str prefix: The bucket prefix.
        """
        ExperimentTemplateLogConfigurationS3Configuration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket_name=bucket_name,
            prefix=prefix,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket_name: Optional[str] = None,
             prefix: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if bucket_name is None and 'bucketName' in kwargs:
            bucket_name = kwargs['bucketName']
        if bucket_name is None:
            raise TypeError("Missing 'bucket_name' argument")

        _setter("bucket_name", bucket_name)
        if prefix is not None:
            _setter("prefix", prefix)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> str:
        """
        The name of the destination bucket.
        """
        return pulumi.get(self, "bucket_name")

    @property
    @pulumi.getter
    def prefix(self) -> Optional[str]:
        """
        The bucket prefix.
        """
        return pulumi.get(self, "prefix")


@pulumi.output_type
class ExperimentTemplateStopCondition(dict):
    def __init__(__self__, *,
                 source: str,
                 value: Optional[str] = None):
        """
        :param str source: Source of the condition. One of `none`, `aws:cloudwatch:alarm`.
        :param str value: ARN of the CloudWatch alarm. Required if the source is a CloudWatch alarm.
        """
        ExperimentTemplateStopCondition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            source=source,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             source: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if source is None:
            raise TypeError("Missing 'source' argument")

        _setter("source", source)
        if value is not None:
            _setter("value", value)

    @property
    @pulumi.getter
    def source(self) -> str:
        """
        Source of the condition. One of `none`, `aws:cloudwatch:alarm`.
        """
        return pulumi.get(self, "source")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        """
        ARN of the CloudWatch alarm. Required if the source is a CloudWatch alarm.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class ExperimentTemplateTarget(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resourceType":
            suggest = "resource_type"
        elif key == "selectionMode":
            suggest = "selection_mode"
        elif key == "resourceArns":
            suggest = "resource_arns"
        elif key == "resourceTags":
            suggest = "resource_tags"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExperimentTemplateTarget. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExperimentTemplateTarget.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExperimentTemplateTarget.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 resource_type: str,
                 selection_mode: str,
                 filters: Optional[Sequence['outputs.ExperimentTemplateTargetFilter']] = None,
                 parameters: Optional[Mapping[str, str]] = None,
                 resource_arns: Optional[Sequence[str]] = None,
                 resource_tags: Optional[Sequence['outputs.ExperimentTemplateTargetResourceTag']] = None):
        """
        :param str name: Friendly name given to the target.
        :param str resource_type: AWS resource type. The resource type must be supported for the specified action. To find out what resource types are supported, see [Targets for AWS FIS](https://docs.aws.amazon.com/fis/latest/userguide/targets.html#resource-types).
        :param str selection_mode: Scopes the identified resources. Valid values are `ALL` (all identified resources), `COUNT(n)` (randomly select `n` of the identified resources), `PERCENT(n)` (randomly select `n` percent of the identified resources).
        :param Sequence['ExperimentTemplateTargetFilterArgs'] filters: Filter(s) for the target. Filters can be used to select resources based on specific attributes returned by the respective describe action of the resource type. For more information, see [Targets for AWS FIS](https://docs.aws.amazon.com/fis/latest/userguide/targets.html#target-filters). See below.
        :param Mapping[str, str] parameters: The resource type parameters.
               
               > **NOTE:** The `target` configuration block requires either `resource_arns` or `resource_tag`.
        :param Sequence[str] resource_arns: Set of ARNs of the resources to target with an action. Conflicts with `resource_tag`.
        :param Sequence['ExperimentTemplateTargetResourceTagArgs'] resource_tags: Tag(s) the resources need to have to be considered a valid target for an action. Conflicts with `resource_arns`. See below.
        """
        ExperimentTemplateTarget._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            resource_type=resource_type,
            selection_mode=selection_mode,
            filters=filters,
            parameters=parameters,
            resource_arns=resource_arns,
            resource_tags=resource_tags,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             resource_type: Optional[str] = None,
             selection_mode: Optional[str] = None,
             filters: Optional[Sequence['outputs.ExperimentTemplateTargetFilter']] = None,
             parameters: Optional[Mapping[str, str]] = None,
             resource_arns: Optional[Sequence[str]] = None,
             resource_tags: Optional[Sequence['outputs.ExperimentTemplateTargetResourceTag']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if resource_type is None and 'resourceType' in kwargs:
            resource_type = kwargs['resourceType']
        if resource_type is None:
            raise TypeError("Missing 'resource_type' argument")
        if selection_mode is None and 'selectionMode' in kwargs:
            selection_mode = kwargs['selectionMode']
        if selection_mode is None:
            raise TypeError("Missing 'selection_mode' argument")
        if resource_arns is None and 'resourceArns' in kwargs:
            resource_arns = kwargs['resourceArns']
        if resource_tags is None and 'resourceTags' in kwargs:
            resource_tags = kwargs['resourceTags']

        _setter("name", name)
        _setter("resource_type", resource_type)
        _setter("selection_mode", selection_mode)
        if filters is not None:
            _setter("filters", filters)
        if parameters is not None:
            _setter("parameters", parameters)
        if resource_arns is not None:
            _setter("resource_arns", resource_arns)
        if resource_tags is not None:
            _setter("resource_tags", resource_tags)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Friendly name given to the target.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> str:
        """
        AWS resource type. The resource type must be supported for the specified action. To find out what resource types are supported, see [Targets for AWS FIS](https://docs.aws.amazon.com/fis/latest/userguide/targets.html#resource-types).
        """
        return pulumi.get(self, "resource_type")

    @property
    @pulumi.getter(name="selectionMode")
    def selection_mode(self) -> str:
        """
        Scopes the identified resources. Valid values are `ALL` (all identified resources), `COUNT(n)` (randomly select `n` of the identified resources), `PERCENT(n)` (randomly select `n` percent of the identified resources).
        """
        return pulumi.get(self, "selection_mode")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.ExperimentTemplateTargetFilter']]:
        """
        Filter(s) for the target. Filters can be used to select resources based on specific attributes returned by the respective describe action of the resource type. For more information, see [Targets for AWS FIS](https://docs.aws.amazon.com/fis/latest/userguide/targets.html#target-filters). See below.
        """
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def parameters(self) -> Optional[Mapping[str, str]]:
        """
        The resource type parameters.

        > **NOTE:** The `target` configuration block requires either `resource_arns` or `resource_tag`.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="resourceArns")
    def resource_arns(self) -> Optional[Sequence[str]]:
        """
        Set of ARNs of the resources to target with an action. Conflicts with `resource_tag`.
        """
        return pulumi.get(self, "resource_arns")

    @property
    @pulumi.getter(name="resourceTags")
    def resource_tags(self) -> Optional[Sequence['outputs.ExperimentTemplateTargetResourceTag']]:
        """
        Tag(s) the resources need to have to be considered a valid target for an action. Conflicts with `resource_arns`. See below.
        """
        return pulumi.get(self, "resource_tags")


@pulumi.output_type
class ExperimentTemplateTargetFilter(dict):
    def __init__(__self__, *,
                 path: str,
                 values: Sequence[str]):
        """
        :param str path: Attribute path for the filter.
        :param Sequence[str] values: Set of attribute values for the filter.
               
               > **NOTE:** Values specified in a `filter` are joined with an `OR` clause, while values across multiple `filter` blocks are joined with an `AND` clause. For more information, see [Targets for AWS FIS](https://docs.aws.amazon.com/fis/latest/userguide/targets.html#target-filters).
        """
        ExperimentTemplateTargetFilter._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            path=path,
            values=values,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             path: Optional[str] = None,
             values: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if path is None:
            raise TypeError("Missing 'path' argument")
        if values is None:
            raise TypeError("Missing 'values' argument")

        _setter("path", path)
        _setter("values", values)

    @property
    @pulumi.getter
    def path(self) -> str:
        """
        Attribute path for the filter.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        Set of attribute values for the filter.

        > **NOTE:** Values specified in a `filter` are joined with an `OR` clause, while values across multiple `filter` blocks are joined with an `AND` clause. For more information, see [Targets for AWS FIS](https://docs.aws.amazon.com/fis/latest/userguide/targets.html#target-filters).
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class ExperimentTemplateTargetResourceTag(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: Tag key.
        :param str value: Tag value.
        """
        ExperimentTemplateTargetResourceTag._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if key is None:
            raise TypeError("Missing 'key' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        Tag key.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Tag value.
        """
        return pulumi.get(self, "value")


