# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'TableCapacitySpecification',
    'TableClientSideTimestamps',
    'TableComment',
    'TableEncryptionSpecification',
    'TablePointInTimeRecovery',
    'TableSchemaDefinition',
    'TableSchemaDefinitionClusteringKey',
    'TableSchemaDefinitionColumn',
    'TableSchemaDefinitionPartitionKey',
    'TableSchemaDefinitionStaticColumn',
    'TableTtl',
]

@pulumi.output_type
class TableCapacitySpecification(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "readCapacityUnits":
            suggest = "read_capacity_units"
        elif key == "throughputMode":
            suggest = "throughput_mode"
        elif key == "writeCapacityUnits":
            suggest = "write_capacity_units"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableCapacitySpecification. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableCapacitySpecification.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableCapacitySpecification.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 read_capacity_units: Optional[int] = None,
                 throughput_mode: Optional[str] = None,
                 write_capacity_units: Optional[int] = None):
        """
        :param int read_capacity_units: The throughput capacity specified for read operations defined in read capacity units (RCUs).
        :param str throughput_mode: The read/write throughput capacity mode for a table. Valid values: `PAY_PER_REQUEST`, `PROVISIONED`. The default value is `PAY_PER_REQUEST`.
        :param int write_capacity_units: The throughput capacity specified for write operations defined in write capacity units (WCUs).
        """
        TableCapacitySpecification._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            read_capacity_units=read_capacity_units,
            throughput_mode=throughput_mode,
            write_capacity_units=write_capacity_units,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             read_capacity_units: Optional[int] = None,
             throughput_mode: Optional[str] = None,
             write_capacity_units: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if read_capacity_units is None and 'readCapacityUnits' in kwargs:
            read_capacity_units = kwargs['readCapacityUnits']
        if throughput_mode is None and 'throughputMode' in kwargs:
            throughput_mode = kwargs['throughputMode']
        if write_capacity_units is None and 'writeCapacityUnits' in kwargs:
            write_capacity_units = kwargs['writeCapacityUnits']

        if read_capacity_units is not None:
            _setter("read_capacity_units", read_capacity_units)
        if throughput_mode is not None:
            _setter("throughput_mode", throughput_mode)
        if write_capacity_units is not None:
            _setter("write_capacity_units", write_capacity_units)

    @property
    @pulumi.getter(name="readCapacityUnits")
    def read_capacity_units(self) -> Optional[int]:
        """
        The throughput capacity specified for read operations defined in read capacity units (RCUs).
        """
        return pulumi.get(self, "read_capacity_units")

    @property
    @pulumi.getter(name="throughputMode")
    def throughput_mode(self) -> Optional[str]:
        """
        The read/write throughput capacity mode for a table. Valid values: `PAY_PER_REQUEST`, `PROVISIONED`. The default value is `PAY_PER_REQUEST`.
        """
        return pulumi.get(self, "throughput_mode")

    @property
    @pulumi.getter(name="writeCapacityUnits")
    def write_capacity_units(self) -> Optional[int]:
        """
        The throughput capacity specified for write operations defined in write capacity units (WCUs).
        """
        return pulumi.get(self, "write_capacity_units")


@pulumi.output_type
class TableClientSideTimestamps(dict):
    def __init__(__self__, *,
                 status: str):
        """
        :param str status: Shows how to enable client-side timestamps settings for the specified table. Valid values: `ENABLED`.
        """
        TableClientSideTimestamps._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if status is None:
            raise TypeError("Missing 'status' argument")

        _setter("status", status)

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Shows how to enable client-side timestamps settings for the specified table. Valid values: `ENABLED`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class TableComment(dict):
    def __init__(__self__, *,
                 message: Optional[str] = None):
        """
        :param str message: A description of the table.
        """
        TableComment._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            message=message,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             message: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if message is not None:
            _setter("message", message)

    @property
    @pulumi.getter
    def message(self) -> Optional[str]:
        """
        A description of the table.
        """
        return pulumi.get(self, "message")


@pulumi.output_type
class TableEncryptionSpecification(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "kmsKeyIdentifier":
            suggest = "kms_key_identifier"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableEncryptionSpecification. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableEncryptionSpecification.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableEncryptionSpecification.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 kms_key_identifier: Optional[str] = None,
                 type: Optional[str] = None):
        """
        :param str kms_key_identifier: The Amazon Resource Name (ARN) of the customer managed KMS key.
        :param str type: The encryption option specified for the table. Valid values: `AWS_OWNED_KMS_KEY`, `CUSTOMER_MANAGED_KMS_KEY`. The default value is `AWS_OWNED_KMS_KEY`.
        """
        TableEncryptionSpecification._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            kms_key_identifier=kms_key_identifier,
            type=type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             kms_key_identifier: Optional[str] = None,
             type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if kms_key_identifier is None and 'kmsKeyIdentifier' in kwargs:
            kms_key_identifier = kwargs['kmsKeyIdentifier']

        if kms_key_identifier is not None:
            _setter("kms_key_identifier", kms_key_identifier)
        if type is not None:
            _setter("type", type)

    @property
    @pulumi.getter(name="kmsKeyIdentifier")
    def kms_key_identifier(self) -> Optional[str]:
        """
        The Amazon Resource Name (ARN) of the customer managed KMS key.
        """
        return pulumi.get(self, "kms_key_identifier")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The encryption option specified for the table. Valid values: `AWS_OWNED_KMS_KEY`, `CUSTOMER_MANAGED_KMS_KEY`. The default value is `AWS_OWNED_KMS_KEY`.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class TablePointInTimeRecovery(dict):
    def __init__(__self__, *,
                 status: Optional[str] = None):
        """
        :param str status: Valid values: `ENABLED`, `DISABLED`. The default value is `DISABLED`.
        """
        TablePointInTimeRecovery._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if status is not None:
            _setter("status", status)

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Valid values: `ENABLED`, `DISABLED`. The default value is `DISABLED`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class TableSchemaDefinition(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "partitionKeys":
            suggest = "partition_keys"
        elif key == "clusteringKeys":
            suggest = "clustering_keys"
        elif key == "staticColumns":
            suggest = "static_columns"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableSchemaDefinition. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableSchemaDefinition.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableSchemaDefinition.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 columns: Sequence['outputs.TableSchemaDefinitionColumn'],
                 partition_keys: Sequence['outputs.TableSchemaDefinitionPartitionKey'],
                 clustering_keys: Optional[Sequence['outputs.TableSchemaDefinitionClusteringKey']] = None,
                 static_columns: Optional[Sequence['outputs.TableSchemaDefinitionStaticColumn']] = None):
        """
        :param Sequence['TableSchemaDefinitionColumnArgs'] columns: The regular columns of the table.
        :param Sequence['TableSchemaDefinitionPartitionKeyArgs'] partition_keys: The columns that are part of the partition key of the table .
        :param Sequence['TableSchemaDefinitionClusteringKeyArgs'] clustering_keys: The columns that are part of the clustering key of the table.
        :param Sequence['TableSchemaDefinitionStaticColumnArgs'] static_columns: The columns that have been defined as `STATIC`. Static columns store values that are shared by all rows in the same partition.
        """
        TableSchemaDefinition._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            columns=columns,
            partition_keys=partition_keys,
            clustering_keys=clustering_keys,
            static_columns=static_columns,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             columns: Optional[Sequence['outputs.TableSchemaDefinitionColumn']] = None,
             partition_keys: Optional[Sequence['outputs.TableSchemaDefinitionPartitionKey']] = None,
             clustering_keys: Optional[Sequence['outputs.TableSchemaDefinitionClusteringKey']] = None,
             static_columns: Optional[Sequence['outputs.TableSchemaDefinitionStaticColumn']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if columns is None:
            raise TypeError("Missing 'columns' argument")
        if partition_keys is None and 'partitionKeys' in kwargs:
            partition_keys = kwargs['partitionKeys']
        if partition_keys is None:
            raise TypeError("Missing 'partition_keys' argument")
        if clustering_keys is None and 'clusteringKeys' in kwargs:
            clustering_keys = kwargs['clusteringKeys']
        if static_columns is None and 'staticColumns' in kwargs:
            static_columns = kwargs['staticColumns']

        _setter("columns", columns)
        _setter("partition_keys", partition_keys)
        if clustering_keys is not None:
            _setter("clustering_keys", clustering_keys)
        if static_columns is not None:
            _setter("static_columns", static_columns)

    @property
    @pulumi.getter
    def columns(self) -> Sequence['outputs.TableSchemaDefinitionColumn']:
        """
        The regular columns of the table.
        """
        return pulumi.get(self, "columns")

    @property
    @pulumi.getter(name="partitionKeys")
    def partition_keys(self) -> Sequence['outputs.TableSchemaDefinitionPartitionKey']:
        """
        The columns that are part of the partition key of the table .
        """
        return pulumi.get(self, "partition_keys")

    @property
    @pulumi.getter(name="clusteringKeys")
    def clustering_keys(self) -> Optional[Sequence['outputs.TableSchemaDefinitionClusteringKey']]:
        """
        The columns that are part of the clustering key of the table.
        """
        return pulumi.get(self, "clustering_keys")

    @property
    @pulumi.getter(name="staticColumns")
    def static_columns(self) -> Optional[Sequence['outputs.TableSchemaDefinitionStaticColumn']]:
        """
        The columns that have been defined as `STATIC`. Static columns store values that are shared by all rows in the same partition.
        """
        return pulumi.get(self, "static_columns")


@pulumi.output_type
class TableSchemaDefinitionClusteringKey(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "orderBy":
            suggest = "order_by"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TableSchemaDefinitionClusteringKey. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TableSchemaDefinitionClusteringKey.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TableSchemaDefinitionClusteringKey.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 order_by: str):
        """
        :param str name: The name of the clustering key column.
        :param str order_by: The order modifier. Valid values: `ASC`, `DESC`.
        """
        TableSchemaDefinitionClusteringKey._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            order_by=order_by,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             order_by: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if order_by is None and 'orderBy' in kwargs:
            order_by = kwargs['orderBy']
        if order_by is None:
            raise TypeError("Missing 'order_by' argument")

        _setter("name", name)
        _setter("order_by", order_by)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the clustering key column.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="orderBy")
    def order_by(self) -> str:
        """
        The order modifier. Valid values: `ASC`, `DESC`.
        """
        return pulumi.get(self, "order_by")


@pulumi.output_type
class TableSchemaDefinitionColumn(dict):
    def __init__(__self__, *,
                 name: str,
                 type: str):
        """
        :param str name: The name of the column.
        :param str type: The data type of the column. See the [Developer Guide](https://docs.aws.amazon.com/keyspaces/latest/devguide/cql.elements.html#cql.data-types) for a list of available data types.
        """
        TableSchemaDefinitionColumn._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            type=type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if type is None:
            raise TypeError("Missing 'type' argument")

        _setter("name", name)
        _setter("type", type)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the column.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The data type of the column. See the [Developer Guide](https://docs.aws.amazon.com/keyspaces/latest/devguide/cql.elements.html#cql.data-types) for a list of available data types.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class TableSchemaDefinitionPartitionKey(dict):
    def __init__(__self__, *,
                 name: str):
        """
        :param str name: The name of the partition key column.
        """
        TableSchemaDefinitionPartitionKey._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")

        _setter("name", name)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the partition key column.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class TableSchemaDefinitionStaticColumn(dict):
    def __init__(__self__, *,
                 name: str):
        """
        :param str name: The name of the static column.
        """
        TableSchemaDefinitionStaticColumn._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")

        _setter("name", name)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the static column.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class TableTtl(dict):
    def __init__(__self__, *,
                 status: str):
        """
        :param str status: Valid values: `ENABLED`.
        """
        TableTtl._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             status: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if status is None:
            raise TypeError("Missing 'status' argument")

        _setter("status", status)

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Valid values: `ENABLED`.
        """
        return pulumi.get(self, "status")


