# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetLicenseGrantsFilterResult',
    'GetReceivedLicenseConsumptionConfigurationResult',
    'GetReceivedLicenseConsumptionConfigurationBorrowConfigurationResult',
    'GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationResult',
    'GetReceivedLicenseEntitlementResult',
    'GetReceivedLicenseIssuerResult',
    'GetReceivedLicenseLicenseMetadataResult',
    'GetReceivedLicenseReceivedMetadataResult',
    'GetReceivedLicenseValidityResult',
    'GetReceivedLicensesFilterResult',
]

@pulumi.output_type
class GetLicenseGrantsFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str]):
        """
        :param str name: Name of the field to filter by, as defined by
               [the underlying AWS API](https://docs.aws.amazon.com/license-manager/latest/APIReference/API_ListReceivedGrants.html#API_ListReceivedGrants_RequestSyntax).
               For example, if filtering using `ProductSKU`, use:
               
               ```python
               import pulumi
               import pulumi_aws as aws
               
               selected = aws.licensemanager.get_license_grants(filters=[aws.licensemanager.GetLicenseGrantsFilterArgs(
                   name="ProductSKU",
                   values=[""],
               )])
               ```
        :param Sequence[str] values: Set of values that are accepted for the given field.
        """
        GetLicenseGrantsFilterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             values: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if values is None:
            raise TypeError("Missing 'values' argument")

        _setter("name", name)
        _setter("values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the field to filter by, as defined by
        [the underlying AWS API](https://docs.aws.amazon.com/license-manager/latest/APIReference/API_ListReceivedGrants.html#API_ListReceivedGrants_RequestSyntax).
        For example, if filtering using `ProductSKU`, use:

        ```python
        import pulumi
        import pulumi_aws as aws

        selected = aws.licensemanager.get_license_grants(filters=[aws.licensemanager.GetLicenseGrantsFilterArgs(
            name="ProductSKU",
            values=[""],
        )])
        ```
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        Set of values that are accepted for the given field.
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class GetReceivedLicenseConsumptionConfigurationResult(dict):
    def __init__(__self__, *,
                 borrow_configurations: Sequence['outputs.GetReceivedLicenseConsumptionConfigurationBorrowConfigurationResult'],
                 provisional_configurations: Sequence['outputs.GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationResult'],
                 renew_type: str):
        """
        :param Sequence['GetReceivedLicenseConsumptionConfigurationBorrowConfigurationArgs'] borrow_configurations: Details about a borrow configuration. Detailed below
        :param Sequence['GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationArgs'] provisional_configurations: Details about a provisional configuration. Detailed below
        """
        GetReceivedLicenseConsumptionConfigurationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            borrow_configurations=borrow_configurations,
            provisional_configurations=provisional_configurations,
            renew_type=renew_type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             borrow_configurations: Optional[Sequence['outputs.GetReceivedLicenseConsumptionConfigurationBorrowConfigurationResult']] = None,
             provisional_configurations: Optional[Sequence['outputs.GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationResult']] = None,
             renew_type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if borrow_configurations is None and 'borrowConfigurations' in kwargs:
            borrow_configurations = kwargs['borrowConfigurations']
        if borrow_configurations is None:
            raise TypeError("Missing 'borrow_configurations' argument")
        if provisional_configurations is None and 'provisionalConfigurations' in kwargs:
            provisional_configurations = kwargs['provisionalConfigurations']
        if provisional_configurations is None:
            raise TypeError("Missing 'provisional_configurations' argument")
        if renew_type is None and 'renewType' in kwargs:
            renew_type = kwargs['renewType']
        if renew_type is None:
            raise TypeError("Missing 'renew_type' argument")

        _setter("borrow_configurations", borrow_configurations)
        _setter("provisional_configurations", provisional_configurations)
        _setter("renew_type", renew_type)

    @property
    @pulumi.getter(name="borrowConfigurations")
    def borrow_configurations(self) -> Sequence['outputs.GetReceivedLicenseConsumptionConfigurationBorrowConfigurationResult']:
        """
        Details about a borrow configuration. Detailed below
        """
        return pulumi.get(self, "borrow_configurations")

    @property
    @pulumi.getter(name="provisionalConfigurations")
    def provisional_configurations(self) -> Sequence['outputs.GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationResult']:
        """
        Details about a provisional configuration. Detailed below
        """
        return pulumi.get(self, "provisional_configurations")

    @property
    @pulumi.getter(name="renewType")
    def renew_type(self) -> str:
        return pulumi.get(self, "renew_type")


@pulumi.output_type
class GetReceivedLicenseConsumptionConfigurationBorrowConfigurationResult(dict):
    def __init__(__self__, *,
                 allow_early_check_in: bool,
                 max_time_to_live_in_minutes: int):
        """
        :param bool allow_early_check_in: Indicates whether early check-ins are allowed.
        :param int max_time_to_live_in_minutes: Maximum time for the provisional configuration, in minutes.
        """
        GetReceivedLicenseConsumptionConfigurationBorrowConfigurationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            allow_early_check_in=allow_early_check_in,
            max_time_to_live_in_minutes=max_time_to_live_in_minutes,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             allow_early_check_in: Optional[bool] = None,
             max_time_to_live_in_minutes: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if allow_early_check_in is None and 'allowEarlyCheckIn' in kwargs:
            allow_early_check_in = kwargs['allowEarlyCheckIn']
        if allow_early_check_in is None:
            raise TypeError("Missing 'allow_early_check_in' argument")
        if max_time_to_live_in_minutes is None and 'maxTimeToLiveInMinutes' in kwargs:
            max_time_to_live_in_minutes = kwargs['maxTimeToLiveInMinutes']
        if max_time_to_live_in_minutes is None:
            raise TypeError("Missing 'max_time_to_live_in_minutes' argument")

        _setter("allow_early_check_in", allow_early_check_in)
        _setter("max_time_to_live_in_minutes", max_time_to_live_in_minutes)

    @property
    @pulumi.getter(name="allowEarlyCheckIn")
    def allow_early_check_in(self) -> bool:
        """
        Indicates whether early check-ins are allowed.
        """
        return pulumi.get(self, "allow_early_check_in")

    @property
    @pulumi.getter(name="maxTimeToLiveInMinutes")
    def max_time_to_live_in_minutes(self) -> int:
        """
        Maximum time for the provisional configuration, in minutes.
        """
        return pulumi.get(self, "max_time_to_live_in_minutes")


@pulumi.output_type
class GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationResult(dict):
    def __init__(__self__, *,
                 max_time_to_live_in_minutes: int):
        """
        :param int max_time_to_live_in_minutes: Maximum time for the provisional configuration, in minutes.
        """
        GetReceivedLicenseConsumptionConfigurationProvisionalConfigurationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            max_time_to_live_in_minutes=max_time_to_live_in_minutes,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             max_time_to_live_in_minutes: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if max_time_to_live_in_minutes is None and 'maxTimeToLiveInMinutes' in kwargs:
            max_time_to_live_in_minutes = kwargs['maxTimeToLiveInMinutes']
        if max_time_to_live_in_minutes is None:
            raise TypeError("Missing 'max_time_to_live_in_minutes' argument")

        _setter("max_time_to_live_in_minutes", max_time_to_live_in_minutes)

    @property
    @pulumi.getter(name="maxTimeToLiveInMinutes")
    def max_time_to_live_in_minutes(self) -> int:
        """
        Maximum time for the provisional configuration, in minutes.
        """
        return pulumi.get(self, "max_time_to_live_in_minutes")


@pulumi.output_type
class GetReceivedLicenseEntitlementResult(dict):
    def __init__(__self__, *,
                 allow_check_in: bool,
                 max_count: int,
                 name: str,
                 unit: str,
                 value: str):
        """
        :param bool allow_check_in: Indicates whether check-ins are allowed.
        :param int max_count: Maximum entitlement count. Use if the unit is not None.
        :param str name: The key name.
        :param str unit: Entitlement unit.
        :param str value: The value.
        """
        GetReceivedLicenseEntitlementResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            allow_check_in=allow_check_in,
            max_count=max_count,
            name=name,
            unit=unit,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             allow_check_in: Optional[bool] = None,
             max_count: Optional[int] = None,
             name: Optional[str] = None,
             unit: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if allow_check_in is None and 'allowCheckIn' in kwargs:
            allow_check_in = kwargs['allowCheckIn']
        if allow_check_in is None:
            raise TypeError("Missing 'allow_check_in' argument")
        if max_count is None and 'maxCount' in kwargs:
            max_count = kwargs['maxCount']
        if max_count is None:
            raise TypeError("Missing 'max_count' argument")
        if name is None:
            raise TypeError("Missing 'name' argument")
        if unit is None:
            raise TypeError("Missing 'unit' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("allow_check_in", allow_check_in)
        _setter("max_count", max_count)
        _setter("name", name)
        _setter("unit", unit)
        _setter("value", value)

    @property
    @pulumi.getter(name="allowCheckIn")
    def allow_check_in(self) -> bool:
        """
        Indicates whether check-ins are allowed.
        """
        return pulumi.get(self, "allow_check_in")

    @property
    @pulumi.getter(name="maxCount")
    def max_count(self) -> int:
        """
        Maximum entitlement count. Use if the unit is not None.
        """
        return pulumi.get(self, "max_count")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The key name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def unit(self) -> str:
        """
        Entitlement unit.
        """
        return pulumi.get(self, "unit")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetReceivedLicenseIssuerResult(dict):
    def __init__(__self__, *,
                 key_fingerprint: str,
                 name: str,
                 sign_key: str):
        """
        :param str key_fingerprint: Issuer key fingerprint.
        :param str name: The key name.
        :param str sign_key: Asymmetric KMS key from AWS Key Management Service. The KMS key must have a key usage of sign and verify, and support the RSASSA-PSS SHA-256 signing algorithm.
        """
        GetReceivedLicenseIssuerResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key_fingerprint=key_fingerprint,
            name=name,
            sign_key=sign_key,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key_fingerprint: Optional[str] = None,
             name: Optional[str] = None,
             sign_key: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if key_fingerprint is None and 'keyFingerprint' in kwargs:
            key_fingerprint = kwargs['keyFingerprint']
        if key_fingerprint is None:
            raise TypeError("Missing 'key_fingerprint' argument")
        if name is None:
            raise TypeError("Missing 'name' argument")
        if sign_key is None and 'signKey' in kwargs:
            sign_key = kwargs['signKey']
        if sign_key is None:
            raise TypeError("Missing 'sign_key' argument")

        _setter("key_fingerprint", key_fingerprint)
        _setter("name", name)
        _setter("sign_key", sign_key)

    @property
    @pulumi.getter(name="keyFingerprint")
    def key_fingerprint(self) -> str:
        """
        Issuer key fingerprint.
        """
        return pulumi.get(self, "key_fingerprint")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The key name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="signKey")
    def sign_key(self) -> str:
        """
        Asymmetric KMS key from AWS Key Management Service. The KMS key must have a key usage of sign and verify, and support the RSASSA-PSS SHA-256 signing algorithm.
        """
        return pulumi.get(self, "sign_key")


@pulumi.output_type
class GetReceivedLicenseLicenseMetadataResult(dict):
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        :param str name: The key name.
        :param str value: The value.
        """
        GetReceivedLicenseLicenseMetadataResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("name", name)
        _setter("value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The key name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetReceivedLicenseReceivedMetadataResult(dict):
    def __init__(__self__, *,
                 allowed_operations: Sequence[str],
                 received_status: str,
                 received_status_reason: str):
        """
        :param Sequence[str] allowed_operations: A list of allowed operations.
        :param str received_status: Received status.
        :param str received_status_reason: Received status reason.
        """
        GetReceivedLicenseReceivedMetadataResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            allowed_operations=allowed_operations,
            received_status=received_status,
            received_status_reason=received_status_reason,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             allowed_operations: Optional[Sequence[str]] = None,
             received_status: Optional[str] = None,
             received_status_reason: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if allowed_operations is None and 'allowedOperations' in kwargs:
            allowed_operations = kwargs['allowedOperations']
        if allowed_operations is None:
            raise TypeError("Missing 'allowed_operations' argument")
        if received_status is None and 'receivedStatus' in kwargs:
            received_status = kwargs['receivedStatus']
        if received_status is None:
            raise TypeError("Missing 'received_status' argument")
        if received_status_reason is None and 'receivedStatusReason' in kwargs:
            received_status_reason = kwargs['receivedStatusReason']
        if received_status_reason is None:
            raise TypeError("Missing 'received_status_reason' argument")

        _setter("allowed_operations", allowed_operations)
        _setter("received_status", received_status)
        _setter("received_status_reason", received_status_reason)

    @property
    @pulumi.getter(name="allowedOperations")
    def allowed_operations(self) -> Sequence[str]:
        """
        A list of allowed operations.
        """
        return pulumi.get(self, "allowed_operations")

    @property
    @pulumi.getter(name="receivedStatus")
    def received_status(self) -> str:
        """
        Received status.
        """
        return pulumi.get(self, "received_status")

    @property
    @pulumi.getter(name="receivedStatusReason")
    def received_status_reason(self) -> str:
        """
        Received status reason.
        """
        return pulumi.get(self, "received_status_reason")


@pulumi.output_type
class GetReceivedLicenseValidityResult(dict):
    def __init__(__self__, *,
                 begin: str,
                 end: str):
        """
        :param str begin: Start of the validity time range.
        :param str end: End of the validity time range.
        """
        GetReceivedLicenseValidityResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            begin=begin,
            end=end,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             begin: Optional[str] = None,
             end: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if begin is None:
            raise TypeError("Missing 'begin' argument")
        if end is None:
            raise TypeError("Missing 'end' argument")

        _setter("begin", begin)
        _setter("end", end)

    @property
    @pulumi.getter
    def begin(self) -> str:
        """
        Start of the validity time range.
        """
        return pulumi.get(self, "begin")

    @property
    @pulumi.getter
    def end(self) -> str:
        """
        End of the validity time range.
        """
        return pulumi.get(self, "end")


@pulumi.output_type
class GetReceivedLicensesFilterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str]):
        """
        :param str name: Name of the field to filter by, as defined by
               [the underlying AWS API](https://docs.aws.amazon.com/license-manager/latest/APIReference/API_ListReceivedLicenses.html#API_ListReceivedLicenses_RequestSyntax).
               For example, if filtering using `ProductSKU`, use:
               
               ```python
               import pulumi
               import pulumi_aws as aws
               
               selected = aws.licensemanager.get_received_licenses(filters=[aws.licensemanager.GetReceivedLicensesFilterArgs(
                   name="ProductSKU",
                   values=[""],
               )])
               ```
        :param Sequence[str] values: Set of values that are accepted for the given field.
        """
        GetReceivedLicensesFilterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             values: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if values is None:
            raise TypeError("Missing 'values' argument")

        _setter("name", name)
        _setter("values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the field to filter by, as defined by
        [the underlying AWS API](https://docs.aws.amazon.com/license-manager/latest/APIReference/API_ListReceivedLicenses.html#API_ListReceivedLicenses_RequestSyntax).
        For example, if filtering using `ProductSKU`, use:

        ```python
        import pulumi
        import pulumi_aws as aws

        selected = aws.licensemanager.get_received_licenses(filters=[aws.licensemanager.GetReceivedLicensesFilterArgs(
            name="ProductSKU",
            values=[""],
        )])
        ```
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        Set of values that are accepted for the given field.
        """
        return pulumi.get(self, "values")


