# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'QueueReservationPlanSettings',
]

@pulumi.output_type
class QueueReservationPlanSettings(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "renewalType":
            suggest = "renewal_type"
        elif key == "reservedSlots":
            suggest = "reserved_slots"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in QueueReservationPlanSettings. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        QueueReservationPlanSettings.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        QueueReservationPlanSettings.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 commitment: str,
                 renewal_type: str,
                 reserved_slots: int):
        """
        :param str commitment: The length of the term of your reserved queue pricing plan commitment. Valid value is `ONE_YEAR`.
        :param str renewal_type: Specifies whether the term of your reserved queue pricing plan. Valid values are `AUTO_RENEW` or `EXPIRE`.
        :param int reserved_slots: Specifies the number of reserved transcode slots (RTS) for queue.
        """
        QueueReservationPlanSettings._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            commitment=commitment,
            renewal_type=renewal_type,
            reserved_slots=reserved_slots,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             commitment: Optional[str] = None,
             renewal_type: Optional[str] = None,
             reserved_slots: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if commitment is None:
            raise TypeError("Missing 'commitment' argument")
        if renewal_type is None and 'renewalType' in kwargs:
            renewal_type = kwargs['renewalType']
        if renewal_type is None:
            raise TypeError("Missing 'renewal_type' argument")
        if reserved_slots is None and 'reservedSlots' in kwargs:
            reserved_slots = kwargs['reservedSlots']
        if reserved_slots is None:
            raise TypeError("Missing 'reserved_slots' argument")

        _setter("commitment", commitment)
        _setter("renewal_type", renewal_type)
        _setter("reserved_slots", reserved_slots)

    @property
    @pulumi.getter
    def commitment(self) -> str:
        """
        The length of the term of your reserved queue pricing plan commitment. Valid value is `ONE_YEAR`.
        """
        return pulumi.get(self, "commitment")

    @property
    @pulumi.getter(name="renewalType")
    def renewal_type(self) -> str:
        """
        Specifies whether the term of your reserved queue pricing plan. Valid values are `AUTO_RENEW` or `EXPIRE`.
        """
        return pulumi.get(self, "renewal_type")

    @property
    @pulumi.getter(name="reservedSlots")
    def reserved_slots(self) -> int:
        """
        Specifies the number of reserved transcode slots (RTS) for queue.
        """
        return pulumi.get(self, "reserved_slots")


