# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from ._inputs import *

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 access_key: Optional[pulumi.Input[str]] = None,
                 allowed_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 assume_role: Optional[pulumi.Input['ProviderAssumeRoleArgs']] = None,
                 assume_role_with_web_identity: Optional[pulumi.Input['ProviderAssumeRoleWithWebIdentityArgs']] = None,
                 custom_ca_bundle: Optional[pulumi.Input[str]] = None,
                 default_tags: Optional[pulumi.Input['ProviderDefaultTagsArgs']] = None,
                 ec2_metadata_service_endpoint: Optional[pulumi.Input[str]] = None,
                 ec2_metadata_service_endpoint_mode: Optional[pulumi.Input[str]] = None,
                 endpoints: Optional[pulumi.Input[Sequence[pulumi.Input['ProviderEndpointArgs']]]] = None,
                 forbidden_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_proxy: Optional[pulumi.Input[str]] = None,
                 ignore_tags: Optional[pulumi.Input['ProviderIgnoreTagsArgs']] = None,
                 insecure: Optional[pulumi.Input[bool]] = None,
                 max_retries: Optional[pulumi.Input[int]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 retry_mode: Optional[pulumi.Input[str]] = None,
                 s3_us_east1_regional_endpoint: Optional[pulumi.Input[str]] = None,
                 s3_use_path_style: Optional[pulumi.Input[bool]] = None,
                 secret_key: Optional[pulumi.Input[str]] = None,
                 shared_config_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 shared_credentials_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 skip_credentials_validation: Optional[pulumi.Input[bool]] = None,
                 skip_metadata_api_check: Optional[pulumi.Input[bool]] = None,
                 skip_region_validation: Optional[pulumi.Input[bool]] = None,
                 skip_requesting_account_id: Optional[pulumi.Input[bool]] = None,
                 sts_region: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 use_dualstack_endpoint: Optional[pulumi.Input[bool]] = None,
                 use_fips_endpoint: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] access_key: The access key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        :param pulumi.Input[str] custom_ca_bundle: File containing custom root and intermediate certificates. Can also be configured using the `AWS_CA_BUNDLE` environment
               variable. (Setting `ca_bundle` in the shared config file is not supported.)
        :param pulumi.Input['ProviderDefaultTagsArgs'] default_tags: Configuration block with settings to default resource tags across all resources.
        :param pulumi.Input[str] ec2_metadata_service_endpoint: Address of the EC2 metadata service endpoint to use. Can also be configured using the
               `AWS_EC2_METADATA_SERVICE_ENDPOINT` environment variable.
        :param pulumi.Input[str] ec2_metadata_service_endpoint_mode: Protocol to use with EC2 metadata service endpoint.Valid values are `IPv4` and `IPv6`. Can also be configured using the
               `AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE` environment variable.
        :param pulumi.Input[str] http_proxy: The address of an HTTP proxy to use when accessing the AWS API. Can also be configured using the `HTTP_PROXY` or
               `HTTPS_PROXY` environment variables.
        :param pulumi.Input['ProviderIgnoreTagsArgs'] ignore_tags: Configuration block with settings to ignore resource tags across all resources.
        :param pulumi.Input[bool] insecure: Explicitly allow the provider to perform "insecure" SSL requests. If omitted, default value is `false`
        :param pulumi.Input[int] max_retries: The maximum number of times an AWS API request is being executed. If the API request still fails, an error is thrown.
        :param pulumi.Input[str] profile: The profile for API operations. If not set, the default profile created with `aws configure` will be used.
        :param pulumi.Input[str] region: The region where AWS operations will take place. Examples are us-east-1, us-west-2, etc.
        :param pulumi.Input[str] retry_mode: Specifies how retries are attempted. Valid values are `standard` and `adaptive`. Can also be configured using the
               `AWS_RETRY_MODE` environment variable.
        :param pulumi.Input[str] s3_us_east1_regional_endpoint: Specifies whether S3 API calls in the `us-east-1` region use the legacy global endpoint or a regional endpoint. Valid
               values are `legacy` or `regional`. Can also be configured using the `AWS_S3_US_EAST_1_REGIONAL_ENDPOINT` environment
               variable or the `s3_us_east_1_regional_endpoint` shared config file parameter
        :param pulumi.Input[bool] s3_use_path_style: Set this to true to enable the request to use path-style addressing, i.e., https://s3.amazonaws.com/BUCKET/KEY. By
               default, the S3 client will use virtual hosted bucket addressing when possible (https://BUCKET.s3.amazonaws.com/KEY).
               Specific to the Amazon S3 service.
        :param pulumi.Input[str] secret_key: The secret key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] shared_config_files: List of paths to shared config files. If not set, defaults to [~/.aws/config].
        :param pulumi.Input[Sequence[pulumi.Input[str]]] shared_credentials_files: List of paths to shared credentials files. If not set, defaults to [~/.aws/credentials].
        :param pulumi.Input[bool] skip_credentials_validation: Skip the credentials validation via STS API. Used for AWS API implementations that do not have STS
               available/implemented.
        :param pulumi.Input[bool] skip_metadata_api_check: Skip the AWS Metadata API check. Used for AWS API implementations that do not have a metadata api endpoint.
        :param pulumi.Input[bool] skip_region_validation: Skip static validation of region name. Used by users of alternative AWS-like APIs or users w/ access to regions that are
               not public (yet).
        :param pulumi.Input[bool] skip_requesting_account_id: Skip requesting the account ID. Used for AWS API implementations that do not have IAM/STS API and/or metadata API.
        :param pulumi.Input[str] sts_region: The region where AWS STS operations will take place. Examples are us-east-1 and us-west-2.
        :param pulumi.Input[str] token: session token. A session token is only required if you are using temporary security credentials.
        :param pulumi.Input[bool] use_dualstack_endpoint: Resolve an endpoint with DualStack capability
        :param pulumi.Input[bool] use_fips_endpoint: Resolve an endpoint with FIPS capability
        """
        ProviderArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            access_key=access_key,
            allowed_account_ids=allowed_account_ids,
            assume_role=assume_role,
            assume_role_with_web_identity=assume_role_with_web_identity,
            custom_ca_bundle=custom_ca_bundle,
            default_tags=default_tags,
            ec2_metadata_service_endpoint=ec2_metadata_service_endpoint,
            ec2_metadata_service_endpoint_mode=ec2_metadata_service_endpoint_mode,
            endpoints=endpoints,
            forbidden_account_ids=forbidden_account_ids,
            http_proxy=http_proxy,
            ignore_tags=ignore_tags,
            insecure=insecure,
            max_retries=max_retries,
            profile=profile,
            region=region,
            retry_mode=retry_mode,
            s3_us_east1_regional_endpoint=s3_us_east1_regional_endpoint,
            s3_use_path_style=s3_use_path_style,
            secret_key=secret_key,
            shared_config_files=shared_config_files,
            shared_credentials_files=shared_credentials_files,
            skip_credentials_validation=skip_credentials_validation,
            skip_metadata_api_check=skip_metadata_api_check,
            skip_region_validation=skip_region_validation,
            skip_requesting_account_id=skip_requesting_account_id,
            sts_region=sts_region,
            token=token,
            use_dualstack_endpoint=use_dualstack_endpoint,
            use_fips_endpoint=use_fips_endpoint,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             access_key: Optional[pulumi.Input[str]] = None,
             allowed_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             assume_role: Optional[pulumi.Input['ProviderAssumeRoleArgs']] = None,
             assume_role_with_web_identity: Optional[pulumi.Input['ProviderAssumeRoleWithWebIdentityArgs']] = None,
             custom_ca_bundle: Optional[pulumi.Input[str]] = None,
             default_tags: Optional[pulumi.Input['ProviderDefaultTagsArgs']] = None,
             ec2_metadata_service_endpoint: Optional[pulumi.Input[str]] = None,
             ec2_metadata_service_endpoint_mode: Optional[pulumi.Input[str]] = None,
             endpoints: Optional[pulumi.Input[Sequence[pulumi.Input['ProviderEndpointArgs']]]] = None,
             forbidden_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             http_proxy: Optional[pulumi.Input[str]] = None,
             ignore_tags: Optional[pulumi.Input['ProviderIgnoreTagsArgs']] = None,
             insecure: Optional[pulumi.Input[bool]] = None,
             max_retries: Optional[pulumi.Input[int]] = None,
             profile: Optional[pulumi.Input[str]] = None,
             region: Optional[pulumi.Input[str]] = None,
             retry_mode: Optional[pulumi.Input[str]] = None,
             s3_us_east1_regional_endpoint: Optional[pulumi.Input[str]] = None,
             s3_use_path_style: Optional[pulumi.Input[bool]] = None,
             secret_key: Optional[pulumi.Input[str]] = None,
             shared_config_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             shared_credentials_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             skip_credentials_validation: Optional[pulumi.Input[bool]] = None,
             skip_metadata_api_check: Optional[pulumi.Input[bool]] = None,
             skip_region_validation: Optional[pulumi.Input[bool]] = None,
             skip_requesting_account_id: Optional[pulumi.Input[bool]] = None,
             sts_region: Optional[pulumi.Input[str]] = None,
             token: Optional[pulumi.Input[str]] = None,
             use_dualstack_endpoint: Optional[pulumi.Input[bool]] = None,
             use_fips_endpoint: Optional[pulumi.Input[bool]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if access_key is None and 'accessKey' in kwargs:
            access_key = kwargs['accessKey']
        if allowed_account_ids is None and 'allowedAccountIds' in kwargs:
            allowed_account_ids = kwargs['allowedAccountIds']
        if assume_role is None and 'assumeRole' in kwargs:
            assume_role = kwargs['assumeRole']
        if assume_role_with_web_identity is None and 'assumeRoleWithWebIdentity' in kwargs:
            assume_role_with_web_identity = kwargs['assumeRoleWithWebIdentity']
        if custom_ca_bundle is None and 'customCaBundle' in kwargs:
            custom_ca_bundle = kwargs['customCaBundle']
        if default_tags is None and 'defaultTags' in kwargs:
            default_tags = kwargs['defaultTags']
        if ec2_metadata_service_endpoint is None and 'ec2MetadataServiceEndpoint' in kwargs:
            ec2_metadata_service_endpoint = kwargs['ec2MetadataServiceEndpoint']
        if ec2_metadata_service_endpoint_mode is None and 'ec2MetadataServiceEndpointMode' in kwargs:
            ec2_metadata_service_endpoint_mode = kwargs['ec2MetadataServiceEndpointMode']
        if forbidden_account_ids is None and 'forbiddenAccountIds' in kwargs:
            forbidden_account_ids = kwargs['forbiddenAccountIds']
        if http_proxy is None and 'httpProxy' in kwargs:
            http_proxy = kwargs['httpProxy']
        if ignore_tags is None and 'ignoreTags' in kwargs:
            ignore_tags = kwargs['ignoreTags']
        if max_retries is None and 'maxRetries' in kwargs:
            max_retries = kwargs['maxRetries']
        if retry_mode is None and 'retryMode' in kwargs:
            retry_mode = kwargs['retryMode']
        if s3_us_east1_regional_endpoint is None and 's3UsEast1RegionalEndpoint' in kwargs:
            s3_us_east1_regional_endpoint = kwargs['s3UsEast1RegionalEndpoint']
        if s3_use_path_style is None and 's3UsePathStyle' in kwargs:
            s3_use_path_style = kwargs['s3UsePathStyle']
        if secret_key is None and 'secretKey' in kwargs:
            secret_key = kwargs['secretKey']
        if shared_config_files is None and 'sharedConfigFiles' in kwargs:
            shared_config_files = kwargs['sharedConfigFiles']
        if shared_credentials_files is None and 'sharedCredentialsFiles' in kwargs:
            shared_credentials_files = kwargs['sharedCredentialsFiles']
        if skip_credentials_validation is None and 'skipCredentialsValidation' in kwargs:
            skip_credentials_validation = kwargs['skipCredentialsValidation']
        if skip_metadata_api_check is None and 'skipMetadataApiCheck' in kwargs:
            skip_metadata_api_check = kwargs['skipMetadataApiCheck']
        if skip_region_validation is None and 'skipRegionValidation' in kwargs:
            skip_region_validation = kwargs['skipRegionValidation']
        if skip_requesting_account_id is None and 'skipRequestingAccountId' in kwargs:
            skip_requesting_account_id = kwargs['skipRequestingAccountId']
        if sts_region is None and 'stsRegion' in kwargs:
            sts_region = kwargs['stsRegion']
        if use_dualstack_endpoint is None and 'useDualstackEndpoint' in kwargs:
            use_dualstack_endpoint = kwargs['useDualstackEndpoint']
        if use_fips_endpoint is None and 'useFipsEndpoint' in kwargs:
            use_fips_endpoint = kwargs['useFipsEndpoint']

        if access_key is not None:
            _setter("access_key", access_key)
        if allowed_account_ids is not None:
            _setter("allowed_account_ids", allowed_account_ids)
        if assume_role is not None:
            _setter("assume_role", assume_role)
        if assume_role_with_web_identity is not None:
            _setter("assume_role_with_web_identity", assume_role_with_web_identity)
        if custom_ca_bundle is not None:
            _setter("custom_ca_bundle", custom_ca_bundle)
        if default_tags is not None:
            _setter("default_tags", default_tags)
        if ec2_metadata_service_endpoint is not None:
            _setter("ec2_metadata_service_endpoint", ec2_metadata_service_endpoint)
        if ec2_metadata_service_endpoint_mode is not None:
            _setter("ec2_metadata_service_endpoint_mode", ec2_metadata_service_endpoint_mode)
        if endpoints is not None:
            _setter("endpoints", endpoints)
        if forbidden_account_ids is not None:
            _setter("forbidden_account_ids", forbidden_account_ids)
        if http_proxy is not None:
            _setter("http_proxy", http_proxy)
        if ignore_tags is not None:
            _setter("ignore_tags", ignore_tags)
        if insecure is not None:
            _setter("insecure", insecure)
        if max_retries is not None:
            _setter("max_retries", max_retries)
        if profile is not None:
            _setter("profile", profile)
        if region is None:
            region = _utilities.get_env('AWS_REGION', 'AWS_DEFAULT_REGION')
        if region is not None:
            _setter("region", region)
        if retry_mode is not None:
            _setter("retry_mode", retry_mode)
        if s3_us_east1_regional_endpoint is not None:
            _setter("s3_us_east1_regional_endpoint", s3_us_east1_regional_endpoint)
        if s3_use_path_style is not None:
            _setter("s3_use_path_style", s3_use_path_style)
        if secret_key is not None:
            _setter("secret_key", secret_key)
        if shared_config_files is not None:
            _setter("shared_config_files", shared_config_files)
        if shared_credentials_files is not None:
            _setter("shared_credentials_files", shared_credentials_files)
        if skip_credentials_validation is None:
            skip_credentials_validation = False
        if skip_credentials_validation is not None:
            _setter("skip_credentials_validation", skip_credentials_validation)
        if skip_metadata_api_check is None:
            skip_metadata_api_check = True
        if skip_metadata_api_check is not None:
            _setter("skip_metadata_api_check", skip_metadata_api_check)
        if skip_region_validation is None:
            skip_region_validation = True
        if skip_region_validation is not None:
            _setter("skip_region_validation", skip_region_validation)
        if skip_requesting_account_id is not None:
            _setter("skip_requesting_account_id", skip_requesting_account_id)
        if sts_region is not None:
            _setter("sts_region", sts_region)
        if token is not None:
            _setter("token", token)
        if use_dualstack_endpoint is not None:
            _setter("use_dualstack_endpoint", use_dualstack_endpoint)
        if use_fips_endpoint is not None:
            _setter("use_fips_endpoint", use_fips_endpoint)

    @property
    @pulumi.getter(name="accessKey")
    def access_key(self) -> Optional[pulumi.Input[str]]:
        """
        The access key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        """
        return pulumi.get(self, "access_key")

    @access_key.setter
    def access_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_key", value)

    @property
    @pulumi.getter(name="allowedAccountIds")
    def allowed_account_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "allowed_account_ids")

    @allowed_account_ids.setter
    def allowed_account_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "allowed_account_ids", value)

    @property
    @pulumi.getter(name="assumeRole")
    def assume_role(self) -> Optional[pulumi.Input['ProviderAssumeRoleArgs']]:
        return pulumi.get(self, "assume_role")

    @assume_role.setter
    def assume_role(self, value: Optional[pulumi.Input['ProviderAssumeRoleArgs']]):
        pulumi.set(self, "assume_role", value)

    @property
    @pulumi.getter(name="assumeRoleWithWebIdentity")
    def assume_role_with_web_identity(self) -> Optional[pulumi.Input['ProviderAssumeRoleWithWebIdentityArgs']]:
        return pulumi.get(self, "assume_role_with_web_identity")

    @assume_role_with_web_identity.setter
    def assume_role_with_web_identity(self, value: Optional[pulumi.Input['ProviderAssumeRoleWithWebIdentityArgs']]):
        pulumi.set(self, "assume_role_with_web_identity", value)

    @property
    @pulumi.getter(name="customCaBundle")
    def custom_ca_bundle(self) -> Optional[pulumi.Input[str]]:
        """
        File containing custom root and intermediate certificates. Can also be configured using the `AWS_CA_BUNDLE` environment
        variable. (Setting `ca_bundle` in the shared config file is not supported.)
        """
        return pulumi.get(self, "custom_ca_bundle")

    @custom_ca_bundle.setter
    def custom_ca_bundle(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_ca_bundle", value)

    @property
    @pulumi.getter(name="defaultTags")
    def default_tags(self) -> Optional[pulumi.Input['ProviderDefaultTagsArgs']]:
        """
        Configuration block with settings to default resource tags across all resources.
        """
        return pulumi.get(self, "default_tags")

    @default_tags.setter
    def default_tags(self, value: Optional[pulumi.Input['ProviderDefaultTagsArgs']]):
        pulumi.set(self, "default_tags", value)

    @property
    @pulumi.getter(name="ec2MetadataServiceEndpoint")
    def ec2_metadata_service_endpoint(self) -> Optional[pulumi.Input[str]]:
        """
        Address of the EC2 metadata service endpoint to use. Can also be configured using the
        `AWS_EC2_METADATA_SERVICE_ENDPOINT` environment variable.
        """
        return pulumi.get(self, "ec2_metadata_service_endpoint")

    @ec2_metadata_service_endpoint.setter
    def ec2_metadata_service_endpoint(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ec2_metadata_service_endpoint", value)

    @property
    @pulumi.getter(name="ec2MetadataServiceEndpointMode")
    def ec2_metadata_service_endpoint_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Protocol to use with EC2 metadata service endpoint.Valid values are `IPv4` and `IPv6`. Can also be configured using the
        `AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE` environment variable.
        """
        return pulumi.get(self, "ec2_metadata_service_endpoint_mode")

    @ec2_metadata_service_endpoint_mode.setter
    def ec2_metadata_service_endpoint_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ec2_metadata_service_endpoint_mode", value)

    @property
    @pulumi.getter
    def endpoints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProviderEndpointArgs']]]]:
        return pulumi.get(self, "endpoints")

    @endpoints.setter
    def endpoints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProviderEndpointArgs']]]]):
        pulumi.set(self, "endpoints", value)

    @property
    @pulumi.getter(name="forbiddenAccountIds")
    def forbidden_account_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "forbidden_account_ids")

    @forbidden_account_ids.setter
    def forbidden_account_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "forbidden_account_ids", value)

    @property
    @pulumi.getter(name="httpProxy")
    def http_proxy(self) -> Optional[pulumi.Input[str]]:
        """
        The address of an HTTP proxy to use when accessing the AWS API. Can also be configured using the `HTTP_PROXY` or
        `HTTPS_PROXY` environment variables.
        """
        return pulumi.get(self, "http_proxy")

    @http_proxy.setter
    def http_proxy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "http_proxy", value)

    @property
    @pulumi.getter(name="ignoreTags")
    def ignore_tags(self) -> Optional[pulumi.Input['ProviderIgnoreTagsArgs']]:
        """
        Configuration block with settings to ignore resource tags across all resources.
        """
        return pulumi.get(self, "ignore_tags")

    @ignore_tags.setter
    def ignore_tags(self, value: Optional[pulumi.Input['ProviderIgnoreTagsArgs']]):
        pulumi.set(self, "ignore_tags", value)

    @property
    @pulumi.getter
    def insecure(self) -> Optional[pulumi.Input[bool]]:
        """
        Explicitly allow the provider to perform "insecure" SSL requests. If omitted, default value is `false`
        """
        return pulumi.get(self, "insecure")

    @insecure.setter
    def insecure(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "insecure", value)

    @property
    @pulumi.getter(name="maxRetries")
    def max_retries(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum number of times an AWS API request is being executed. If the API request still fails, an error is thrown.
        """
        return pulumi.get(self, "max_retries")

    @max_retries.setter
    def max_retries(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_retries", value)

    @property
    @pulumi.getter
    def profile(self) -> Optional[pulumi.Input[str]]:
        """
        The profile for API operations. If not set, the default profile created with `aws configure` will be used.
        """
        return pulumi.get(self, "profile")

    @profile.setter
    def profile(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region where AWS operations will take place. Examples are us-east-1, us-west-2, etc.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="retryMode")
    def retry_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies how retries are attempted. Valid values are `standard` and `adaptive`. Can also be configured using the
        `AWS_RETRY_MODE` environment variable.
        """
        return pulumi.get(self, "retry_mode")

    @retry_mode.setter
    def retry_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "retry_mode", value)

    @property
    @pulumi.getter(name="s3UsEast1RegionalEndpoint")
    def s3_us_east1_regional_endpoint(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies whether S3 API calls in the `us-east-1` region use the legacy global endpoint or a regional endpoint. Valid
        values are `legacy` or `regional`. Can also be configured using the `AWS_S3_US_EAST_1_REGIONAL_ENDPOINT` environment
        variable or the `s3_us_east_1_regional_endpoint` shared config file parameter
        """
        return pulumi.get(self, "s3_us_east1_regional_endpoint")

    @s3_us_east1_regional_endpoint.setter
    def s3_us_east1_regional_endpoint(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "s3_us_east1_regional_endpoint", value)

    @property
    @pulumi.getter(name="s3UsePathStyle")
    def s3_use_path_style(self) -> Optional[pulumi.Input[bool]]:
        """
        Set this to true to enable the request to use path-style addressing, i.e., https://s3.amazonaws.com/BUCKET/KEY. By
        default, the S3 client will use virtual hosted bucket addressing when possible (https://BUCKET.s3.amazonaws.com/KEY).
        Specific to the Amazon S3 service.
        """
        return pulumi.get(self, "s3_use_path_style")

    @s3_use_path_style.setter
    def s3_use_path_style(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "s3_use_path_style", value)

    @property
    @pulumi.getter(name="secretKey")
    def secret_key(self) -> Optional[pulumi.Input[str]]:
        """
        The secret key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        """
        return pulumi.get(self, "secret_key")

    @secret_key.setter
    def secret_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secret_key", value)

    @property
    @pulumi.getter(name="sharedConfigFiles")
    def shared_config_files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of paths to shared config files. If not set, defaults to [~/.aws/config].
        """
        return pulumi.get(self, "shared_config_files")

    @shared_config_files.setter
    def shared_config_files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "shared_config_files", value)

    @property
    @pulumi.getter(name="sharedCredentialsFiles")
    def shared_credentials_files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of paths to shared credentials files. If not set, defaults to [~/.aws/credentials].
        """
        return pulumi.get(self, "shared_credentials_files")

    @shared_credentials_files.setter
    def shared_credentials_files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "shared_credentials_files", value)

    @property
    @pulumi.getter(name="skipCredentialsValidation")
    def skip_credentials_validation(self) -> Optional[pulumi.Input[bool]]:
        """
        Skip the credentials validation via STS API. Used for AWS API implementations that do not have STS
        available/implemented.
        """
        return pulumi.get(self, "skip_credentials_validation")

    @skip_credentials_validation.setter
    def skip_credentials_validation(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "skip_credentials_validation", value)

    @property
    @pulumi.getter(name="skipMetadataApiCheck")
    def skip_metadata_api_check(self) -> Optional[pulumi.Input[bool]]:
        """
        Skip the AWS Metadata API check. Used for AWS API implementations that do not have a metadata api endpoint.
        """
        return pulumi.get(self, "skip_metadata_api_check")

    @skip_metadata_api_check.setter
    def skip_metadata_api_check(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "skip_metadata_api_check", value)

    @property
    @pulumi.getter(name="skipRegionValidation")
    def skip_region_validation(self) -> Optional[pulumi.Input[bool]]:
        """
        Skip static validation of region name. Used by users of alternative AWS-like APIs or users w/ access to regions that are
        not public (yet).
        """
        return pulumi.get(self, "skip_region_validation")

    @skip_region_validation.setter
    def skip_region_validation(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "skip_region_validation", value)

    @property
    @pulumi.getter(name="skipRequestingAccountId")
    def skip_requesting_account_id(self) -> Optional[pulumi.Input[bool]]:
        """
        Skip requesting the account ID. Used for AWS API implementations that do not have IAM/STS API and/or metadata API.
        """
        return pulumi.get(self, "skip_requesting_account_id")

    @skip_requesting_account_id.setter
    def skip_requesting_account_id(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "skip_requesting_account_id", value)

    @property
    @pulumi.getter(name="stsRegion")
    def sts_region(self) -> Optional[pulumi.Input[str]]:
        """
        The region where AWS STS operations will take place. Examples are us-east-1 and us-west-2.
        """
        return pulumi.get(self, "sts_region")

    @sts_region.setter
    def sts_region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sts_region", value)

    @property
    @pulumi.getter
    def token(self) -> Optional[pulumi.Input[str]]:
        """
        session token. A session token is only required if you are using temporary security credentials.
        """
        return pulumi.get(self, "token")

    @token.setter
    def token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "token", value)

    @property
    @pulumi.getter(name="useDualstackEndpoint")
    def use_dualstack_endpoint(self) -> Optional[pulumi.Input[bool]]:
        """
        Resolve an endpoint with DualStack capability
        """
        return pulumi.get(self, "use_dualstack_endpoint")

    @use_dualstack_endpoint.setter
    def use_dualstack_endpoint(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_dualstack_endpoint", value)

    @property
    @pulumi.getter(name="useFipsEndpoint")
    def use_fips_endpoint(self) -> Optional[pulumi.Input[bool]]:
        """
        Resolve an endpoint with FIPS capability
        """
        return pulumi.get(self, "use_fips_endpoint")

    @use_fips_endpoint.setter
    def use_fips_endpoint(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "use_fips_endpoint", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_key: Optional[pulumi.Input[str]] = None,
                 allowed_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 assume_role: Optional[pulumi.Input[pulumi.InputType['ProviderAssumeRoleArgs']]] = None,
                 assume_role_with_web_identity: Optional[pulumi.Input[pulumi.InputType['ProviderAssumeRoleWithWebIdentityArgs']]] = None,
                 custom_ca_bundle: Optional[pulumi.Input[str]] = None,
                 default_tags: Optional[pulumi.Input[pulumi.InputType['ProviderDefaultTagsArgs']]] = None,
                 ec2_metadata_service_endpoint: Optional[pulumi.Input[str]] = None,
                 ec2_metadata_service_endpoint_mode: Optional[pulumi.Input[str]] = None,
                 endpoints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProviderEndpointArgs']]]]] = None,
                 forbidden_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_proxy: Optional[pulumi.Input[str]] = None,
                 ignore_tags: Optional[pulumi.Input[pulumi.InputType['ProviderIgnoreTagsArgs']]] = None,
                 insecure: Optional[pulumi.Input[bool]] = None,
                 max_retries: Optional[pulumi.Input[int]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 retry_mode: Optional[pulumi.Input[str]] = None,
                 s3_us_east1_regional_endpoint: Optional[pulumi.Input[str]] = None,
                 s3_use_path_style: Optional[pulumi.Input[bool]] = None,
                 secret_key: Optional[pulumi.Input[str]] = None,
                 shared_config_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 shared_credentials_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 skip_credentials_validation: Optional[pulumi.Input[bool]] = None,
                 skip_metadata_api_check: Optional[pulumi.Input[bool]] = None,
                 skip_region_validation: Optional[pulumi.Input[bool]] = None,
                 skip_requesting_account_id: Optional[pulumi.Input[bool]] = None,
                 sts_region: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 use_dualstack_endpoint: Optional[pulumi.Input[bool]] = None,
                 use_fips_endpoint: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        The provider type for the aws package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_key: The access key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        :param pulumi.Input[str] custom_ca_bundle: File containing custom root and intermediate certificates. Can also be configured using the `AWS_CA_BUNDLE` environment
               variable. (Setting `ca_bundle` in the shared config file is not supported.)
        :param pulumi.Input[pulumi.InputType['ProviderDefaultTagsArgs']] default_tags: Configuration block with settings to default resource tags across all resources.
        :param pulumi.Input[str] ec2_metadata_service_endpoint: Address of the EC2 metadata service endpoint to use. Can also be configured using the
               `AWS_EC2_METADATA_SERVICE_ENDPOINT` environment variable.
        :param pulumi.Input[str] ec2_metadata_service_endpoint_mode: Protocol to use with EC2 metadata service endpoint.Valid values are `IPv4` and `IPv6`. Can also be configured using the
               `AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE` environment variable.
        :param pulumi.Input[str] http_proxy: The address of an HTTP proxy to use when accessing the AWS API. Can also be configured using the `HTTP_PROXY` or
               `HTTPS_PROXY` environment variables.
        :param pulumi.Input[pulumi.InputType['ProviderIgnoreTagsArgs']] ignore_tags: Configuration block with settings to ignore resource tags across all resources.
        :param pulumi.Input[bool] insecure: Explicitly allow the provider to perform "insecure" SSL requests. If omitted, default value is `false`
        :param pulumi.Input[int] max_retries: The maximum number of times an AWS API request is being executed. If the API request still fails, an error is thrown.
        :param pulumi.Input[str] profile: The profile for API operations. If not set, the default profile created with `aws configure` will be used.
        :param pulumi.Input[str] region: The region where AWS operations will take place. Examples are us-east-1, us-west-2, etc.
        :param pulumi.Input[str] retry_mode: Specifies how retries are attempted. Valid values are `standard` and `adaptive`. Can also be configured using the
               `AWS_RETRY_MODE` environment variable.
        :param pulumi.Input[str] s3_us_east1_regional_endpoint: Specifies whether S3 API calls in the `us-east-1` region use the legacy global endpoint or a regional endpoint. Valid
               values are `legacy` or `regional`. Can also be configured using the `AWS_S3_US_EAST_1_REGIONAL_ENDPOINT` environment
               variable or the `s3_us_east_1_regional_endpoint` shared config file parameter
        :param pulumi.Input[bool] s3_use_path_style: Set this to true to enable the request to use path-style addressing, i.e., https://s3.amazonaws.com/BUCKET/KEY. By
               default, the S3 client will use virtual hosted bucket addressing when possible (https://BUCKET.s3.amazonaws.com/KEY).
               Specific to the Amazon S3 service.
        :param pulumi.Input[str] secret_key: The secret key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] shared_config_files: List of paths to shared config files. If not set, defaults to [~/.aws/config].
        :param pulumi.Input[Sequence[pulumi.Input[str]]] shared_credentials_files: List of paths to shared credentials files. If not set, defaults to [~/.aws/credentials].
        :param pulumi.Input[bool] skip_credentials_validation: Skip the credentials validation via STS API. Used for AWS API implementations that do not have STS
               available/implemented.
        :param pulumi.Input[bool] skip_metadata_api_check: Skip the AWS Metadata API check. Used for AWS API implementations that do not have a metadata api endpoint.
        :param pulumi.Input[bool] skip_region_validation: Skip static validation of region name. Used by users of alternative AWS-like APIs or users w/ access to regions that are
               not public (yet).
        :param pulumi.Input[bool] skip_requesting_account_id: Skip requesting the account ID. Used for AWS API implementations that do not have IAM/STS API and/or metadata API.
        :param pulumi.Input[str] sts_region: The region where AWS STS operations will take place. Examples are us-east-1 and us-west-2.
        :param pulumi.Input[str] token: session token. A session token is only required if you are using temporary security credentials.
        :param pulumi.Input[bool] use_dualstack_endpoint: Resolve an endpoint with DualStack capability
        :param pulumi.Input[bool] use_fips_endpoint: Resolve an endpoint with FIPS capability
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the aws package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            ProviderArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_key: Optional[pulumi.Input[str]] = None,
                 allowed_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 assume_role: Optional[pulumi.Input[pulumi.InputType['ProviderAssumeRoleArgs']]] = None,
                 assume_role_with_web_identity: Optional[pulumi.Input[pulumi.InputType['ProviderAssumeRoleWithWebIdentityArgs']]] = None,
                 custom_ca_bundle: Optional[pulumi.Input[str]] = None,
                 default_tags: Optional[pulumi.Input[pulumi.InputType['ProviderDefaultTagsArgs']]] = None,
                 ec2_metadata_service_endpoint: Optional[pulumi.Input[str]] = None,
                 ec2_metadata_service_endpoint_mode: Optional[pulumi.Input[str]] = None,
                 endpoints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProviderEndpointArgs']]]]] = None,
                 forbidden_account_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 http_proxy: Optional[pulumi.Input[str]] = None,
                 ignore_tags: Optional[pulumi.Input[pulumi.InputType['ProviderIgnoreTagsArgs']]] = None,
                 insecure: Optional[pulumi.Input[bool]] = None,
                 max_retries: Optional[pulumi.Input[int]] = None,
                 profile: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 retry_mode: Optional[pulumi.Input[str]] = None,
                 s3_us_east1_regional_endpoint: Optional[pulumi.Input[str]] = None,
                 s3_use_path_style: Optional[pulumi.Input[bool]] = None,
                 secret_key: Optional[pulumi.Input[str]] = None,
                 shared_config_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 shared_credentials_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 skip_credentials_validation: Optional[pulumi.Input[bool]] = None,
                 skip_metadata_api_check: Optional[pulumi.Input[bool]] = None,
                 skip_region_validation: Optional[pulumi.Input[bool]] = None,
                 skip_requesting_account_id: Optional[pulumi.Input[bool]] = None,
                 sts_region: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 use_dualstack_endpoint: Optional[pulumi.Input[bool]] = None,
                 use_fips_endpoint: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["access_key"] = access_key
            __props__.__dict__["allowed_account_ids"] = pulumi.Output.from_input(allowed_account_ids).apply(pulumi.runtime.to_json) if allowed_account_ids is not None else None
            assume_role = _utilities.configure(assume_role, ProviderAssumeRoleArgs, True)
            __props__.__dict__["assume_role"] = pulumi.Output.from_input(assume_role).apply(pulumi.runtime.to_json) if assume_role is not None else None
            assume_role_with_web_identity = _utilities.configure(assume_role_with_web_identity, ProviderAssumeRoleWithWebIdentityArgs, True)
            __props__.__dict__["assume_role_with_web_identity"] = pulumi.Output.from_input(assume_role_with_web_identity).apply(pulumi.runtime.to_json) if assume_role_with_web_identity is not None else None
            __props__.__dict__["custom_ca_bundle"] = custom_ca_bundle
            default_tags = _utilities.configure(default_tags, ProviderDefaultTagsArgs, True)
            __props__.__dict__["default_tags"] = pulumi.Output.from_input(default_tags).apply(pulumi.runtime.to_json) if default_tags is not None else None
            __props__.__dict__["ec2_metadata_service_endpoint"] = ec2_metadata_service_endpoint
            __props__.__dict__["ec2_metadata_service_endpoint_mode"] = ec2_metadata_service_endpoint_mode
            __props__.__dict__["endpoints"] = pulumi.Output.from_input(endpoints).apply(pulumi.runtime.to_json) if endpoints is not None else None
            __props__.__dict__["forbidden_account_ids"] = pulumi.Output.from_input(forbidden_account_ids).apply(pulumi.runtime.to_json) if forbidden_account_ids is not None else None
            __props__.__dict__["http_proxy"] = http_proxy
            ignore_tags = _utilities.configure(ignore_tags, ProviderIgnoreTagsArgs, True)
            __props__.__dict__["ignore_tags"] = pulumi.Output.from_input(ignore_tags).apply(pulumi.runtime.to_json) if ignore_tags is not None else None
            __props__.__dict__["insecure"] = pulumi.Output.from_input(insecure).apply(pulumi.runtime.to_json) if insecure is not None else None
            __props__.__dict__["max_retries"] = pulumi.Output.from_input(max_retries).apply(pulumi.runtime.to_json) if max_retries is not None else None
            __props__.__dict__["profile"] = profile
            if region is None:
                region = _utilities.get_env('AWS_REGION', 'AWS_DEFAULT_REGION')
            __props__.__dict__["region"] = region
            __props__.__dict__["retry_mode"] = retry_mode
            __props__.__dict__["s3_us_east1_regional_endpoint"] = s3_us_east1_regional_endpoint
            __props__.__dict__["s3_use_path_style"] = pulumi.Output.from_input(s3_use_path_style).apply(pulumi.runtime.to_json) if s3_use_path_style is not None else None
            __props__.__dict__["secret_key"] = secret_key
            __props__.__dict__["shared_config_files"] = pulumi.Output.from_input(shared_config_files).apply(pulumi.runtime.to_json) if shared_config_files is not None else None
            __props__.__dict__["shared_credentials_files"] = pulumi.Output.from_input(shared_credentials_files).apply(pulumi.runtime.to_json) if shared_credentials_files is not None else None
            if skip_credentials_validation is None:
                skip_credentials_validation = False
            __props__.__dict__["skip_credentials_validation"] = pulumi.Output.from_input(skip_credentials_validation).apply(pulumi.runtime.to_json) if skip_credentials_validation is not None else None
            if skip_metadata_api_check is None:
                skip_metadata_api_check = True
            __props__.__dict__["skip_metadata_api_check"] = pulumi.Output.from_input(skip_metadata_api_check).apply(pulumi.runtime.to_json) if skip_metadata_api_check is not None else None
            if skip_region_validation is None:
                skip_region_validation = True
            __props__.__dict__["skip_region_validation"] = pulumi.Output.from_input(skip_region_validation).apply(pulumi.runtime.to_json) if skip_region_validation is not None else None
            __props__.__dict__["skip_requesting_account_id"] = pulumi.Output.from_input(skip_requesting_account_id).apply(pulumi.runtime.to_json) if skip_requesting_account_id is not None else None
            __props__.__dict__["sts_region"] = sts_region
            __props__.__dict__["token"] = token
            __props__.__dict__["use_dualstack_endpoint"] = pulumi.Output.from_input(use_dualstack_endpoint).apply(pulumi.runtime.to_json) if use_dualstack_endpoint is not None else None
            __props__.__dict__["use_fips_endpoint"] = pulumi.Output.from_input(use_fips_endpoint).apply(pulumi.runtime.to_json) if use_fips_endpoint is not None else None
        super(Provider, __self__).__init__(
            'aws',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter(name="accessKey")
    def access_key(self) -> pulumi.Output[Optional[str]]:
        """
        The access key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        """
        return pulumi.get(self, "access_key")

    @property
    @pulumi.getter(name="customCaBundle")
    def custom_ca_bundle(self) -> pulumi.Output[Optional[str]]:
        """
        File containing custom root and intermediate certificates. Can also be configured using the `AWS_CA_BUNDLE` environment
        variable. (Setting `ca_bundle` in the shared config file is not supported.)
        """
        return pulumi.get(self, "custom_ca_bundle")

    @property
    @pulumi.getter(name="ec2MetadataServiceEndpoint")
    def ec2_metadata_service_endpoint(self) -> pulumi.Output[Optional[str]]:
        """
        Address of the EC2 metadata service endpoint to use. Can also be configured using the
        `AWS_EC2_METADATA_SERVICE_ENDPOINT` environment variable.
        """
        return pulumi.get(self, "ec2_metadata_service_endpoint")

    @property
    @pulumi.getter(name="ec2MetadataServiceEndpointMode")
    def ec2_metadata_service_endpoint_mode(self) -> pulumi.Output[Optional[str]]:
        """
        Protocol to use with EC2 metadata service endpoint.Valid values are `IPv4` and `IPv6`. Can also be configured using the
        `AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE` environment variable.
        """
        return pulumi.get(self, "ec2_metadata_service_endpoint_mode")

    @property
    @pulumi.getter(name="httpProxy")
    def http_proxy(self) -> pulumi.Output[Optional[str]]:
        """
        The address of an HTTP proxy to use when accessing the AWS API. Can also be configured using the `HTTP_PROXY` or
        `HTTPS_PROXY` environment variables.
        """
        return pulumi.get(self, "http_proxy")

    @property
    @pulumi.getter
    def profile(self) -> pulumi.Output[Optional[str]]:
        """
        The profile for API operations. If not set, the default profile created with `aws configure` will be used.
        """
        return pulumi.get(self, "profile")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[Optional[str]]:
        """
        The region where AWS operations will take place. Examples are us-east-1, us-west-2, etc.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="retryMode")
    def retry_mode(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies how retries are attempted. Valid values are `standard` and `adaptive`. Can also be configured using the
        `AWS_RETRY_MODE` environment variable.
        """
        return pulumi.get(self, "retry_mode")

    @property
    @pulumi.getter(name="s3UsEast1RegionalEndpoint")
    def s3_us_east1_regional_endpoint(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies whether S3 API calls in the `us-east-1` region use the legacy global endpoint or a regional endpoint. Valid
        values are `legacy` or `regional`. Can also be configured using the `AWS_S3_US_EAST_1_REGIONAL_ENDPOINT` environment
        variable or the `s3_us_east_1_regional_endpoint` shared config file parameter
        """
        return pulumi.get(self, "s3_us_east1_regional_endpoint")

    @property
    @pulumi.getter(name="secretKey")
    def secret_key(self) -> pulumi.Output[Optional[str]]:
        """
        The secret key for API operations. You can retrieve this from the 'Security & Credentials' section of the AWS console.
        """
        return pulumi.get(self, "secret_key")

    @property
    @pulumi.getter(name="stsRegion")
    def sts_region(self) -> pulumi.Output[Optional[str]]:
        """
        The region where AWS STS operations will take place. Examples are us-east-1 and us-west-2.
        """
        return pulumi.get(self, "sts_region")

    @property
    @pulumi.getter
    def token(self) -> pulumi.Output[Optional[str]]:
        """
        session token. A session token is only required if you are using temporary security credentials.
        """
        return pulumi.get(self, "token")

