# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'SigningJobDestinationArgs',
    'SigningJobDestinationS3Args',
    'SigningJobRevocationRecordArgs',
    'SigningJobSignedObjectArgs',
    'SigningJobSignedObjectS3Args',
    'SigningJobSourceArgs',
    'SigningJobSourceS3Args',
    'SigningProfileRevocationRecordArgs',
    'SigningProfileSignatureValidityPeriodArgs',
    'SigningProfileSigningMaterialArgs',
]

@pulumi.input_type
class SigningJobDestinationArgs:
    def __init__(__self__, *,
                 s3: pulumi.Input['SigningJobDestinationS3Args']):
        """
        :param pulumi.Input['SigningJobDestinationS3Args'] s3: A configuration block describing the S3 Destination object: See S3 Destination below for details.
        """
        SigningJobDestinationArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            s3=s3,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             s3: Optional[pulumi.Input['SigningJobDestinationS3Args']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if s3 is None:
            raise TypeError("Missing 's3' argument")

        _setter("s3", s3)

    @property
    @pulumi.getter
    def s3(self) -> pulumi.Input['SigningJobDestinationS3Args']:
        """
        A configuration block describing the S3 Destination object: See S3 Destination below for details.
        """
        return pulumi.get(self, "s3")

    @s3.setter
    def s3(self, value: pulumi.Input['SigningJobDestinationS3Args']):
        pulumi.set(self, "s3", value)


@pulumi.input_type
class SigningJobDestinationS3Args:
    def __init__(__self__, *,
                 bucket: pulumi.Input[str],
                 prefix: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] bucket: Name of the S3 bucket.
        :param pulumi.Input[str] prefix: An Amazon S3 object key prefix that you can use to limit signed objects keys to begin with the specified prefix.
        """
        SigningJobDestinationS3Args._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            prefix=prefix,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[pulumi.Input[str]] = None,
             prefix: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if bucket is None:
            raise TypeError("Missing 'bucket' argument")

        _setter("bucket", bucket)
        if prefix is not None:
            _setter("prefix", prefix)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Input[str]:
        """
        Name of the S3 bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: pulumi.Input[str]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter
    def prefix(self) -> Optional[pulumi.Input[str]]:
        """
        An Amazon S3 object key prefix that you can use to limit signed objects keys to begin with the specified prefix.
        """
        return pulumi.get(self, "prefix")

    @prefix.setter
    def prefix(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "prefix", value)


@pulumi.input_type
class SigningJobRevocationRecordArgs:
    def __init__(__self__, *,
                 reason: Optional[pulumi.Input[str]] = None,
                 revoked_at: Optional[pulumi.Input[str]] = None,
                 revoked_by: Optional[pulumi.Input[str]] = None):
        SigningJobRevocationRecordArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            reason=reason,
            revoked_at=revoked_at,
            revoked_by=revoked_by,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             reason: Optional[pulumi.Input[str]] = None,
             revoked_at: Optional[pulumi.Input[str]] = None,
             revoked_by: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if revoked_at is None and 'revokedAt' in kwargs:
            revoked_at = kwargs['revokedAt']
        if revoked_by is None and 'revokedBy' in kwargs:
            revoked_by = kwargs['revokedBy']

        if reason is not None:
            _setter("reason", reason)
        if revoked_at is not None:
            _setter("revoked_at", revoked_at)
        if revoked_by is not None:
            _setter("revoked_by", revoked_by)

    @property
    @pulumi.getter
    def reason(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "reason")

    @reason.setter
    def reason(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reason", value)

    @property
    @pulumi.getter(name="revokedAt")
    def revoked_at(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "revoked_at")

    @revoked_at.setter
    def revoked_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "revoked_at", value)

    @property
    @pulumi.getter(name="revokedBy")
    def revoked_by(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "revoked_by")

    @revoked_by.setter
    def revoked_by(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "revoked_by", value)


@pulumi.input_type
class SigningJobSignedObjectArgs:
    def __init__(__self__, *,
                 s3s: Optional[pulumi.Input[Sequence[pulumi.Input['SigningJobSignedObjectS3Args']]]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input['SigningJobSignedObjectS3Args']]] s3s: A configuration block describing the S3 Destination object: See S3 Destination below for details.
        """
        SigningJobSignedObjectArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            s3s=s3s,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             s3s: Optional[pulumi.Input[Sequence[pulumi.Input['SigningJobSignedObjectS3Args']]]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if s3s is not None:
            _setter("s3s", s3s)

    @property
    @pulumi.getter
    def s3s(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SigningJobSignedObjectS3Args']]]]:
        """
        A configuration block describing the S3 Destination object: See S3 Destination below for details.
        """
        return pulumi.get(self, "s3s")

    @s3s.setter
    def s3s(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SigningJobSignedObjectS3Args']]]]):
        pulumi.set(self, "s3s", value)


@pulumi.input_type
class SigningJobSignedObjectS3Args:
    def __init__(__self__, *,
                 bucket: Optional[pulumi.Input[str]] = None,
                 key: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] bucket: Name of the S3 bucket.
        :param pulumi.Input[str] key: Key name of the object that contains your unsigned code.
        """
        SigningJobSignedObjectS3Args._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            key=key,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[pulumi.Input[str]] = None,
             key: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if bucket is not None:
            _setter("bucket", bucket)
        if key is not None:
            _setter("key", key)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the S3 bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        Key name of the object that contains your unsigned code.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)


@pulumi.input_type
class SigningJobSourceArgs:
    def __init__(__self__, *,
                 s3: pulumi.Input['SigningJobSourceS3Args']):
        """
        :param pulumi.Input['SigningJobSourceS3Args'] s3: A configuration block describing the S3 Source object: See S3 Source below for details.
        """
        SigningJobSourceArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            s3=s3,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             s3: Optional[pulumi.Input['SigningJobSourceS3Args']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if s3 is None:
            raise TypeError("Missing 's3' argument")

        _setter("s3", s3)

    @property
    @pulumi.getter
    def s3(self) -> pulumi.Input['SigningJobSourceS3Args']:
        """
        A configuration block describing the S3 Source object: See S3 Source below for details.
        """
        return pulumi.get(self, "s3")

    @s3.setter
    def s3(self, value: pulumi.Input['SigningJobSourceS3Args']):
        pulumi.set(self, "s3", value)


@pulumi.input_type
class SigningJobSourceS3Args:
    def __init__(__self__, *,
                 bucket: pulumi.Input[str],
                 key: pulumi.Input[str],
                 version: pulumi.Input[str]):
        """
        :param pulumi.Input[str] bucket: Name of the S3 bucket.
        :param pulumi.Input[str] key: Key name of the object that contains your unsigned code.
        :param pulumi.Input[str] version: Version of your source image in your version enabled S3 bucket.
        """
        SigningJobSourceS3Args._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket=bucket,
            key=key,
            version=version,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket: Optional[pulumi.Input[str]] = None,
             key: Optional[pulumi.Input[str]] = None,
             version: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if bucket is None:
            raise TypeError("Missing 'bucket' argument")
        if key is None:
            raise TypeError("Missing 'key' argument")
        if version is None:
            raise TypeError("Missing 'version' argument")

        _setter("bucket", bucket)
        _setter("key", key)
        _setter("version", version)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Input[str]:
        """
        Name of the S3 bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: pulumi.Input[str]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        Key name of the object that contains your unsigned code.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[str]:
        """
        Version of your source image in your version enabled S3 bucket.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[str]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class SigningProfileRevocationRecordArgs:
    def __init__(__self__, *,
                 revocation_effective_from: Optional[pulumi.Input[str]] = None,
                 revoked_at: Optional[pulumi.Input[str]] = None,
                 revoked_by: Optional[pulumi.Input[str]] = None):
        SigningProfileRevocationRecordArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            revocation_effective_from=revocation_effective_from,
            revoked_at=revoked_at,
            revoked_by=revoked_by,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             revocation_effective_from: Optional[pulumi.Input[str]] = None,
             revoked_at: Optional[pulumi.Input[str]] = None,
             revoked_by: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if revocation_effective_from is None and 'revocationEffectiveFrom' in kwargs:
            revocation_effective_from = kwargs['revocationEffectiveFrom']
        if revoked_at is None and 'revokedAt' in kwargs:
            revoked_at = kwargs['revokedAt']
        if revoked_by is None and 'revokedBy' in kwargs:
            revoked_by = kwargs['revokedBy']

        if revocation_effective_from is not None:
            _setter("revocation_effective_from", revocation_effective_from)
        if revoked_at is not None:
            _setter("revoked_at", revoked_at)
        if revoked_by is not None:
            _setter("revoked_by", revoked_by)

    @property
    @pulumi.getter(name="revocationEffectiveFrom")
    def revocation_effective_from(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "revocation_effective_from")

    @revocation_effective_from.setter
    def revocation_effective_from(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "revocation_effective_from", value)

    @property
    @pulumi.getter(name="revokedAt")
    def revoked_at(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "revoked_at")

    @revoked_at.setter
    def revoked_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "revoked_at", value)

    @property
    @pulumi.getter(name="revokedBy")
    def revoked_by(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "revoked_by")

    @revoked_by.setter
    def revoked_by(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "revoked_by", value)


@pulumi.input_type
class SigningProfileSignatureValidityPeriodArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 value: pulumi.Input[int]):
        SigningProfileSignatureValidityPeriodArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            type=type,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             type: Optional[pulumi.Input[str]] = None,
             value: Optional[pulumi.Input[int]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if type is None:
            raise TypeError("Missing 'type' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("type", type)
        _setter("value", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[int]:
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[int]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class SigningProfileSigningMaterialArgs:
    def __init__(__self__, *,
                 certificate_arn: pulumi.Input[str]):
        SigningProfileSigningMaterialArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            certificate_arn=certificate_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             certificate_arn: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if certificate_arn is None and 'certificateArn' in kwargs:
            certificate_arn = kwargs['certificateArn']
        if certificate_arn is None:
            raise TypeError("Missing 'certificate_arn' argument")

        _setter("certificate_arn", certificate_arn)

    @property
    @pulumi.getter(name="certificateArn")
    def certificate_arn(self) -> pulumi.Input[str]:
        return pulumi.get(self, "certificate_arn")

    @certificate_arn.setter
    def certificate_arn(self, value: pulumi.Input[str]):
        pulumi.set(self, "certificate_arn", value)


