# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ReplicationSetRegion',
    'ResponsePlanAction',
    'ResponsePlanActionSsmAutomation',
    'ResponsePlanActionSsmAutomationParameter',
    'ResponsePlanIncidentTemplate',
    'ResponsePlanIncidentTemplateNotificationTarget',
    'ResponsePlanIntegration',
    'ResponsePlanIntegrationPagerduty',
    'GetReplicationSetRegionResult',
    'GetResponsePlanActionResult',
    'GetResponsePlanActionSsmAutomationResult',
    'GetResponsePlanActionSsmAutomationParameterResult',
    'GetResponsePlanIncidentTemplateResult',
    'GetResponsePlanIncidentTemplateNotificationTargetResult',
    'GetResponsePlanIntegrationResult',
    'GetResponsePlanIntegrationPagerdutyResult',
]

@pulumi.output_type
class ReplicationSetRegion(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "kmsKeyArn":
            suggest = "kms_key_arn"
        elif key == "statusMessage":
            suggest = "status_message"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ReplicationSetRegion. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ReplicationSetRegion.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ReplicationSetRegion.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 kms_key_arn: Optional[str] = None,
                 status: Optional[str] = None,
                 status_message: Optional[str] = None):
        """
        :param str name: The name of the Region, such as `ap-southeast-2`.
        :param str kms_key_arn: The Amazon Resource name (ARN) of the customer managed key. If omitted, AWS manages the AWS KMS keys for you, using an AWS owned key, as indicated by a default value of `DefaultKey`.
               
               The following arguments are optional:
        :param str status: The current status of the Region.
               * Valid Values: `ACTIVE` | `CREATING` | `UPDATING` | `DELETING` | `FAILED`
        :param str status_message: More information about the status of a Region.
        """
        ReplicationSetRegion._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            kms_key_arn=kms_key_arn,
            status=status,
            status_message=status_message,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             kms_key_arn: Optional[str] = None,
             status: Optional[str] = None,
             status_message: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if kms_key_arn is None and 'kmsKeyArn' in kwargs:
            kms_key_arn = kwargs['kmsKeyArn']
        if status_message is None and 'statusMessage' in kwargs:
            status_message = kwargs['statusMessage']

        _setter("name", name)
        if kms_key_arn is not None:
            _setter("kms_key_arn", kms_key_arn)
        if status is not None:
            _setter("status", status)
        if status_message is not None:
            _setter("status_message", status_message)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Region, such as `ap-southeast-2`.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="kmsKeyArn")
    def kms_key_arn(self) -> Optional[str]:
        """
        The Amazon Resource name (ARN) of the customer managed key. If omitted, AWS manages the AWS KMS keys for you, using an AWS owned key, as indicated by a default value of `DefaultKey`.

        The following arguments are optional:
        """
        return pulumi.get(self, "kms_key_arn")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        The current status of the Region.
        * Valid Values: `ACTIVE` | `CREATING` | `UPDATING` | `DELETING` | `FAILED`
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="statusMessage")
    def status_message(self) -> Optional[str]:
        """
        More information about the status of a Region.
        """
        return pulumi.get(self, "status_message")


@pulumi.output_type
class ResponsePlanAction(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ssmAutomations":
            suggest = "ssm_automations"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResponsePlanAction. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResponsePlanAction.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResponsePlanAction.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ssm_automations: Optional[Sequence['outputs.ResponsePlanActionSsmAutomation']] = None):
        """
        :param Sequence['ResponsePlanActionSsmAutomationArgs'] ssm_automations: The Systems Manager automation document to start as the runbook at the beginning of the incident. The following values are supported:
        """
        ResponsePlanAction._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ssm_automations=ssm_automations,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ssm_automations: Optional[Sequence['outputs.ResponsePlanActionSsmAutomation']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if ssm_automations is None and 'ssmAutomations' in kwargs:
            ssm_automations = kwargs['ssmAutomations']

        if ssm_automations is not None:
            _setter("ssm_automations", ssm_automations)

    @property
    @pulumi.getter(name="ssmAutomations")
    def ssm_automations(self) -> Optional[Sequence['outputs.ResponsePlanActionSsmAutomation']]:
        """
        The Systems Manager automation document to start as the runbook at the beginning of the incident. The following values are supported:
        """
        return pulumi.get(self, "ssm_automations")


@pulumi.output_type
class ResponsePlanActionSsmAutomation(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "documentName":
            suggest = "document_name"
        elif key == "roleArn":
            suggest = "role_arn"
        elif key == "documentVersion":
            suggest = "document_version"
        elif key == "dynamicParameters":
            suggest = "dynamic_parameters"
        elif key == "targetAccount":
            suggest = "target_account"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResponsePlanActionSsmAutomation. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResponsePlanActionSsmAutomation.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResponsePlanActionSsmAutomation.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 document_name: str,
                 role_arn: str,
                 document_version: Optional[str] = None,
                 dynamic_parameters: Optional[Mapping[str, str]] = None,
                 parameters: Optional[Sequence['outputs.ResponsePlanActionSsmAutomationParameter']] = None,
                 target_account: Optional[str] = None):
        """
        :param str document_name: The automation document's name.
        :param str role_arn: The Amazon Resource Name (ARN) of the role that the automation document assumes when it runs commands.
        :param str document_version: The version of the automation document to use at runtime.
        :param Mapping[str, str] dynamic_parameters: The key-value pair to resolve dynamic parameter values when processing a Systems Manager Automation runbook.
        :param Sequence['ResponsePlanActionSsmAutomationParameterArgs'] parameters: The key-value pair parameters to use when the automation document runs. The following values are supported:
        :param str target_account: The account that the automation document runs in. This can be in either the management account or an application account.
        """
        ResponsePlanActionSsmAutomation._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            document_name=document_name,
            role_arn=role_arn,
            document_version=document_version,
            dynamic_parameters=dynamic_parameters,
            parameters=parameters,
            target_account=target_account,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             document_name: Optional[str] = None,
             role_arn: Optional[str] = None,
             document_version: Optional[str] = None,
             dynamic_parameters: Optional[Mapping[str, str]] = None,
             parameters: Optional[Sequence['outputs.ResponsePlanActionSsmAutomationParameter']] = None,
             target_account: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if document_name is None and 'documentName' in kwargs:
            document_name = kwargs['documentName']
        if document_name is None:
            raise TypeError("Missing 'document_name' argument")
        if role_arn is None and 'roleArn' in kwargs:
            role_arn = kwargs['roleArn']
        if role_arn is None:
            raise TypeError("Missing 'role_arn' argument")
        if document_version is None and 'documentVersion' in kwargs:
            document_version = kwargs['documentVersion']
        if dynamic_parameters is None and 'dynamicParameters' in kwargs:
            dynamic_parameters = kwargs['dynamicParameters']
        if target_account is None and 'targetAccount' in kwargs:
            target_account = kwargs['targetAccount']

        _setter("document_name", document_name)
        _setter("role_arn", role_arn)
        if document_version is not None:
            _setter("document_version", document_version)
        if dynamic_parameters is not None:
            _setter("dynamic_parameters", dynamic_parameters)
        if parameters is not None:
            _setter("parameters", parameters)
        if target_account is not None:
            _setter("target_account", target_account)

    @property
    @pulumi.getter(name="documentName")
    def document_name(self) -> str:
        """
        The automation document's name.
        """
        return pulumi.get(self, "document_name")

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        """
        The Amazon Resource Name (ARN) of the role that the automation document assumes when it runs commands.
        """
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="documentVersion")
    def document_version(self) -> Optional[str]:
        """
        The version of the automation document to use at runtime.
        """
        return pulumi.get(self, "document_version")

    @property
    @pulumi.getter(name="dynamicParameters")
    def dynamic_parameters(self) -> Optional[Mapping[str, str]]:
        """
        The key-value pair to resolve dynamic parameter values when processing a Systems Manager Automation runbook.
        """
        return pulumi.get(self, "dynamic_parameters")

    @property
    @pulumi.getter
    def parameters(self) -> Optional[Sequence['outputs.ResponsePlanActionSsmAutomationParameter']]:
        """
        The key-value pair parameters to use when the automation document runs. The following values are supported:
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="targetAccount")
    def target_account(self) -> Optional[str]:
        """
        The account that the automation document runs in. This can be in either the management account or an application account.
        """
        return pulumi.get(self, "target_account")


@pulumi.output_type
class ResponsePlanActionSsmAutomationParameter(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str]):
        """
        :param str name: The name of the response plan.
        :param Sequence[str] values: The values for the associated parameter name.
        """
        ResponsePlanActionSsmAutomationParameter._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             values: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if values is None:
            raise TypeError("Missing 'values' argument")

        _setter("name", name)
        _setter("values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the response plan.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        The values for the associated parameter name.
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class ResponsePlanIncidentTemplate(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dedupeString":
            suggest = "dedupe_string"
        elif key == "incidentTags":
            suggest = "incident_tags"
        elif key == "notificationTargets":
            suggest = "notification_targets"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResponsePlanIncidentTemplate. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResponsePlanIncidentTemplate.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResponsePlanIncidentTemplate.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 impact: int,
                 title: str,
                 dedupe_string: Optional[str] = None,
                 incident_tags: Optional[Mapping[str, str]] = None,
                 notification_targets: Optional[Sequence['outputs.ResponsePlanIncidentTemplateNotificationTarget']] = None,
                 summary: Optional[str] = None):
        """
        :param int impact: The impact value of a generated incident. The following values are supported:
        :param str title: The title of a generated incident.
        :param str dedupe_string: A string used to stop Incident Manager from creating multiple incident records for the same incident.
        :param Mapping[str, str] incident_tags: The tags assigned to an incident template. When an incident starts, Incident Manager assigns the tags specified in the template to the incident.
        :param Sequence['ResponsePlanIncidentTemplateNotificationTargetArgs'] notification_targets: The Amazon Simple Notification Service (Amazon SNS) targets that this incident notifies when it is updated. The `notification_target` configuration block supports the following argument:
        :param str summary: The summary of an incident.
        """
        ResponsePlanIncidentTemplate._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            impact=impact,
            title=title,
            dedupe_string=dedupe_string,
            incident_tags=incident_tags,
            notification_targets=notification_targets,
            summary=summary,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             impact: Optional[int] = None,
             title: Optional[str] = None,
             dedupe_string: Optional[str] = None,
             incident_tags: Optional[Mapping[str, str]] = None,
             notification_targets: Optional[Sequence['outputs.ResponsePlanIncidentTemplateNotificationTarget']] = None,
             summary: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if impact is None:
            raise TypeError("Missing 'impact' argument")
        if title is None:
            raise TypeError("Missing 'title' argument")
        if dedupe_string is None and 'dedupeString' in kwargs:
            dedupe_string = kwargs['dedupeString']
        if incident_tags is None and 'incidentTags' in kwargs:
            incident_tags = kwargs['incidentTags']
        if notification_targets is None and 'notificationTargets' in kwargs:
            notification_targets = kwargs['notificationTargets']

        _setter("impact", impact)
        _setter("title", title)
        if dedupe_string is not None:
            _setter("dedupe_string", dedupe_string)
        if incident_tags is not None:
            _setter("incident_tags", incident_tags)
        if notification_targets is not None:
            _setter("notification_targets", notification_targets)
        if summary is not None:
            _setter("summary", summary)

    @property
    @pulumi.getter
    def impact(self) -> int:
        """
        The impact value of a generated incident. The following values are supported:
        """
        return pulumi.get(self, "impact")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        The title of a generated incident.
        """
        return pulumi.get(self, "title")

    @property
    @pulumi.getter(name="dedupeString")
    def dedupe_string(self) -> Optional[str]:
        """
        A string used to stop Incident Manager from creating multiple incident records for the same incident.
        """
        return pulumi.get(self, "dedupe_string")

    @property
    @pulumi.getter(name="incidentTags")
    def incident_tags(self) -> Optional[Mapping[str, str]]:
        """
        The tags assigned to an incident template. When an incident starts, Incident Manager assigns the tags specified in the template to the incident.
        """
        return pulumi.get(self, "incident_tags")

    @property
    @pulumi.getter(name="notificationTargets")
    def notification_targets(self) -> Optional[Sequence['outputs.ResponsePlanIncidentTemplateNotificationTarget']]:
        """
        The Amazon Simple Notification Service (Amazon SNS) targets that this incident notifies when it is updated. The `notification_target` configuration block supports the following argument:
        """
        return pulumi.get(self, "notification_targets")

    @property
    @pulumi.getter
    def summary(self) -> Optional[str]:
        """
        The summary of an incident.
        """
        return pulumi.get(self, "summary")


@pulumi.output_type
class ResponsePlanIncidentTemplateNotificationTarget(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "snsTopicArn":
            suggest = "sns_topic_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResponsePlanIncidentTemplateNotificationTarget. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResponsePlanIncidentTemplateNotificationTarget.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResponsePlanIncidentTemplateNotificationTarget.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 sns_topic_arn: str):
        """
        :param str sns_topic_arn: The ARN of the Amazon SNS topic.
               
               The following arguments are optional:
        """
        ResponsePlanIncidentTemplateNotificationTarget._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            sns_topic_arn=sns_topic_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             sns_topic_arn: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if sns_topic_arn is None and 'snsTopicArn' in kwargs:
            sns_topic_arn = kwargs['snsTopicArn']
        if sns_topic_arn is None:
            raise TypeError("Missing 'sns_topic_arn' argument")

        _setter("sns_topic_arn", sns_topic_arn)

    @property
    @pulumi.getter(name="snsTopicArn")
    def sns_topic_arn(self) -> str:
        """
        The ARN of the Amazon SNS topic.

        The following arguments are optional:
        """
        return pulumi.get(self, "sns_topic_arn")


@pulumi.output_type
class ResponsePlanIntegration(dict):
    def __init__(__self__, *,
                 pagerduties: Optional[Sequence['outputs.ResponsePlanIntegrationPagerduty']] = None):
        """
        :param Sequence['ResponsePlanIntegrationPagerdutyArgs'] pagerduties: Details about the PagerDuty configuration for a response plan. The following values are supported:
        """
        ResponsePlanIntegration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            pagerduties=pagerduties,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             pagerduties: Optional[Sequence['outputs.ResponsePlanIntegrationPagerduty']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):

        if pagerduties is not None:
            _setter("pagerduties", pagerduties)

    @property
    @pulumi.getter
    def pagerduties(self) -> Optional[Sequence['outputs.ResponsePlanIntegrationPagerduty']]:
        """
        Details about the PagerDuty configuration for a response plan. The following values are supported:
        """
        return pulumi.get(self, "pagerduties")


@pulumi.output_type
class ResponsePlanIntegrationPagerduty(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "secretId":
            suggest = "secret_id"
        elif key == "serviceId":
            suggest = "service_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResponsePlanIntegrationPagerduty. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResponsePlanIntegrationPagerduty.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResponsePlanIntegrationPagerduty.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: str,
                 secret_id: str,
                 service_id: str):
        """
        :param str name: The name of the response plan.
        :param str secret_id: The ID of the AWS Secrets Manager secret that stores your PagerDuty key &mdash; either a General Access REST API Key or User Token REST API Key &mdash; and other user credentials.
               
               For more information about the constraints for each field, see [CreateResponsePlan](https://docs.aws.amazon.com/incident-manager/latest/APIReference/API_CreateResponsePlan.html) in the *AWS Systems Manager Incident Manager API Reference*.
        :param str service_id: The ID of the PagerDuty service that the response plan associated with the incident at launch.
        """
        ResponsePlanIntegrationPagerduty._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            secret_id=secret_id,
            service_id=service_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             secret_id: Optional[str] = None,
             service_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if secret_id is None and 'secretId' in kwargs:
            secret_id = kwargs['secretId']
        if secret_id is None:
            raise TypeError("Missing 'secret_id' argument")
        if service_id is None and 'serviceId' in kwargs:
            service_id = kwargs['serviceId']
        if service_id is None:
            raise TypeError("Missing 'service_id' argument")

        _setter("name", name)
        _setter("secret_id", secret_id)
        _setter("service_id", service_id)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the response plan.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="secretId")
    def secret_id(self) -> str:
        """
        The ID of the AWS Secrets Manager secret that stores your PagerDuty key &mdash; either a General Access REST API Key or User Token REST API Key &mdash; and other user credentials.

        For more information about the constraints for each field, see [CreateResponsePlan](https://docs.aws.amazon.com/incident-manager/latest/APIReference/API_CreateResponsePlan.html) in the *AWS Systems Manager Incident Manager API Reference*.
        """
        return pulumi.get(self, "secret_id")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> str:
        """
        The ID of the PagerDuty service that the response plan associated with the incident at launch.
        """
        return pulumi.get(self, "service_id")


@pulumi.output_type
class GetReplicationSetRegionResult(dict):
    def __init__(__self__, *,
                 kms_key_arn: str,
                 name: str,
                 status: str,
                 status_message: str):
        """
        :param str kms_key_arn: The ARN of the AWS Key Management Service (AWS KMS) encryption key.
        :param str name: The name of the Region.
        :param str status: The current status of the Region.
               * Valid Values: `ACTIVE` | `CREATING` | `UPDATING` | `DELETING` | `FAILED`
        :param str status_message: More information about the status of a Region.
        """
        GetReplicationSetRegionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            kms_key_arn=kms_key_arn,
            name=name,
            status=status,
            status_message=status_message,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             kms_key_arn: Optional[str] = None,
             name: Optional[str] = None,
             status: Optional[str] = None,
             status_message: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if kms_key_arn is None and 'kmsKeyArn' in kwargs:
            kms_key_arn = kwargs['kmsKeyArn']
        if kms_key_arn is None:
            raise TypeError("Missing 'kms_key_arn' argument")
        if name is None:
            raise TypeError("Missing 'name' argument")
        if status is None:
            raise TypeError("Missing 'status' argument")
        if status_message is None and 'statusMessage' in kwargs:
            status_message = kwargs['statusMessage']
        if status_message is None:
            raise TypeError("Missing 'status_message' argument")

        _setter("kms_key_arn", kms_key_arn)
        _setter("name", name)
        _setter("status", status)
        _setter("status_message", status_message)

    @property
    @pulumi.getter(name="kmsKeyArn")
    def kms_key_arn(self) -> str:
        """
        The ARN of the AWS Key Management Service (AWS KMS) encryption key.
        """
        return pulumi.get(self, "kms_key_arn")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Region.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The current status of the Region.
        * Valid Values: `ACTIVE` | `CREATING` | `UPDATING` | `DELETING` | `FAILED`
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="statusMessage")
    def status_message(self) -> str:
        """
        More information about the status of a Region.
        """
        return pulumi.get(self, "status_message")


@pulumi.output_type
class GetResponsePlanActionResult(dict):
    def __init__(__self__, *,
                 ssm_automations: Sequence['outputs.GetResponsePlanActionSsmAutomationResult']):
        """
        :param Sequence['GetResponsePlanActionSsmAutomationArgs'] ssm_automations: The Systems Manager automation document to start as the runbook at the beginning of the incident. The following values are supported:
        """
        GetResponsePlanActionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ssm_automations=ssm_automations,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ssm_automations: Optional[Sequence['outputs.GetResponsePlanActionSsmAutomationResult']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if ssm_automations is None and 'ssmAutomations' in kwargs:
            ssm_automations = kwargs['ssmAutomations']
        if ssm_automations is None:
            raise TypeError("Missing 'ssm_automations' argument")

        _setter("ssm_automations", ssm_automations)

    @property
    @pulumi.getter(name="ssmAutomations")
    def ssm_automations(self) -> Sequence['outputs.GetResponsePlanActionSsmAutomationResult']:
        """
        The Systems Manager automation document to start as the runbook at the beginning of the incident. The following values are supported:
        """
        return pulumi.get(self, "ssm_automations")


@pulumi.output_type
class GetResponsePlanActionSsmAutomationResult(dict):
    def __init__(__self__, *,
                 document_name: str,
                 document_version: str,
                 dynamic_parameters: Mapping[str, str],
                 parameters: Sequence['outputs.GetResponsePlanActionSsmAutomationParameterResult'],
                 role_arn: str,
                 target_account: str):
        """
        :param str document_name: The automation document's name.
        :param str document_version: The version of the automation document to use at runtime.
        :param Mapping[str, str] dynamic_parameters: The key-value pair used to resolve dynamic parameter values when processing a Systems Manager Automation runbook.
        :param Sequence['GetResponsePlanActionSsmAutomationParameterArgs'] parameters: The key-value pair parameters used when the automation document runs. The following values are supported:
        :param str role_arn: The Amazon Resource Name (ARN) of the role that the automation document assumes when it runs commands.
        :param str target_account: The account that runs the automation document. This can be in either the management account or an application account.
        """
        GetResponsePlanActionSsmAutomationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            document_name=document_name,
            document_version=document_version,
            dynamic_parameters=dynamic_parameters,
            parameters=parameters,
            role_arn=role_arn,
            target_account=target_account,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             document_name: Optional[str] = None,
             document_version: Optional[str] = None,
             dynamic_parameters: Optional[Mapping[str, str]] = None,
             parameters: Optional[Sequence['outputs.GetResponsePlanActionSsmAutomationParameterResult']] = None,
             role_arn: Optional[str] = None,
             target_account: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if document_name is None and 'documentName' in kwargs:
            document_name = kwargs['documentName']
        if document_name is None:
            raise TypeError("Missing 'document_name' argument")
        if document_version is None and 'documentVersion' in kwargs:
            document_version = kwargs['documentVersion']
        if document_version is None:
            raise TypeError("Missing 'document_version' argument")
        if dynamic_parameters is None and 'dynamicParameters' in kwargs:
            dynamic_parameters = kwargs['dynamicParameters']
        if dynamic_parameters is None:
            raise TypeError("Missing 'dynamic_parameters' argument")
        if parameters is None:
            raise TypeError("Missing 'parameters' argument")
        if role_arn is None and 'roleArn' in kwargs:
            role_arn = kwargs['roleArn']
        if role_arn is None:
            raise TypeError("Missing 'role_arn' argument")
        if target_account is None and 'targetAccount' in kwargs:
            target_account = kwargs['targetAccount']
        if target_account is None:
            raise TypeError("Missing 'target_account' argument")

        _setter("document_name", document_name)
        _setter("document_version", document_version)
        _setter("dynamic_parameters", dynamic_parameters)
        _setter("parameters", parameters)
        _setter("role_arn", role_arn)
        _setter("target_account", target_account)

    @property
    @pulumi.getter(name="documentName")
    def document_name(self) -> str:
        """
        The automation document's name.
        """
        return pulumi.get(self, "document_name")

    @property
    @pulumi.getter(name="documentVersion")
    def document_version(self) -> str:
        """
        The version of the automation document to use at runtime.
        """
        return pulumi.get(self, "document_version")

    @property
    @pulumi.getter(name="dynamicParameters")
    def dynamic_parameters(self) -> Mapping[str, str]:
        """
        The key-value pair used to resolve dynamic parameter values when processing a Systems Manager Automation runbook.
        """
        return pulumi.get(self, "dynamic_parameters")

    @property
    @pulumi.getter
    def parameters(self) -> Sequence['outputs.GetResponsePlanActionSsmAutomationParameterResult']:
        """
        The key-value pair parameters used when the automation document runs. The following values are supported:
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> str:
        """
        The Amazon Resource Name (ARN) of the role that the automation document assumes when it runs commands.
        """
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter(name="targetAccount")
    def target_account(self) -> str:
        """
        The account that runs the automation document. This can be in either the management account or an application account.
        """
        return pulumi.get(self, "target_account")


@pulumi.output_type
class GetResponsePlanActionSsmAutomationParameterResult(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Sequence[str]):
        """
        :param str name: The name of the PagerDuty configuration.
        :param Sequence[str] values: The values for the associated parameter name.
        """
        GetResponsePlanActionSsmAutomationParameterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            values=values,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             values: Optional[Sequence[str]] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if values is None:
            raise TypeError("Missing 'values' argument")

        _setter("name", name)
        _setter("values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the PagerDuty configuration.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        The values for the associated parameter name.
        """
        return pulumi.get(self, "values")


@pulumi.output_type
class GetResponsePlanIncidentTemplateResult(dict):
    def __init__(__self__, *,
                 dedupe_string: str,
                 impact: int,
                 incident_tags: Mapping[str, str],
                 notification_targets: Sequence['outputs.GetResponsePlanIncidentTemplateNotificationTargetResult'],
                 summary: str,
                 title: str):
        """
        :param str dedupe_string: A string used to stop Incident Manager from creating multiple incident records for the same incident.
        :param int impact: The impact value of a generated incident. The following values are supported:
        :param Mapping[str, str] incident_tags: The tags assigned to an incident template. When an incident starts, Incident Manager assigns the tags specified in the template to the incident.
        :param Sequence['GetResponsePlanIncidentTemplateNotificationTargetArgs'] notification_targets: The Amazon Simple Notification Service (Amazon SNS) targets that this incident notifies when it is updated. The `notification_target` configuration block supports the following argument:
        :param str summary: The summary of an incident.
        :param str title: The title of a generated incident.
        """
        GetResponsePlanIncidentTemplateResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            dedupe_string=dedupe_string,
            impact=impact,
            incident_tags=incident_tags,
            notification_targets=notification_targets,
            summary=summary,
            title=title,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             dedupe_string: Optional[str] = None,
             impact: Optional[int] = None,
             incident_tags: Optional[Mapping[str, str]] = None,
             notification_targets: Optional[Sequence['outputs.GetResponsePlanIncidentTemplateNotificationTargetResult']] = None,
             summary: Optional[str] = None,
             title: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if dedupe_string is None and 'dedupeString' in kwargs:
            dedupe_string = kwargs['dedupeString']
        if dedupe_string is None:
            raise TypeError("Missing 'dedupe_string' argument")
        if impact is None:
            raise TypeError("Missing 'impact' argument")
        if incident_tags is None and 'incidentTags' in kwargs:
            incident_tags = kwargs['incidentTags']
        if incident_tags is None:
            raise TypeError("Missing 'incident_tags' argument")
        if notification_targets is None and 'notificationTargets' in kwargs:
            notification_targets = kwargs['notificationTargets']
        if notification_targets is None:
            raise TypeError("Missing 'notification_targets' argument")
        if summary is None:
            raise TypeError("Missing 'summary' argument")
        if title is None:
            raise TypeError("Missing 'title' argument")

        _setter("dedupe_string", dedupe_string)
        _setter("impact", impact)
        _setter("incident_tags", incident_tags)
        _setter("notification_targets", notification_targets)
        _setter("summary", summary)
        _setter("title", title)

    @property
    @pulumi.getter(name="dedupeString")
    def dedupe_string(self) -> str:
        """
        A string used to stop Incident Manager from creating multiple incident records for the same incident.
        """
        return pulumi.get(self, "dedupe_string")

    @property
    @pulumi.getter
    def impact(self) -> int:
        """
        The impact value of a generated incident. The following values are supported:
        """
        return pulumi.get(self, "impact")

    @property
    @pulumi.getter(name="incidentTags")
    def incident_tags(self) -> Mapping[str, str]:
        """
        The tags assigned to an incident template. When an incident starts, Incident Manager assigns the tags specified in the template to the incident.
        """
        return pulumi.get(self, "incident_tags")

    @property
    @pulumi.getter(name="notificationTargets")
    def notification_targets(self) -> Sequence['outputs.GetResponsePlanIncidentTemplateNotificationTargetResult']:
        """
        The Amazon Simple Notification Service (Amazon SNS) targets that this incident notifies when it is updated. The `notification_target` configuration block supports the following argument:
        """
        return pulumi.get(self, "notification_targets")

    @property
    @pulumi.getter
    def summary(self) -> str:
        """
        The summary of an incident.
        """
        return pulumi.get(self, "summary")

    @property
    @pulumi.getter
    def title(self) -> str:
        """
        The title of a generated incident.
        """
        return pulumi.get(self, "title")


@pulumi.output_type
class GetResponsePlanIncidentTemplateNotificationTargetResult(dict):
    def __init__(__self__, *,
                 sns_topic_arn: str):
        """
        :param str sns_topic_arn: The ARN of the Amazon SNS topic.
        """
        GetResponsePlanIncidentTemplateNotificationTargetResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            sns_topic_arn=sns_topic_arn,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             sns_topic_arn: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if sns_topic_arn is None and 'snsTopicArn' in kwargs:
            sns_topic_arn = kwargs['snsTopicArn']
        if sns_topic_arn is None:
            raise TypeError("Missing 'sns_topic_arn' argument")

        _setter("sns_topic_arn", sns_topic_arn)

    @property
    @pulumi.getter(name="snsTopicArn")
    def sns_topic_arn(self) -> str:
        """
        The ARN of the Amazon SNS topic.
        """
        return pulumi.get(self, "sns_topic_arn")


@pulumi.output_type
class GetResponsePlanIntegrationResult(dict):
    def __init__(__self__, *,
                 pagerduties: Sequence['outputs.GetResponsePlanIntegrationPagerdutyResult']):
        """
        :param Sequence['GetResponsePlanIntegrationPagerdutyArgs'] pagerduties: Details about the PagerDuty configuration for a response plan. The following values are supported:
        """
        GetResponsePlanIntegrationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            pagerduties=pagerduties,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             pagerduties: Optional[Sequence['outputs.GetResponsePlanIntegrationPagerdutyResult']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if pagerduties is None:
            raise TypeError("Missing 'pagerduties' argument")

        _setter("pagerduties", pagerduties)

    @property
    @pulumi.getter
    def pagerduties(self) -> Sequence['outputs.GetResponsePlanIntegrationPagerdutyResult']:
        """
        Details about the PagerDuty configuration for a response plan. The following values are supported:
        """
        return pulumi.get(self, "pagerduties")


@pulumi.output_type
class GetResponsePlanIntegrationPagerdutyResult(dict):
    def __init__(__self__, *,
                 name: str,
                 secret_id: str,
                 service_id: str):
        """
        :param str name: The name of the PagerDuty configuration.
        :param str secret_id: The ID of the AWS Secrets Manager secret that stores your PagerDuty key &mdash; either a General Access REST API Key or User Token REST API Key &mdash; and other user credentials.
        :param str service_id: The ID of the PagerDuty service that the response plan associates with an incident when it launches.
        """
        GetResponsePlanIntegrationPagerdutyResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            secret_id=secret_id,
            service_id=service_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             secret_id: Optional[str] = None,
             service_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if secret_id is None and 'secretId' in kwargs:
            secret_id = kwargs['secretId']
        if secret_id is None:
            raise TypeError("Missing 'secret_id' argument")
        if service_id is None and 'serviceId' in kwargs:
            service_id = kwargs['serviceId']
        if service_id is None:
            raise TypeError("Missing 'service_id' argument")

        _setter("name", name)
        _setter("secret_id", secret_id)
        _setter("service_id", service_id)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the PagerDuty configuration.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="secretId")
    def secret_id(self) -> str:
        """
        The ID of the AWS Secrets Manager secret that stores your PagerDuty key &mdash; either a General Access REST API Key or User Token REST API Key &mdash; and other user credentials.
        """
        return pulumi.get(self, "secret_id")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> str:
        """
        The ID of the PagerDuty service that the response plan associates with an incident when it launches.
        """
        return pulumi.get(self, "service_id")


